/**
 * @license
 * Copyright 2023 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{})}(this,(function(e){"use strict";function t(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var r=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,r.get?r:{enumerable:!0,get:function(){return t[n]}})}}))})),e}class n{refCount(e){return r("refCount")}incRef(e){return r("incRef")}timerAvailable(){return!0}time(e){return r("time")}read(e){return r("read")}readSync(e){return r("readSync")}readToGPU(e,t){return r("readToGPU")}numDataIds(){return r("numDataIds")}disposeData(e,t){return r("disposeData")}write(e,t,n){return r("write")}move(e,t,n,s,o){return r("move")}createTensorFromGPUData(e,t,n){return r("createTensorFromGPUData")}memory(){return r("memory")}floatPrecision(){return r("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}dispose(){return r("dispose")}}function r(e){throw new Error(`'${e}' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen`)}function s(e){let t=e.length,n=0;for(;t>0;)n=Math.random()*t|0,t--,a(e,t,n)}function o(e,t,n){return Math.max(e,Math.min(t,n))}function a(e,t,n){const r=e[t];e[t]=e[n],e[n]=r}function i(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function l(e,t,n=""){i(h(e,t),(()=>n+` Shapes ${e} and ${t} must match`))}function u(e){i(null!=e,(()=>"The input to the tensor constructor must be a non-null value."))}function c(e){if(0===e.length)return 1;let t=e[0];for(let n=1;n<e.length;n++)t*=e[n];return t}function h(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function d(e){return e%1==0}function p(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function f(e,t){const n=t.length;return i((e=null==e?t.map(((e,t)=>t)):[].concat(e)).every((e=>e>=-n&&e<n)),(()=>`All values in axis param must be in range [-${n}, ${n}) but got axis ${e}`)),i(e.every((e=>d(e))),(()=>`All values in axis param must be integers but got axis ${e}`)),e.map((e=>e<0?n+e:e))}function g(e,t){const n=[],r=[],s=null!=t&&Array.isArray(t)&&0===t.length,o=null==t||s?null:f(t,e).sort();let a=0;for(let t=0;t<e.length;++t){if(null!=o){if(o[a]===t&&1!==e[t])throw new Error(`Can't squeeze axis ${t} since its dim '${e[t]}' is not 1`);(null==o[a]||o[a]>t)&&1===e[t]&&(n.push(e[t]),r.push(t)),o[a]<=t&&a++}1!==e[t]&&(n.push(e[t]),r.push(t))}return{newShape:n,keptDims:r}}function m(e,t){return b(e,t)}function b(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error(`Unknown data type ${e}`);n=new Array(t)}return n}function y(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(isNaN(r)||!isFinite(r))throw Error(`A tensor of type ${t} being uploaded contains ${r}.`)}}function w(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}function k(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error(`Unknown dtype ${e}`)}function v(e){if(null==e)return 0;let t=0;return e.forEach((e=>t+=e.length)),t}function x(e){return"string"==typeof e||e instanceof String}function E(e){return"boolean"==typeof e}function S(e){return"number"==typeof e}function $(e){return Array.isArray(e)?$(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray?"int32":S(e)?"float32":x(e)?"string":E(e)?"bool":"float32"}function A(e){return!!(e&&e.constructor&&e.call&&e.apply)}function _(e,t){for(let n=t;n<e;++n)if(e%n==0)return n;return e}function I(e){const t=e.length;if(t<2)return[];const n=new Array(t-1);n[t-2]=e[t-1];for(let r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function N(e,t,n,r=!1){const s=new Array;if(1===t.length){const o=t[0]*(r?2:1);for(let t=0;t<o;t++)s[t]=n[e+t]}else{const o=t[0],a=t.slice(1),i=a.reduce(((e,t)=>e*t))*(r?2:1);for(let t=0;t<o;t++)s[t]=N(e+t*i,a,n,r)}return s}function M(e,t,n=!1){if(0===e.length)return t[0];const r=e.reduce(((e,t)=>e*t))*(n?2:1);if(0===r)return[];if(r!==t.length)throw new Error(`[${e}] does not match the input size ${t.length}${n?" for a complex tensor":""}.`);return N(0,e,t,n)}function T(e,t){const n=D(e,t);for(let e=0;e<n.length;e++)n[e]=1;return n}function D(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error(`Unknown data type ${t}`)}function R(e){e.forEach((t=>{i(Number.isInteger(t)&&t>=0,(()=>`Tensor must have a shape comprised of positive integers but got shape [${e}].`))}))}function F(e){return e&&e.then&&"function"==typeof e.then}const B="tfjsflags";class C{constructor(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=P,this.populateURLFlags()}setPlatform(e,t){null!=this.platform&&(O().getBool("IS_TEST")||O().getBool("PROD")||console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${e}.`)),this.platformName=e,this.platform=t}registerFlag(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){const t=this.urlFlags[e];O().getBool("IS_TEST")||O().getBool("PROD")||console.warn(`Setting feature override from URL ${e}: ${t}.`),this.set(e,t)}}async getAsync(e){return e in this.flags||(this.flags[e]=await this.evaluateFlag(e)),this.flags[e]}get(e){if(e in this.flags)return this.flags[e];const t=this.evaluateFlag(e);if(F(t))throw new Error(`Flag ${e} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[e]=t,this.flags[e]}getNumber(e){return this.get(e)}getBool(e){return this.get(e)}getFlags(){return this.flags}get features(){return this.flags}set(e,t){if(null==this.flagRegistry[e])throw new Error(`Cannot set flag ${e} as it has not been registered.`);this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)}evaluateFlag(e){if(null==this.flagRegistry[e])throw new Error(`Cannot evaluate flag '${e}': no evaluation function found.`);return this.flagRegistry[e].evaluationFn()}setFlags(e){this.flags=Object.assign({},e)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if("undefined"==typeof this.global||"undefined"==typeof this.global.location||"undefined"==typeof this.global.location.search)return;const e=this.getQueryParams(this.global.location.search);if(B in e){e.tfjsflags.split(",").forEach((e=>{const[t,n]=e.split(":");this.urlFlags[t]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if(""+ +t===t)return+t;throw new Error(`Could not parse value flag value ${t} for flag ${e}.`)}(t,n)}))}}}function P(e){const t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,((e,...n)=>(function(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}(t,n[0],n[1]),n.join("=")))),t}function O(){return e.ENV}let L;function z(){if(null==L){let e;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}L=e}return L}function W(e,t){const n=function(){const e=z();return null==e._tfGlobals&&(e._tfGlobals=new Map),e._tfGlobals}();if(n.has(e))return n.get(e);{const r=t();return n.set(e,r),n.get(e)}}e.ENV=null;const U="Acos",G="Acosh",K="Add",q="AddN",V="ArgMax",H="ArgMin",j="Asin",Z="Asinh",J="Atan",Y="Atanh",X="Atan2",Q="AvgPool",ee="AvgPool3D",te="BatchMatMul",ne="BatchToSpaceND",re="Bincount",se="BroadcastArgs",oe="Cast",ae="Ceil",ie="ClipByValue",le="Complex",ue="ComplexAbs",ce="Concat",he="Conv2D",de="Conv2DBackpropFilter",pe="Conv2DBackpropInput",fe="Conv3D",ge="Conv3DBackpropInputV2",me="Cosh",be="Cumprod",ye="Cumsum",we="CropAndResize",ke="DenseBincount",ve="DepthToSpace",xe="DepthwiseConv2dNative",Ee="DepthwiseConv2dNativeBackpropFilter",Se="DepthwiseConv2dNativeBackpropInput",$e="Diag",Ae="Dilation2D",_e="RealDiv",Ie="Einsum",Ne="Equal",Me="ExpandDims",Te="Expm1",De="Fill",Re="FlipLeftRight",Fe="Floor",Be="FloorDiv",Ce="FusedBatchNorm",Pe="GatherV2",Oe="GatherNd",Le="Greater",ze="GreaterEqual",We="Identity",Ue="IFFT",Ge="Imag",Ke="IsFinite",qe="IsInf",Ve="IsNan",He="LeakyRelu",je="Less",Ze="LessEqual",Je="LinSpace",Ye="Log1p",Xe="LogicalAnd",Qe="LogicalNot",et="LogicalOr",tt="Maximum",nt="MaxPool",rt="MaxPool3D",st="MaxPoolWithArgmax",ot="Mean",at="Minimum",it="MirrorPad",lt="Multinomial",ut="Multiply",ct="NotEqual",ht="NonMaxSuppressionV3",dt="NonMaxSuppressionV4",pt="NonMaxSuppressionV5",ft="OnesLike",gt="OneHot",mt="Pack",bt="PadV2",yt="Prelu",wt="Prod",kt="RaggedGather",vt="RaggedRange",xt="RaggedTensorToTensor",Et="Range",St="Real",$t="Reciprocal",At="Relu",_t="Reshape",It="ResizeNearestNeighbor",Nt="ResizeBilinear",Mt="Relu6",Tt="Reverse",Dt="Round",Rt="Rsqrt",Ft="ScatterNd",Bt="TensorScatterUpdate",Ct="SearchSorted",Pt="Select",Ot="Selu",Lt="Slice",zt="Sinh",Wt="Sign",Ut="Sigmoid",Gt="Softplus",Kt="Sqrt",qt="SpaceToBatchND",Vt="SplitV",Ht="Softmax",jt="SparseFillEmptyRows",Zt="SparseReshape",Jt="SparseSegmentMean",Yt="SparseSegmentSum",Xt="SparseToDense",Qt="SquaredDifference",en="StaticRegexReplace",tn="StridedSlice",nn="StringNGrams",rn="StringSplit",sn="StringToHashBucketFast",on="Tanh",an="Tile",ln="TopK",un="Transform",cn="Transpose",hn="Unique",dn="Unpack",pn="UnsortedSegmentSum",fn="ZerosLike",gn="Step",mn="FromPixels",bn="RotateWithOffset",yn="_FusedMatMul",wn="FusedConv2D",kn="FusedDepthwiseConv2D";function vn(...e){O().getBool("IS_TEST")||O().getBool("PROD")||console.warn(...e)}const xn=W("kernelRegistry",(()=>new Map)),En=W("gradRegistry",(()=>new Map));function Sn(e,t){const n=In(e,t);return xn.get(n)}function $n(e){return En.get(e)}function An(e){const t=xn.entries(),n=[];for(;;){const{done:r,value:s}=t.next();if(r)break;const[o,a]=s,[i]=o.split("_");i===e&&n.push(a)}return n}function _n(e){const{kernelName:t,backendName:n}=e,r=In(t,n);xn.has(r)&&vn(`The kernel '${t}' for backend '${n}' is already registered`),xn.set(r,e)}function In(e,t){return`${t}_${e}`}var Nn=Tn,Mn=null;try{Mn=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(e){}function Tn(e,t,n){this.low=0|e,this.high=0|t,this.unsigned=!!n}function Dn(e){return!0===(e&&e.__isLong__)}Tn.prototype.__isLong__,Object.defineProperty(Tn.prototype,"__isLong__",{value:!0}),Tn.isLong=Dn;var Rn={},Fn={};function Bn(e,t){var n,r,s;return t?(s=0<=(e>>>=0)&&e<256)&&(r=Fn[e])?r:(n=Pn(e,(0|e)<0?-1:0,!0),s&&(Fn[e]=n),n):(s=-128<=(e|=0)&&e<128)&&(r=Rn[e])?r:(n=Pn(e,e<0?-1:0,!1),s&&(Rn[e]=n),n)}function Cn(e,t){if(isNaN(e))return t?Vn:qn;if(t){if(e<0)return Vn;if(e>=Un)return Yn}else{if(e<=-Gn)return Xn;if(e+1>=Gn)return Jn}return e<0?Cn(-e,t).neg():Pn(e%Wn|0,e/Wn|0,t)}function Pn(e,t,n){return new Tn(e,t,n)}Tn.fromInt=Bn,Tn.fromNumber=Cn,Tn.fromBits=Pn;var On=Math.pow;function Ln(e,t,n){if(0===e.length)throw Error("empty string");if("NaN"===e||"Infinity"===e||"+Infinity"===e||"-Infinity"===e)return qn;if("number"==typeof t?(n=t,t=!1):t=!!t,(n=n||10)<2||36<n)throw RangeError("radix");var r;if((r=e.indexOf("-"))>0)throw Error("interior hyphen");if(0===r)return Ln(e.substring(1),t,n).neg();for(var s=Cn(On(n,8)),o=qn,a=0;a<e.length;a+=8){var i=Math.min(8,e.length-a),l=parseInt(e.substring(a,a+i),n);if(i<8){var u=Cn(On(n,i));o=o.mul(u).add(Cn(l))}else o=(o=o.mul(s)).add(Cn(l))}return o.unsigned=t,o}function zn(e,t){return"number"==typeof e?Cn(e,t):"string"==typeof e?Ln(e,t):Pn(e.low,e.high,"boolean"==typeof t?t:e.unsigned)}Tn.fromString=Ln,Tn.fromValue=zn;var Wn=4294967296,Un=Wn*Wn,Gn=Un/2,Kn=Bn(1<<24),qn=Bn(0);Tn.ZERO=qn;var Vn=Bn(0,!0);Tn.UZERO=Vn;var Hn=Bn(1);Tn.ONE=Hn;var jn=Bn(1,!0);Tn.UONE=jn;var Zn=Bn(-1);Tn.NEG_ONE=Zn;var Jn=Pn(-1,2147483647,!1);Tn.MAX_VALUE=Jn;var Yn=Pn(-1,-1,!0);Tn.MAX_UNSIGNED_VALUE=Yn;var Xn=Pn(0,-2147483648,!1);Tn.MIN_VALUE=Xn;var Qn=Tn.prototype;Qn.toInt=function(){return this.unsigned?this.low>>>0:this.low},Qn.toNumber=function(){return this.unsigned?(this.high>>>0)*Wn+(this.low>>>0):this.high*Wn+(this.low>>>0)},Qn.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(Xn)){var t=Cn(e),n=this.div(t),r=n.mul(t).sub(this);return n.toString(e)+r.toInt().toString(e)}return"-"+this.neg().toString(e)}for(var s=Cn(On(e,6),this.unsigned),o=this,a="";;){var i=o.div(s),l=(o.sub(i.mul(s)).toInt()>>>0).toString(e);if((o=i).isZero())return l+a;for(;l.length<6;)l="0"+l;a=""+l+a}},Qn.getHighBits=function(){return this.high},Qn.getHighBitsUnsigned=function(){return this.high>>>0},Qn.getLowBits=function(){return this.low},Qn.getLowBitsUnsigned=function(){return this.low>>>0},Qn.getNumBitsAbs=function(){if(this.isNegative())return this.eq(Xn)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;t>0&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},Qn.isZero=function(){return 0===this.high&&0===this.low},Qn.eqz=Qn.isZero,Qn.isNegative=function(){return!this.unsigned&&this.high<0},Qn.isPositive=function(){return this.unsigned||this.high>=0},Qn.isOdd=function(){return 1==(1&this.low)},Qn.isEven=function(){return 0==(1&this.low)},Qn.equals=function(e){return Dn(e)||(e=zn(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&(this.high===e.high&&this.low===e.low)},Qn.eq=Qn.equals,Qn.notEquals=function(e){return!this.eq(e)},Qn.neq=Qn.notEquals,Qn.ne=Qn.notEquals,Qn.lessThan=function(e){return this.comp(e)<0},Qn.lt=Qn.lessThan,Qn.lessThanOrEqual=function(e){return this.comp(e)<=0},Qn.lte=Qn.lessThanOrEqual,Qn.le=Qn.lessThanOrEqual,Qn.greaterThan=function(e){return this.comp(e)>0},Qn.gt=Qn.greaterThan,Qn.greaterThanOrEqual=function(e){return this.comp(e)>=0},Qn.gte=Qn.greaterThanOrEqual,Qn.ge=Qn.greaterThanOrEqual,Qn.compare=function(e){if(Dn(e)||(e=zn(e)),this.eq(e))return 0;var t=this.isNegative(),n=e.isNegative();return t&&!n?-1:!t&&n?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},Qn.comp=Qn.compare,Qn.negate=function(){return!this.unsigned&&this.eq(Xn)?Xn:this.not().add(Hn)},Qn.neg=Qn.negate,Qn.add=function(e){Dn(e)||(e=zn(e));var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,s=65535&this.low,o=e.high>>>16,a=65535&e.high,i=e.low>>>16,l=0,u=0,c=0,h=0;return c+=(h+=s+(65535&e.low))>>>16,u+=(c+=r+i)>>>16,l+=(u+=n+a)>>>16,l+=t+o,Pn((c&=65535)<<16|(h&=65535),(l&=65535)<<16|(u&=65535),this.unsigned)},Qn.subtract=function(e){return Dn(e)||(e=zn(e)),this.add(e.neg())},Qn.sub=Qn.subtract,Qn.multiply=function(e){if(this.isZero())return qn;if(Dn(e)||(e=zn(e)),Mn)return Pn(Mn.mul(this.low,this.high,e.low,e.high),Mn.get_high(),this.unsigned);if(e.isZero())return qn;if(this.eq(Xn))return e.isOdd()?Xn:qn;if(e.eq(Xn))return this.isOdd()?Xn:qn;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(Kn)&&e.lt(Kn))return Cn(this.toNumber()*e.toNumber(),this.unsigned);var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,s=65535&this.low,o=e.high>>>16,a=65535&e.high,i=e.low>>>16,l=65535&e.low,u=0,c=0,h=0,d=0;return h+=(d+=s*l)>>>16,c+=(h+=r*l)>>>16,h&=65535,c+=(h+=s*i)>>>16,u+=(c+=n*l)>>>16,c&=65535,u+=(c+=r*i)>>>16,c&=65535,u+=(c+=s*a)>>>16,u+=t*l+n*i+r*a+s*o,Pn((h&=65535)<<16|(d&=65535),(u&=65535)<<16|(c&=65535),this.unsigned)},Qn.mul=Qn.multiply,Qn.divide=function(e){if(Dn(e)||(e=zn(e)),e.isZero())throw Error("division by zero");var t,n,r;if(Mn)return this.unsigned||-2147483648!==this.high||-1!==e.low||-1!==e.high?Pn((this.unsigned?Mn.div_u:Mn.div_s)(this.low,this.high,e.low,e.high),Mn.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?Vn:qn;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return Vn;if(e.gt(this.shru(1)))return jn;r=Vn}else{if(this.eq(Xn))return e.eq(Hn)||e.eq(Zn)?Xn:e.eq(Xn)?Hn:(t=this.shr(1).div(e).shl(1)).eq(qn)?e.isNegative()?Hn:Zn:(n=this.sub(e.mul(t)),r=t.add(n.div(e)));if(e.eq(Xn))return this.unsigned?Vn:qn;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();r=qn}for(n=this;n.gte(e);){t=Math.max(1,Math.floor(n.toNumber()/e.toNumber()));for(var s=Math.ceil(Math.log(t)/Math.LN2),o=s<=48?1:On(2,s-48),a=Cn(t),i=a.mul(e);i.isNegative()||i.gt(n);)i=(a=Cn(t-=o,this.unsigned)).mul(e);a.isZero()&&(a=Hn),r=r.add(a),n=n.sub(i)}return r},Qn.div=Qn.divide,Qn.modulo=function(e){return Dn(e)||(e=zn(e)),Mn?Pn((this.unsigned?Mn.rem_u:Mn.rem_s)(this.low,this.high,e.low,e.high),Mn.get_high(),this.unsigned):this.sub(this.div(e).mul(e))},Qn.mod=Qn.modulo,Qn.rem=Qn.modulo,Qn.not=function(){return Pn(~this.low,~this.high,this.unsigned)},Qn.and=function(e){return Dn(e)||(e=zn(e)),Pn(this.low&e.low,this.high&e.high,this.unsigned)},Qn.or=function(e){return Dn(e)||(e=zn(e)),Pn(this.low|e.low,this.high|e.high,this.unsigned)},Qn.xor=function(e){return Dn(e)||(e=zn(e)),Pn(this.low^e.low,this.high^e.high,this.unsigned)},Qn.shiftLeft=function(e){return Dn(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?Pn(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):Pn(0,this.low<<e-32,this.unsigned)},Qn.shl=Qn.shiftLeft,Qn.shiftRight=function(e){return Dn(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?Pn(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):Pn(this.high>>e-32,this.high>=0?0:-1,this.unsigned)},Qn.shr=Qn.shiftRight,Qn.shiftRightUnsigned=function(e){if(Dn(e)&&(e=e.toInt()),0===(e&=63))return this;var t=this.high;return e<32?Pn(this.low>>>e|t<<32-e,t>>>e,this.unsigned):Pn(32===e?t:t>>>e-32,0,this.unsigned)},Qn.shru=Qn.shiftRightUnsigned,Qn.shr_u=Qn.shiftRightUnsigned,Qn.toSigned=function(){return this.unsigned?Pn(this.low,this.high,!1):this},Qn.toUnsigned=function(){return this.unsigned?this:Pn(this.low,this.high,!0)},Qn.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},Qn.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},Qn.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},Tn.fromBytes=function(e,t,n){return n?Tn.fromBytesLE(e,t):Tn.fromBytesBE(e,t)},Tn.fromBytesLE=function(e,t){return new Tn(e[0]|e[1]<<8|e[2]<<16|e[3]<<24,e[4]|e[5]<<8|e[6]<<16|e[7]<<24,t)},Tn.fromBytesBE=function(e,t){return new Tn(e[4]<<24|e[5]<<16|e[6]<<8|e[7],e[0]<<24|e[1]<<16|e[2]<<8|e[3],t)};const er=Nn||t({__proto__:null,default:Nn},[Nn]);function tr(e){return er.fromString(e,!0,16)}const nr=tr("c3a5c85c97cb3127"),rr=tr("b492b66fbe98f273"),sr=tr("9ae16a3b2f90404f");function or(e){return e.xor(e.shru(47))}function ar(e,t,n){const r=e.slice(t,t+n);return er.fromBytes(Array.from(r),!0,!0)}function ir(e,t){return ar(e,t,8)}function lr(e,t){return ar(e,t,4)}function ur(e,t){return 0===t?e:e.shru(t).or(e.shl(64-t))}function cr(e,t,n=tr("9ddfea08eb382d69")){let r=e.xor(t).mul(n);r=r.xor(r.shru(47));let s=t.xor(r).mul(n);return s=s.xor(s.shru(47)),s=s.mul(n),s}function hr(e,t,n,r){return function(e,t,n,r,s,o){s=s.add(e),o=ur(o.add(s).add(r),21);const a=s;return s=(s=s.add(t)).add(n),o=o.add(ur(s,44)),[s.add(r),o.add(a)]}(ir(e,t),ir(e,t+8),ir(e,t+16),ir(e,t+24),n,r)}function dr(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=br(e)),O().getBool("DEBUG")&&y(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){const t=new Uint8Array(e.length);for(let n=0;n<t.length;++n)0!==Math.round(e[n])&&(t[n]=1);return t}throw new Error(`Unknown data type ${t}`)}function pr(){return O().platform.now()}function fr(e,t="utf-8"){return t=t||"utf-8",O().platform.encode(e,t)}function gr(e,t="utf-8"){return t=t||"utf-8",O().platform.decode(e,t)}function mr(e){return O().platform.isTypedArray(e)}function br(e,t=[],n=!1){if(null==t&&(t=[]),"boolean"==typeof e||"number"==typeof e||"string"==typeof e||F(e)||null==e||mr(e)&&n)t.push(e);else if(Array.isArray(e)||mr(e))for(let r=0;r<e.length;++r)br(e[r],t,n);else{let r=-1;for(const t of Object.keys(e))/^([1-9]+[0-9]*|0)$/.test(t)&&(r=Math.max(r,Number(t)));for(let s=0;s<=r;s++)br(e[s],t,n)}return t}var yr={__proto__:null,createScalarValue:function(e,t){return"string"===t?fr(e):dr([e],t)},toTypedArray:dr,now:pr,fetch:function(e,t){return O().platform.fetch(e,t)},encodeString:fr,decodeString:gr,isTypedArray:mr,flatten:br,shuffle:s,shuffleCombo:function(e,t){if(e.length!==t.length)throw new Error(`Array sizes must match to be shuffled together First array length was ${e.length}Second array length was ${t.length}`);let n=e.length,r=0;for(;n>0;)r=Math.random()*n|0,n--,a(e,n,r),a(t,n,r)},clamp:o,nearestLargerEven:function(e){return e%2==0?e:e+1},swap:a,sum:function(e){let t=0;for(let n=0;n<e.length;n++)t+=e[n];return t},randUniform:function(e,t){const n=Math.random();return t*n+(1-n)*e},distSquared:function(e,t){let n=0;for(let r=0;r<e.length;r++){const s=Number(e[r])-Number(t[r]);n+=s*s}return n},assert:i,assertShapesMatch:l,assertNonNull:u,sizeFromShape:c,isScalarShape:function(e){return 0===e.length},arraysEqual:h,isInt:d,tanh:function(e){if(null!=Math.tanh)return Math.tanh(e);if(e===1/0)return 1;if(e===-1/0)return-1;{const t=Math.exp(2*e);return(t-1)/(t+1)}},sizeToSquarishShape:function(e){const t=Math.ceil(Math.sqrt(e));return[t,Math.ceil(e/t)]},createShuffledIndices:function(e){const t=new Uint32Array(e);for(let n=0;n<e;++n)t[n]=n;return s(t),t},rightPad:p,repeatedTry:function(e,t=(e=>0),n,r){return new Promise(((s,o)=>{let a=0;const i=()=>{if(e())return void s();a++;const l=t(a);null!=n&&a>=n?o():null!=r?r(i,l):setTimeout(i,l)};i()}))},inferFromImplicitShape:function(e,t){let n=1,r=-1;for(let t=0;t<e.length;++t)if(e[t]>=0)n*=e[t];else if(-1===e[t]){if(-1!==r)throw Error(`Shapes can only have 1 implicit size. Found -1 at dim ${r} and dim ${t}`);r=t}else if(e[t]<0)throw Error(`Shapes can not be < 0. Found ${e[t]} at dim ${t}`);if(-1===r){if(t>0&&t!==n)throw Error(`Size(${t}) must match the product of shape ${e}`);return e}if(0===n)throw Error(`Cannot infer the missing size in [${e}] when there are 0 elements`);if(t%n!=0)throw Error(`The implicit shape can't be a fractional number. Got ${t} / ${n}`);const s=e.slice();return s[r]=t/n,s},parseAxisParam:f,squeezeShape:g,getTypedArrayFromDType:m,getArrayFromDType:b,checkConversionForErrors:y,isValidDtype:w,hasEncodingLoss:function(e,t){return"complex64"!==t&&(("float32"!==t||"complex64"===e)&&(("int32"!==t||"float32"===e||"complex64"===e)&&("bool"!==t||"bool"!==e)))},bytesPerElement:k,bytesFromStringArray:v,isString:x,isBoolean:E,isNumber:S,inferDtype:$,isFunction:A,nearestDivisor:_,computeStrides:I,toNestedArray:M,convertBackendValuesAndArrayBuffer:function(e,t){if(Array.isArray(e))return e;if("float32"===t)return e instanceof Float32Array?e:new Float32Array(e);if("int32"===t)return e instanceof Int32Array?e:new Int32Array(e);if("bool"===t||"string"===t)return Uint8Array.from(new Int32Array(e));throw new Error(`Unknown dtype ${t}`)},makeOnesTypedArray:T,makeZerosTypedArray:D,makeZerosNestedTypedArray:function(e,t){const n=e.reduce(((e,t)=>e*t),1);if(null==t||"float32"===t)return M(e,new Float32Array(n));if("int32"===t)return M(e,new Int32Array(n));if("bool"===t)return M(e,new Uint8Array(n));throw new Error(`Unknown data type ${t}`)},assertNonNegativeIntegerDimensions:R,locToIndex:function(e,t,n){if(0===t)return 0;if(1===t)return e[0];let r=e[e.length-1];for(let t=0;t<e.length-1;++t)r+=n[t]*e[t];return r},indexToLoc:function(e,t,n){if(0===t)return[];if(1===t)return[e];const r=new Array(t);for(let t=0;t<r.length-1;++t)r[t]=Math.floor(e/n[t]),e-=r[t]*n[t];return r[r.length-1]=e,r},isPromise:F,hexToLong:tr,fingerPrint64:function(e,t=e.length){const n=er.fromNumber(81,!0);if(t<=32)return t<=16?function(e,t=e.length){if(t>=8){const n=sr.add(2*t),r=ir(e,0).add(sr),s=ir(e,t-8);return cr(ur(s,37).mul(n).add(r),ur(r,25).add(s).mul(n),n)}if(t>=4){const n=sr.add(2*t);return cr(lr(e,0).shl(3).add(t),lr(e,t-4),n)}if(t>0){const n=e[0]+(e[t>>1]<<8),r=t+(e[t-1]<<2);return or(sr.mul(n).xor(nr.mul(r))).mul(sr)}return sr}(e,t):function(e,t=e.length){const n=sr.add(2*t),r=ir(e,0).mul(rr),s=ir(e,8),o=ir(e,t-8).mul(n),a=ir(e,t-16).mul(sr);return cr(ur(r.add(s),43).add(ur(o,30)).add(a),r.add(ur(s.add(sr),18)).add(o),n)}(e,t);if(t<=64)return function(e,t=e.length){const n=sr.add(2*t),r=ir(e,0).mul(sr),s=ir(e,8),o=ir(e,t-8).mul(n),a=ir(e,t-16).mul(sr),i=ur(r.add(s),43).add(ur(o,30)).add(a),l=cr(i,r.add(ur(s.add(sr),18)).add(o),n),u=ir(e,16).mul(n),c=ir(e,24),h=i.add(ir(e,t-32)).mul(n),d=l.add(ir(e,t-24)).mul(n);return cr(ur(u.add(c),43).add(ur(h,30)).add(d),u.add(ur(c.add(r),18)).add(h),n)}(e,t);let r=n,s=n.mul(rr).add(113),o=or(s.mul(sr).add(113)).mul(sr),a=[er.UZERO,er.UZERO],i=[er.UZERO,er.UZERO];r=r.mul(sr).add(ir(e,0));let l=0;const u=64*(t-1>>6),c=u+(t-1&63)-63;do{r=ur(r.add(s).add(a[0]).add(ir(e,l+8)),37).mul(rr),s=ur(s.add(a[1]).add(ir(e,l+48)),42).mul(rr),r=r.xor(i[1]),s=s.add(a[0]).add(ir(e,l+40)),o=ur(o.add(i[0]),33).mul(rr),a=hr(e,l,a[1].mul(rr),r.add(i[0])),i=hr(e,l+32,o.add(i[1]),s.add(ir(e,l+16))),[o,r]=[r,o],l+=64}while(l!==u);const h=rr.add(o.and(255).shl(1));return l=c,i[0]=i[0].add(t-1&63),a[0]=a[0].add(i[0]),i[0]=i[0].add(a[0]),r=ur(r.add(s).add(a[0]).add(ir(e,l+8)),37).mul(h),s=ur(s.add(a[1]).add(ir(e,l+48)),42).mul(h),r=r.xor(i[1].mul(9)),s=s.add(a[0].mul(9).add(ir(e,l+40))),o=ur(o.add(i[0]),33).mul(h),a=hr(e,l,a[1].mul(h),r.add(i[0])),i=hr(e,l+32,o.add(i[1]),s.add(ir(e,l+16))),[o,r]=[r,o],cr(cr(a[0],i[0],h).add(or(s).mul(nr)).add(o),cr(a[1],i[1],h).add(r),h)}};class wr{constructor(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new vr)}profileKernel(e,t,n){let r;const s=()=>{r=n()};let o;const a=pr();if(this.backendTimer.timerAvailable())o=this.backendTimer.time(s);else{s();for(const e of r)e.dataSync();o=Promise.resolve({kernelMs:pr()-a})}if(O().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(let t=0;t<r.length;t++){const n=r[t];n.data().then((t=>{kr(t,n.dtype,e)}))}return{kernelName:e,outputs:r,inputs:t,timeMs:o.then((e=>e.kernelMs)),extraInfo:o.then((e=>null!=e.getExtraProfileInfo?e.getExtraProfileInfo():""))}}logKernelProfile(e){const{kernelName:t,outputs:n,timeMs:r,inputs:s,extraInfo:o}=e;n.forEach((e=>{Promise.all([e.data(),r,o]).then((n=>{this.logger.logKernelProfile(t,e,n[0],n[1],s,n[2])}))}))}}function kr(e,t,n){if("float32"!==t)return!1;for(let t=0;t<e.length;t++){const r=e[t];if(isNaN(r)||!isFinite(r))return console.warn(`Found ${r} in the result of '${n}'`),!0}return!1}class vr{logKernelProfile(e,t,n,r,s,o){const a="number"==typeof r?p(`${r}ms`,9):r.error,i=p(e,25),l=t.rank,u=t.size,c=p(t.shape.toString(),14);let h="";for(const e in s){const n=s[e];if(null!=n){const r=n.shape||t.shape,s=r.length;h+=`${e}: ${s}D ${s>0?r:""} `}}console.log(`%c${i}\t%c${a}\t%c${l}D ${c}\t%c${u}\t%c${h}\t%c${o}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function xr(e,t,n,r){const s=I(t),o=function(e,t,n,r){const s=c(t),o=r[r.length-1],a=new Array(o).fill(0),i=t.length,l="complex64"===n?Ar(e):e;if(i>1)for(let e=0;e<s/o;e++){const t=e*o;for(let e=0;e<o;e++)a[e]=Math.max(a[e],Er(l[t+e],0,n).length)}return a}(e,t,n,s),a=t.length,i=$r(e,t,n,s,o),l=["Tensor"];return r&&(l.push(`  dtype: ${n}`),l.push(`  rank: ${a}`),l.push(`  shape: [${t}]`),l.push("  values:")),l.push(i.map((e=>"    "+e)).join("\n")),l.join("\n")}function Er(e,t,n){let r;return r=Array.isArray(e)?`${parseFloat(e[0].toFixed(7))} + ${parseFloat(e[1].toFixed(7))}j`:x(e)?`'${e}'`:"bool"===n?Sr(e):parseFloat(e.toFixed(7)).toString(),p(r,t)}function Sr(e){return 0===e?"false":"true"}function $r(e,t,n,r,s,o=!0){const a="complex64"===n?2:1,i=t[0],l=t.length;if(0===l){if("complex64"===n){return[Er(Ar(e)[0],0,n)]}return"bool"===n?[Sr(e[0])]:[e[0].toString()]}if(1===l){if(i>20){const t=3*a;let r=Array.from(e.slice(0,t)),o=Array.from(e.slice((i-3)*a,i*a));return"complex64"===n&&(r=Ar(r),o=Ar(o)),["["+r.map(((e,t)=>Er(e,s[t],n))).join(", ")+", ..., "+o.map(((e,t)=>Er(e,s[i-3+t],n))).join(", ")+"]"]}return["["+("complex64"===n?Ar(e):Array.from(e)).map(((e,t)=>Er(e,s[t],n))).join(", ")+"]"]}const u=t.slice(1),c=r.slice(1),h=r[0]*a,d=[];if(i>20){for(let t=0;t<3;t++){const r=t*h,o=r+h;d.push(...$r(e.slice(r,o),u,n,c,s,!1))}d.push("...");for(let t=i-3;t<i;t++){const r=t*h,o=r+h;d.push(...$r(e.slice(r,o),u,n,c,s,t===i-1))}}else for(let t=0;t<i;t++){const r=t*h,o=r+h;d.push(...$r(e.slice(r,o),u,n,c,s,t===i-1))}const p=2===l?",":"";d[0]="["+(i>0?d[0]+p:"");for(let e=1;e<d.length-1;e++)d[e]=" "+d[e]+p;let f=",\n";for(let e=2;e<l;e++)f+="\n";return d[d.length-1]=" "+d[d.length-1]+"]"+(o?"":f),d}function Ar(e){const t=[];for(let n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}class _r{constructor(e,t,n){if(this.dtype=t,this.shape=e.slice(),this.size=c(e),null!=n){const e=n.length;i(e===this.size,(()=>`Length of values '${e}' does not match the size inferred by the shape '${this.size}'.`))}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||b(t,this.size),this.strides=I(e)}set(e,...t){0===t.length&&(t=[0]),i(t.length===this.rank,(()=>`The number of provided coordinates (${t.length}) must match the rank (${this.rank})`));const n=this.locToIndex(t);this.values[n]=e}get(...e){0===e.length&&(e=[0]);let t=0;for(const n of e){if(n<0||n>=this.shape[t]){const t=`Requested out of range element at ${e}.   Buffer shape=${this.shape}`;throw new Error(t)}t++}let n=e[e.length-1];for(let t=0;t<e.length-1;++t)n+=this.strides[t]*e[t];return this.values[n]}locToIndex(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];let t=e[e.length-1];for(let n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t}indexToLoc(e){if(0===this.rank)return[];if(1===this.rank)return[e];const t=new Array(this.shape.length);for(let n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t}get rank(){return this.shape.length}toTensor(){return Ir().makeTensor(this.values,this.shape,this.dtype)}}let Ir=null,Nr=null;class Mr{constructor(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=c(e),this.strides=I(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const e=await this.data();return Nr.buffer(this.shape,this.dtype,e)}bufferSync(){return Nr.buffer(this.shape,this.dtype,this.dataSync())}async array(){const e=await this.data();return M(this.shape,e,"complex64"===this.dtype)}arraySync(){return M(this.shape,this.dataSync(),"complex64"===this.dtype)}async data(){this.throwIfDisposed();const e=Ir().read(this.dataId);if("string"===this.dtype){const t=await e;try{return t.map((e=>gr(e)))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return e}dataToGPU(e){return this.throwIfDisposed(),Ir().readToGPU(this.dataId,e)}dataSync(){this.throwIfDisposed();const e=Ir().readSync(this.dataId);if("string"===this.dtype)try{return e.map((e=>gr(e)))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e}async bytes(){this.throwIfDisposed();const e=await Ir().read(this.dataId);return"string"===this.dtype?e:new Uint8Array(e.buffer)}dispose(){this.isDisposed||(Ir().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(e=!1){return Nr.print(this,e)}clone(){return this.throwIfDisposed(),Nr.clone(this)}toString(e=!1){return xr(this.dataSync(),this.shape,this.dtype,e)}cast(e){return this.throwIfDisposed(),Nr.cast(this,e)}variable(e=!0,t,n){return this.throwIfDisposed(),Ir().makeVariable(this,e,t,n)}}Object.defineProperty(Mr,Symbol.hasInstance,{value:e=>!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed}),W("Tensor",(()=>Mr));class Tr extends Mr{constructor(e,t,n,r){super(e.shape,e.dtype,e.dataId,r),this.trainable=t,this.name=n}assign(e){if(e.dtype!==this.dtype)throw new Error(`dtype of the new value (${e.dtype}) and previous value (${this.dtype}) must match`);if(!h(e.shape,this.shape))throw new Error(`shape of the new value (${e.shape}) and previous value (${this.shape}) must match`);Ir().disposeTensor(this),this.dataId=e.dataId,Ir().incRef(this,null)}dispose(){Ir().disposeVariable(this),this.isDisposedInternal=!0}}var Dr,Rr,Fr,Br,Cr;Object.defineProperty(Tr,Symbol.hasInstance,{value:e=>e instanceof Mr&&null!=e.assign&&e.assign instanceof Function}),e.Rank=void 0,(Dr=e.Rank||(e.Rank={})).R0="R0",Dr.R1="R1",Dr.R2="R2",Dr.R3="R3",Dr.R4="R4",Dr.R5="R5",Dr.R6="R6",function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(Rr||(Rr={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(Fr||(Fr={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(Br||(Br={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(Cr||(Cr={}));const Pr={float32:Br,int32:Rr,bool:Fr,complex64:Cr};function Or(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error(`Can not upcast ${e} with ${t}`)}return Pr[e][t]}function Lr(e){return null!=e&&"object"==typeof e&&"texture"in e&&e.texture instanceof WebGLTexture}function zr(e){return"undefined"!=typeof GPUBuffer&&null!=e&&"object"==typeof e&&"buffer"in e&&e.buffer instanceof GPUBuffer}function Wr(e,t){if(e.dtype===t.dtype)return[e,t];const n=Or(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function Ur(e,t){i(e.dtype===t.dtype,(()=>`The dtypes of the first(${e.dtype}) and second(${t.dtype}) input must match`))}function Gr(e){const t=[];return Kr(e,t,new Set),t}function Kr(e,t,n){if(null==e)return;if(e instanceof Mr)return void t.push(e);if(r=e,!Array.isArray(r)&&"object"!=typeof r)return;var r;const s=e;for(const e in s){const r=s[e];n.has(r)||(n.add(r),Kr(r,t,n))}}var qr={__proto__:null,makeTypesMatch:Wr,assertTypesMatch:Ur,isTensorInList:function(e,t){return t.some((t=>t.id===e.id))},getTensorsInContainer:Gr};function Vr(e){return null!=e.kernelName}class Hr{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map((e=>e.name))))}}}dispose(){for(const e in this.registeredVariables)this.registeredVariables[e].dispose()}}class jr{constructor(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Hr}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then((()=>{}));if(null!=this.backendInstance)return;const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:e,asyncInit:t}=this.initializeBackendsAndReturnBest();if(t)throw new Error(`The highest priority backend '${e}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(e)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;{const{asyncInit:t}=this.initializeBackend(e);if(t)return null}}return this.registry[e]}findBackendFactory(e){return e in this.registryFactory?this.registryFactory[e].factory:null}registerBackend(e,t,n=1){return e in this.registryFactory?(vn(`${e} backend was already registered. Reusing existing backend factory.`),!1):(this.registryFactory[e]={factory:t,priority:n},!0)}async setBackend(e){if(null==this.registryFactory[e])throw new Error(`Backend name '${e}' not found in registry`);if(this.backendName=e,null==this.registry[e]){this.backendInstance=null;const{success:t,asyncInit:n}=this.initializeBackend(e);if(!(n?await t:t))return!1}return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new wr(this.backendInstance),!0}setupRegisteredKernels(){An(this.backendName).forEach((e=>{null!=e.setupFunc&&e.setupFunc(this.backendInstance)}))}disposeRegisteredKernels(e){An(e).forEach((t=>{null!=t.disposeFunc&&t.disposeFunc(this.registry[e])}))}initializeBackend(e){const t=this.registryFactory[e];if(null==t)throw new Error(`Cannot initialize backend ${e}, no registration found.`);try{const r=t.factory();if(!r||r instanceof n||"function"!=typeof r.then)return this.registry[e]=r,{success:!0,asyncInit:!1};{const t=++this.pendingBackendInitId,n=r.then((n=>!(t<this.pendingBackendInitId)&&(this.registry[e]=n,this.pendingBackendInit=null,!0))).catch((n=>(t<this.pendingBackendInitId||(this.pendingBackendInit=null,vn(`Initialization of backend ${e} failed`),vn(n.stack||n.message)),!1)));return this.pendingBackendInit=n,{success:n,asyncInit:!0}}}catch(t){return vn(`Initialization of backend ${e} failed`),vn(t.stack||t.message),{success:!1,asyncInit:!1}}}removeBackend(e){if(!(e in this.registryFactory))throw new Error(`${e} backend not found in registry`);this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort(((e,t)=>this.registryFactory[t].priority-this.registryFactory[e].priority))}initializeBackendsAndReturnBest(){const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t],{success:r,asyncInit:s}=this.initializeBackend(n);if(s||r)return{name:n,asyncInit:s}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(e,t){const n=this.state.tensorInfo.get(t),r=n.backend,s=this.readSync(t),o=r.refCount(t);r.disposeData(t,!0),n.backend=e,e.move(t,s,n.shape,n.dtype,o),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(e,t){let n,r=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");r=e}return this.scopedRun((()=>this.startScope(r)),(()=>this.endScope(n)),(()=>(n=t(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n)))}scopedRun(e,t,n){e();try{const e=n();return t(),e}catch(e){throw t(),e}}nextTensorId(){return jr.nextTensorId++}nextVariableId(){return jr.nextVariableId++}clone(e){const t=Jr.runKernel(We,{x:e}),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],(e=>({x:()=>{const t={x:e},n={dtype:"float32"};return Jr.runKernel(oe,t,n)}})),[],{}),t}runKernel(e,t,n){null==this.backendName&&this.backend;if(!(null!=Sn(e,this.backendName)))throw new Error(`Kernel '${e}' not registered for backend '${this.backendName}'`);return this.runKernelFunc({kernelName:e,inputs:t,attrs:n})}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(e,t,n){const r=this.backend.numDataIds();let s=0;n.forEach((e=>{s+="complex64"===e.dtype?3:1}));const o=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],a=r-t-s-o;if(a>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${a} data ids) after running '${e}'`)}runKernelFunc(e){let t,n=[];const r=this.isTapeOn(),s=this.state.numBytes,o=this.state.numTensors;let a,l;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;const u=Vr(e)?e.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(Vr(e)){const{kernelName:t,inputs:s,attrs:o}=e;null==this.backendName&&this.backend;const u=Sn(t,this.backendName);i(null!=u,(()=>`Cannot find registered kernel '${t}' for backend '${this.backendName}'`)),a=()=>{const e=this.backend.numDataIds();l=u.kernelFunc({inputs:s,attrs:o,backend:this.backend});const a=Array.isArray(l)?l:[l];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(t,e,a);const i=a.map((e=>null!=e.rank?e:this.makeTensorFromTensorInfo(e)));if(r){const e=this.getTensorsForGradient(t,s,i);n=this.saveTensorsForBackwardMode(e)}return i}}else{const{forwardFunc:t}=e,s=e=>{r&&(n=e.map((e=>this.keep(this.clone(e)))))};a=()=>{const e=this.backend.numDataIds();l=this.tidy((()=>t(this.backend,s)));const n=Array.isArray(l)?l:[l];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(u,e,n),n}}const{inputs:c,attrs:h}=e,d=Vr(e)?null:e.backwardsFunc;let p;return this.scopedRun((()=>this.state.kernelDepth++),(()=>this.state.kernelDepth--),(()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(p=this.profiler.profileKernel(u,c,(()=>a())),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(p),t=p.outputs):t=a()})),r&&this.addTapeNode(u,c,t,d,n,h),this.state.profiling&&this.state.activeProfile.kernels.push({name:u,bytesAdded:this.state.numBytes-s,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-o,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(c).map((e=>null!=c[e]?c[e].shape:null)),outputShapes:t.map((e=>e.shape)),kernelTimeMs:p.timeMs,extraInfo:p.extraInfo}),Array.isArray(l)?t:t[0]}saveTensorsForBackwardMode(e){const t=e.map((e=>this.keep(this.clone(e))));return t}getTensorsForGradient(e,t,n){const r=$n(e);if(null!=r){const e=r.inputsToSave||[],s=r.outputsToSave||[];let o;r.saveAllInputs?(i(Array.isArray(t),(()=>"saveAllInputs is true, expected inputs to be an array.")),o=Object.keys(t).map((e=>t[e]))):o=e.map((e=>t[e]));const a=n.filter(((e,t)=>s[t]));return o.concat(a)}return[]}makeTensor(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;let s=e;"string"===n&&x(e[0])&&(s=e.map((e=>fr(e))));const o=r.write(s,t,n),a=new Mr(t,n,o,this.nextTensorId());if(this.trackTensor(a,r),"string"===n){const e=this.state.tensorInfo.get(o),t=v(s);this.state.numBytes+=t-e.bytes,e.bytes=t}return a}makeTensorFromDataId(e,t,n,r){const s={dataId:e,shape:t,dtype:n=n||"float32"};return this.makeTensorFromTensorInfo(s,r)}makeTensorFromTensorInfo(e,t){const{dataId:n,shape:r,dtype:s}=e,o=new Mr(r,s,n,this.nextTensorId());return this.trackTensor(o,t),o}makeVariable(e,t=!0,n,r){n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));const s=new Tr(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[s.name])throw new Error(`Variable with name ${s.name} was already registered`);return this.state.registeredVariables[s.name]=s,this.incRef(s,this.backend),s}trackTensor(e,t){this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++;let n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*k(e.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(e.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n})),e instanceof Tr||this.track(e)}incRef(e,t){this.trackTensor(e,t),this.backend.incRef(e.dataId)}removeDataId(e,t){this.state.tensorInfo.has(e)&&this.state.tensorInfo.get(e).backend===t&&(this.state.tensorInfo.delete(e),this.state.numDataBuffers--)}disposeTensor(e){if(!this.state.tensorInfo.has(e.dataId))return;const t=this.state.tensorInfo.get(e.dataId);if(this.state.numTensors--,"string"===e.dtype&&(this.state.numStringTensors--,this.state.numBytes-=t.bytes),"complex64"!==e.dtype&&"string"!==e.dtype){const t=e.size*k(e.dtype);this.state.numBytes-=t}t.backend.disposeData(e.dataId)&&this.removeDataId(e.dataId,t.backend)}disposeVariables(){for(const e in this.state.registeredVariables){const t=this.state.registeredVariables[e];this.disposeVariable(t)}}disposeVariable(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]}memory(){const e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e}async profile(e){this.state.profiling=!0;const t=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await e(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map((e=>e.totalBytesSnapshot))),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const e of this.state.activeProfile.kernels)e.kernelTimeMs=await e.kernelTimeMs,e.extraInfo=await e.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(e,t,n,r,s,o){const a={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:s},i=$n(e);null!=i&&(r=i.gradFunc),null!=r&&(a.gradient=e=>(e=e.map(((e,t)=>{if(null==e){const e=n[t],r=D(e.size,e.dtype);return this.makeTensor(r,e.shape,e.dtype)}return e})),r(e.length>1?e:e[0],s,o))),this.state.activeTape.push(a)}keep(e){return e.kept=!0,e}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(e){const t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t}endScope(e){const t=Gr(e),n=new Set(t.map((e=>e.id)));for(let e=0;e<this.state.activeScope.track.length;e++){const t=this.state.activeScope.track[e];t.kept||n.has(t.id)||t.dispose()}const r=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],t.forEach((e=>{e.kept||e.scopeId!==r.id||this.track(e)}))}gradients(e,t,n,r=!1){if(i(t.length>0,(()=>"gradients() received an empty list of xs.")),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const s=this.scopedRun((()=>this.startTape()),(()=>this.endTape()),(()=>this.tidy("forward",e)));i(s instanceof Mr,(()=>"The result y returned by f() must be a tensor."));const o=function(e,t,n){const r={},s={};for(let e=0;e<t.length;e++)r[t[e].id]=!0;for(let n=0;n<e.length;n++){const o=e[n],a=o.inputs;for(const e in a){const n=a[e];let i=!1;for(let e=0;e<t.length;e++)if(r[n.id]){o.outputs.forEach((e=>r[e.id]=!0)),i=!0,s[o.id]=!0;break}if(i)break}}const o={};o[n.id]=!0;const a={};for(let t=e.length-1;t>=0;t--){const n=e[t],r=n.inputs;for(let e=0;e<n.outputs.length;e++)if(o[n.outputs[e].id]){for(const e in r)o[r[e].id]=!0,a[n.id]=!0;break}}const i=[];for(let t=0;t<e.length;t++){const n=e[t];if(s[n.id]&&a[n.id]){const e={};for(const t in n.inputs){const s=n.inputs[t];r[s.id]&&(e[t]=s)}const t=Object.assign({},n);t.inputs=e,t.outputs=n.outputs,i.push(t)}}return i}(this.state.activeTape,t,s);if(!r&&0===o.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(()=>{const e={};e[s.id]=null==n?function(e){const t=T(c(e),"float32");return Jr.makeTensor(t,e,"float32")}(s.shape):n,function(e,t,n,r){for(let s=t.length-1;s>=0;s--){const o=t[s],a=[];if(o.outputs.forEach((t=>{const n=e[t.id];null!=n?a.push(n):a.push(null)})),null==o.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${o.kernelName}.`);const i=o.gradient(a);for(const t in o.inputs){if(!(t in i))throw new Error(`Cannot backprop through input ${t}. Available gradients found: ${Object.keys(i)}.`);const s=n((()=>i[t]()));if("float32"!==s.dtype)throw new Error(`Error in gradient for op ${o.kernelName}. The gradient of input ${t} must have 'float32' dtype, but has '${s.dtype}'`);const a=o.inputs[t];if(!h(s.shape,a.shape))throw new Error(`Error in gradient for op ${o.kernelName}. The gradient of input '${t}' has shape '${s.shape}', which does not match the shape of the input '${a.shape}'`);if(null==e[a.id])e[a.id]=s;else{const t=e[a.id];e[a.id]=r(t,s),t.dispose()}}}}(e,o,(e=>this.tidy(e)),Yr);const r=t.map((t=>e[t.id]));return 0===this.state.gradientDepth&&(this.state.activeTape.forEach((e=>{for(const t of e.saved)t.dispose()})),this.state.activeTape=null),{value:s,grads:r}}))}customGrad(e){return i(A(e),(()=>"The f passed in customGrad(f) must be a function.")),(...t)=>{let n;i(t.every((e=>e instanceof Mr)),(()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors"));const r={};t.forEach(((e,t)=>{r[t]=e}));return this.runKernelFunc({forwardFunc:(r,s)=>(n=e(...t,s),i(n.value instanceof Mr,(()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor")),i(A(n.gradFunc),(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function.")),n.value),backwardsFunc:(e,r)=>{const s=n.gradFunc(e,r),o=Array.isArray(s)?s:[s];i(o.length===t.length,(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...).")),i(o.every((e=>e instanceof Mr)),(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."));const a={};return o.forEach(((e,t)=>{a[t]=()=>e})),a},inputs:r})}}readSync(e){return this.state.tensorInfo.get(e).backend.readSync(e)}read(e){return this.state.tensorInfo.get(e).backend.read(e)}readToGPU(e,t){return this.state.tensorInfo.get(e).backend.readToGPU(e,t)}async time(e){const t=pr(),n=await this.backend.time(e);return n.wallMs=pr()-t,n}track(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Hr;for(const e in this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}function Zr(){const t=z();if(null==t._tfengine){const e=new C(t);t._tfengine=new jr(e)}var n;return n=t._tfengine.ENV,e.ENV=n,Ir=()=>t._tfengine,t._tfengine}jr.nextTensorId=0,jr.nextVariableId=0;const Jr=Zr();function Yr(e,t){const n={a:e,b:t};return Jr.runKernel(K,n)}let Xr;function Qr(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var es={__proto__:null,mockIsMobile:function(e){Xr=e},isMobile:function(e){if(void 0!==Xr)return Xr;if(e||"undefined"!=typeof navigator&&null!=navigator){if(e||(e=navigator),"ReactNative"===e.product)return!0;const t=e.userAgent||e.vendor||("undefined"!=typeof window?window.opera:"");if(!t){const t=e;return t.userAgentData&&t.userAgentData.mobile}return/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(t.substr(0,4))}return!1},isBrowser:Qr};const ts=O();function ns(e,t){let n=e;if(mr(e))return"string"===t?[]:[e.length];if(Lr(e)){const t=e.channels||"RGBA";return[e.height,e.width*t.length]}if(zr(e))return[e.buffer.size/(null==t?4:k(t))];if(!Array.isArray(e))return[];const r=[];for(;Array.isArray(n)||mr(n)&&"string"!==t;)r.push(n.length),n=n[0];return Array.isArray(e)&&O().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&rs(e,r,[]),r}function rs(e,t,n){if(n=n||[],!Array.isArray(e)&&!mr(e))return void i(0===t.length,(()=>`Element arr[${n.join("][")}] is a primitive, but should be an array/TypedArray of ${t[0]} elements`));i(t.length>0,(()=>`Element arr[${n.join("][")}] should be a primitive, but is an array of ${e.length} elements`)),i(e.length===t[0],(()=>`Element arr[${n.join("][")}] should have ${t[0]} elements, but has ${e.length} elements`));const r=t.slice(1);for(let t=0;t<e.length;++t)rs(e[t],r,n.concat(t))}function ss(e,t,n,r){if("string_or_numeric"!==e){if(null==e)throw new Error("Expected dtype cannot be null.");if("numeric"!==e&&e!==t||"numeric"===e&&"string"===t)throw new Error(`Argument '${n}' passed to '${r}' must be ${e} tensor, but got ${t} tensor`)}}function os(e,t,n,r="numeric"){if(e instanceof Mr)return ss(r,e.dtype,t,n),e;let s=$(e);if("string"!==s&&["bool","int32","float32"].indexOf(r)>=0&&(s=r),ss(r,s,t,n),null==e||!mr(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){const r=null==e?"null":e.constructor.name;throw new Error(`Argument '${t}' passed to '${n}' must be a Tensor or TensorLike, but got '${r}'`)}const o=ns(e,s);mr(e)||Array.isArray(e)||(e=[e]);const a="string"!==s?dr(e,s):br(e,[],!0);return Jr.makeTensor(a,o,s)}function as(e,t,n,r="numeric"){if(!Array.isArray(e))throw new Error(`Argument ${t} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return e.map(((e,s)=>os(e,`${t}[${s}]`,n,r)))}ts.registerFlag("DEBUG",(()=>!1),(e=>{e&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")})),ts.registerFlag("IS_BROWSER",(()=>Qr())),ts.registerFlag("IS_NODE",(()=>"undefined"!=typeof process&&"undefined"!=typeof process.versions&&"undefined"!=typeof process.versions.node)),ts.registerFlag("IS_CHROME",(()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor))),ts.registerFlag("IS_SAFARI",(()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Safari/.test(navigator.userAgent)&&/Apple/.test(navigator.vendor))),ts.registerFlag("PROD",(()=>!1)),ts.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",(()=>ts.getBool("DEBUG"))),ts.registerFlag("DEPRECATION_WARNINGS_ENABLED",(()=>!0)),ts.registerFlag("IS_TEST",(()=>!1)),ts.registerFlag("CHECK_COMPUTATION_FOR_ERRORS",(()=>ts.getBool("DEBUG"))),ts.registerFlag("WRAP_TO_IMAGEBITMAP",(()=>!1)),ts.registerFlag("CANVAS2D_WILL_READ_FREQUENTLY_FOR_GPU",(()=>!1)),ts.registerFlag("USE_SETTIMEOUTCUSTOM",(()=>!1));const is="__op";function ls(e){const t=Object.keys(e);if(1!==t.length)throw new Error(`Please provide an object with a single key (operation name) mapping to a function. Got an object with ${t.length} keys.`);let n=t[0];const r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+=is;const s=(...e)=>{Jr.startScope(n);try{const t=r(...e);return F(t)&&console.error("Cannot return a Promise inside of tidy."),Jr.endScope(t),t}catch(e){throw Jr.endScope(null),e}};return Object.defineProperty(s,"name",{value:n,configurable:!0}),s}const us=ls({complex_:function(e,t){const n=os(e,"real","complex"),r=os(t,"imag","complex");l(n.shape,r.shape,`real and imag shapes, ${n.shape} and ${r.shape}, must match in call to tf.complex().`);const s={real:n,imag:r};return Jr.runKernel(le,s)}});function cs(e,t,n,r){if(null==r)r=$(e);else if("complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(zr(e)||Lr(e)){if("float32"!==r&&"int32"!==r)throw new Error(`Creating tensor from GPU data only supports 'float32'|'int32' dtype, while the dtype is ${r}.`);return Jr.backend.createTensorFromGPUData(e,t||n,r)}if(!mr(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){R(t);const e=c(t),r=c(n);i(e===r,(()=>`Based on the provided shape, [${t}], the tensor should have ${e} values but has ${r}`));for(let e=0;e<n.length;++e){const r=n[e],s=e!==n.length-1||r!==c(t.slice(e));i(n[e]===t[e]||!s,(()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${t}). `))}}return mr(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?dr(e,r):br(e,[],!0),Jr.makeTensor(e,t,r)}function hs(e,t,n){return cs(e,t,ns(e,n),n)}const ds={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};function ps(e,t){const n={};let r,s=0;for(const o of t){const t=o.name,a=o.dtype,i=o.shape,l=c(i);let u;if("quantization"in o){const n=o.quantization;if("uint8"===n.dtype||"uint16"===n.dtype){if(!("min"in n)||!("scale"in n))throw new Error(`Weight ${o.name} with quantization ${n.dtype} doesn't have corresponding metadata min and scale.`)}else{if("float16"!==n.dtype)throw new Error(`Weight ${o.name} has unknown quantization dtype ${n.dtype}. Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.`);if("float32"!==a)throw new Error(`Weight ${o.name} is quantized with ${n.dtype} which only supports weights of type float32 not ${a}.`)}const i=ds[n.dtype],c=e.slice(s,s+l*i),h="uint8"===n.dtype?new Uint8Array(c):new Uint16Array(c);if("float32"===a)if("uint8"===n.dtype||"uint16"===n.dtype){u=new Float32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];u[e]=t*n.scale+n.min}}else{if("float16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type float32.`);void 0===r&&(r=Ss()),u=r(h)}else{if("int32"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);if("uint8"!==n.dtype&&"uint16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type int32.`);u=new Int32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];u[e]=Math.round(t*n.scale+n.min)}}s+=l*i}else if("string"===a){const t=c(o.shape);u=[];for(let n=0;n<t;n++){const t=new Uint32Array(e.slice(s,s+4))[0];s+=4;const n=new Uint8Array(e.slice(s,s+t));u.push(n),s+=t}}else{const r=ds[a],o=e.slice(s,s+l*r);if("float32"===a)u=new Float32Array(o);else if("int32"===a)u=new Int32Array(o);else if("bool"===a)u=new Uint8Array(o);else{if("complex64"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);{u=new Float32Array(o);const e=new Float32Array(u.length/2),r=new Float32Array(u.length/2);for(let t=0;t<e.length;t++)e[t]=u[2*t],r[t]=u[2*t+1];const s=hs(e,i,"float32"),a=hs(r,i,"float32");n[t]=us(s,a),s.dispose(),a.dispose()}}s+=l*r}"complex64"!==a&&(n[t]=hs(u,i,a))}return n}function fs(e){if(null===e)throw new Error(`Invalid input value: ${JSON.stringify(e)}`);let t=0;const n=[];e.forEach((e=>{if(t+=e.byteLength,n.push(e.byteLength===e.buffer.byteLength?e:new e.constructor(e)),!(e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array))throw new Error(`Unsupported TypedArray subtype: ${e.constructor.name}`)}));const r=new Uint8Array(t);let s=0;return n.forEach((e=>{r.set(new Uint8Array(e.buffer),s),s+=e.byteLength})),r.buffer}const gs="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function ms(e){return gs?Buffer.byteLength(e):new Blob([e]).size}function bs(e){if(1===e.length)return e[0];let t=0;e.forEach((e=>{t+=e.byteLength}));const n=new Uint8Array(t);let r=0;return e.forEach((e=>{n.set(new Uint8Array(e),r),r+=e.byteLength})),n.buffer}function ys(e){for(e=e.trim();e.endsWith("/");)e=e.slice(0,e.length-1);const t=e.split("/");return t[t.length-1]}function ws(e,t){const n={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,weightsManifest:t};return null!=e.signature&&(n.signature=e.signature),null!=e.userDefinedMetadata&&(n.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(n.modelInitializer=e.modelInitializer),null!=e.initializerSignature&&(n.initializerSignature=e.initializerSignature),null!=e.trainingConfig&&(n.trainingConfig=e.trainingConfig),n}function ks(e,t,n){const r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy};if(null!=e.trainingConfig&&(r.trainingConfig=e.trainingConfig),null!=e.weightsManifest){if(!t)throw new Error("modelJSON has weightsManifest but weightSpecs is null");if(!n)throw new Error("modelJSON has weightsManifest but weightData is null");r.weightSpecs=t,r.weightData=n}return null!=e.signature&&(r.signature=e.signature),null!=e.userDefinedMetadata&&(r.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(r.modelInitializer=e.modelInitializer),null!=e.initializerSignature&&(r.initializerSignature=e.initializerSignature),r}async function vs(e,t){let n,r;return null!=e.weightsManifest&&([n,r]=await t(e.weightsManifest)),ks(e,n,r)}function xs(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==e.modelTopology?0:ms(JSON.stringify(e.modelTopology)),weightSpecsBytes:null==e.weightSpecs?0:ms(JSON.stringify(e.weightSpecs)),weightDataBytes:null==e.weightData?0:e.weightData.byteLength}}function Es(e){const t=[];for(const n of e)t.push(...n.weights);return t}function Ss(){const e=function(){const e=e=>{let t=e<<13,n=0;for(;0==(8388608&t);)n-=8388608,t<<=1;return t&=-8388609,n+=947912704,t|n},t=new Uint32Array(2048);t[0]=0;for(let n=1;n<1024;n++)t[n]=e(n);for(let e=1024;e<2048;e++)t[e]=939524096+(e-1024<<13);return t}(),t=function(){const e=new Uint32Array(64);e[0]=0,e[31]=1199570944,e[32]=2147483648,e[63]=3347054592;for(let t=1;t<31;t++)e[t]=t<<23;for(let t=33;t<63;t++)e[t]=2147483648+(t-32<<23);return e}(),n=function(){const e=new Uint32Array(64);for(let t=0;t<64;t++)e[t]=1024;return e[0]=e[32]=0,e}();return r=>{const s=new ArrayBuffer(4*r.length),o=new Uint32Array(s);for(let s=0;s<r.length;s++){const a=r[s],i=e[n[a>>10]+(1023&a)]+t[a>>10];o[s]=i}return new Float32Array(s)}}class $s{constructor(){this.saveRouters=[],this.loadRouters=[]}static getInstance(){return null==$s.instance&&($s.instance=new $s),$s.instance}static registerSaveRouter(e){$s.getInstance().saveRouters.push(e)}static registerLoadRouter(e){$s.getInstance().loadRouters.push(e)}static getSaveHandlers(e){return $s.getHandlers(e,"save")}static getLoadHandlers(e,t){return $s.getHandlers(e,"load",t)}static getHandlers(e,t,n){const r=[];return("load"===t?$s.getInstance().loadRouters:$s.getInstance().saveRouters).forEach((t=>{const s=t(e,n);null!==s&&r.push(s)})),r}}const As="tensorflowjs",_s="models_store",Is="model_info_store";function Ns(){if(!O().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");const e="undefined"==typeof window?self:window,t=e.indexedDB||e.mozIndexedDB||e.webkitIndexedDB||e.msIndexedDB||e.shimIndexedDB;if(null==t)throw new Error("The current browser does not appear to support IndexedDB.");return t}function Ms(e){const t=e.result;t.createObjectStore(_s,{keyPath:"modelPath"}),t.createObjectStore(Is,{keyPath:"modelPath"})}class Ts{constructor(e){if(this.indexedDB=Ns(),null==e||!e)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=e}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return this.databaseAction(this.modelPath,e)}async load(){return this.databaseAction(this.modelPath)}databaseAction(e,t){return new Promise(((e,n)=>{const r=this.indexedDB.open(As,1);r.onupgradeneeded=()=>Ms(r),r.onsuccess=()=>{const s=r.result;if(null==t){const t=s.transaction(_s,"readonly"),r=t.objectStore(_s).get(this.modelPath);r.onsuccess=()=>{if(null==r.result)return s.close(),n(new Error(`Cannot find model with path '${this.modelPath}' in IndexedDB.`));e(r.result.modelArtifacts)},r.onerror=e=>(s.close(),n(r.error)),t.oncomplete=()=>s.close()}else{const r=xs(t),o=s.transaction(Is,"readwrite");let a,i,l=o.objectStore(Is);try{a=l.put({modelPath:this.modelPath,modelArtifactsInfo:r})}catch(e){return n(e)}a.onsuccess=()=>{i=s.transaction(_s,"readwrite");const a=i.objectStore(_s);let u;try{u=a.put({modelPath:this.modelPath,modelArtifacts:t,modelArtifactsInfo:r})}catch(e){return n(e)}u.onsuccess=()=>e({modelArtifactsInfo:r}),u.onerror=e=>{l=o.objectStore(Is);const t=l.delete(this.modelPath);t.onsuccess=()=>(s.close(),n(u.error)),t.onerror=e=>(s.close(),n(u.error))}},a.onerror=e=>(s.close(),n(a.error)),o.oncomplete=()=>{null==i?s.close():i.oncomplete=()=>s.close()}}},r.onerror=e=>n(r.error)}))}}Ts.URL_SCHEME="indexeddb://";const Ds=e=>{return O().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Ts.URL_SCHEME)?(t=e.slice(Ts.URL_SCHEME.length),new Ts(t)):null;var t};$s.registerSaveRouter(Ds),$s.registerLoadRouter(Ds);class Rs{constructor(){this.indexedDB=Ns()}async listModels(){return new Promise(((e,t)=>{const n=this.indexedDB.open(As,1);n.onupgradeneeded=()=>Ms(n),n.onsuccess=()=>{const r=n.result,s=r.transaction(Is,"readonly"),o=s.objectStore(Is).getAll();o.onsuccess=()=>{const t={};for(const e of o.result)t[e.modelPath]=e.modelArtifactsInfo;e(t)},o.onerror=e=>(r.close(),t(o.error)),s.oncomplete=()=>r.close()},n.onerror=e=>t(n.error)}))}async removeModel(e){var t;return e=(t=e).startsWith(Ts.URL_SCHEME)?t.slice(Ts.URL_SCHEME.length):t,new Promise(((t,n)=>{const r=this.indexedDB.open(As,1);r.onupgradeneeded=()=>Ms(r),r.onsuccess=()=>{const s=r.result,o=s.transaction(Is,"readwrite"),a=o.objectStore(Is),i=a.get(e);let l;i.onsuccess=()=>{if(null==i.result)return s.close(),n(new Error(`Cannot find model with path '${e}' in IndexedDB.`));{const r=a.delete(e),o=()=>{l=s.transaction(_s,"readwrite");const r=l.objectStore(_s).delete(e);r.onsuccess=()=>t(i.result.modelArtifactsInfo),r.onerror=e=>n(i.error)};r.onsuccess=o,r.onerror=e=>(o(),s.close(),n(i.error))}},i.onerror=e=>(s.close(),n(i.error)),o.oncomplete=()=>{null==l?s.close():l.oncomplete=()=>s.close()}},r.onerror=e=>n(r.error)}))}}const Fs="/",Bs="tensorflowjs_models",Cs="info",Ps="model_topology",Os="weight_specs",Ls="weight_data",zs="model_metadata";function Ws(e){return{info:[Bs,e,Cs].join(Fs),topology:[Bs,e,Ps].join(Fs),weightSpecs:[Bs,e,Os].join(Fs),weightData:[Bs,e,Ls].join(Fs),modelMetadata:[Bs,e,zs].join(Fs)}}function Us(e){for(const t of Object.values(e))window.localStorage.removeItem(t)}function Gs(e){const t=e.split(Fs);if(t.length<3)throw new Error(`Invalid key format: ${e}`);return t.slice(1,t.length-1).join(Fs)}class Ks{constructor(e){if(!O().getBool("IS_BROWSER")||"undefined"==typeof window||"undefined"==typeof window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==e||!e)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=e,this.keys=Ws(this.modelPath)}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");{const t=JSON.stringify(e.modelTopology),n=JSON.stringify(e.weightSpecs),r=xs(e);try{this.LS.setItem(this.keys.info,JSON.stringify(r)),this.LS.setItem(this.keys.topology,t),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(e){if(gs)return Buffer.from(e).toString("base64");const t=new Uint8Array(e);let n="";for(let e=0,r=t.length;e<r;e++)n+=String.fromCharCode(t[e]);return btoa(n)}(e.weightData));const s={format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,signature:null!=e.signature?e.signature:void 0,userDefinedMetadata:null!=e.userDefinedMetadata?e.userDefinedMetadata:void 0,modelInitializer:null!=e.modelInitializer?e.modelInitializer:void 0,initializerSignature:null!=e.initializerSignature?e.initializerSignature:void 0,trainingConfig:null!=e.trainingConfig?e.trainingConfig:void 0};return this.LS.setItem(this.keys.modelMetadata,JSON.stringify(s)),{modelArtifactsInfo:r}}catch(e){throw Us(this.keys),new Error(`Failed to save model '${this.modelPath}' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=${r.modelTopologyBytes}, weightSpecsBytes=${r.weightSpecsBytes}, weightDataBytes=${r.weightDataBytes}.`)}}}async load(){const e=JSON.parse(this.LS.getItem(this.keys.info));if(null==e)throw new Error(`In local storage, there is no model with name '${this.modelPath}'`);if("JSON"!==e.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");const t={},n=JSON.parse(this.LS.getItem(this.keys.topology));if(null==n)throw new Error(`In local storage, the topology of model '${this.modelPath}' is missing.`);t.modelTopology=n;const r=JSON.parse(this.LS.getItem(this.keys.weightSpecs));if(null==r)throw new Error(`In local storage, the weight specs of model '${this.modelPath}' are missing.`);t.weightSpecs=r;const s=this.LS.getItem(this.keys.modelMetadata);if(null!=s){const e=JSON.parse(s);t.format=e.format,t.generatedBy=e.generatedBy,t.convertedBy=e.convertedBy,null!=e.signature&&(t.signature=e.signature),null!=e.userDefinedMetadata&&(t.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(t.modelInitializer=e.modelInitializer),null!=e.initializerSignature&&(t.initializerSignature=e.initializerSignature),null!=e.trainingConfig&&(t.trainingConfig=e.trainingConfig)}const o=this.LS.getItem(this.keys.weightData);if(null==o)throw new Error(`In local storage, the binary weight values of model '${this.modelPath}' are missing.`);return t.weightData=function(e){if(gs){const t=Buffer.from(e,"base64");return t.buffer.slice(t.byteOffset,t.byteOffset+t.byteLength)}const t=atob(e),n=new Uint8Array(t.length);for(let e=0;e<t.length;++e)n.set([t.charCodeAt(e)],e);return n.buffer}(o),t}}Ks.URL_SCHEME="localstorage://";const qs=e=>{return O().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Ks.URL_SCHEME)?(t=e.slice(Ks.URL_SCHEME.length),new Ks(t)):null;var t};$s.registerSaveRouter(qs),$s.registerLoadRouter(qs);class Vs{constructor(){i(O().getBool("IS_BROWSER"),(()=>"Current environment is not a web browser")),i("undefined"==typeof window||"undefined"!=typeof window.localStorage,(()=>"Current browser does not appear to support localStorage")),this.LS=window.localStorage}async listModels(){const e={},t=Bs+Fs,n=Fs+Cs;for(let r=0;r<this.LS.length;++r){const s=this.LS.key(r);if(s.startsWith(t)&&s.endsWith(n)){e[Gs(s)]=JSON.parse(this.LS.getItem(s))}}return e}async removeModel(e){var t;const n=Ws(e=(t=e).startsWith(Ks.URL_SCHEME)?t.slice(Ks.URL_SCHEME.length):t);if(null==this.LS.getItem(n.info))throw new Error(`Cannot find model at path '${e}'`);const r=JSON.parse(this.LS.getItem(n.info));return Us(n),r}}const Hs="://";class js{constructor(){this.managers={}}static getInstance(){return null==js.instance&&(js.instance=new js),js.instance}static registerManager(e,t){i(null!=e,(()=>"scheme must not be undefined or null.")),e.endsWith(Hs)&&(e=e.slice(0,e.indexOf(Hs))),i(e.length>0,(()=>"scheme must not be an empty string."));const n=js.getInstance();i(null==n.managers[e],(()=>`A model store manager is already registered for scheme '${e}'.`)),n.managers[e]=t}static getManager(e){const t=js.getInstance().managers[e];if(null==t)throw new Error(`Cannot find model manager for scheme '${e}'`);return t}static getSchemes(){return Object.keys(js.getInstance().managers)}}function Zs(e){if(-1===e.indexOf(Hs))throw new Error(`The url string provided does not contain a scheme. Supported schemes are: ${js.getSchemes().join(",")}`);return{scheme:e.split(Hs)[0],path:e.split(Hs)[1]}}async function Js(e,t,n=!1){i(e!==t,(()=>`Old path and new path are the same: '${e}'`));const r=$s.getLoadHandlers(e);i(r.length>0,(()=>`Copying failed because no load handler is found for source URL ${e}.`)),i(r.length<2,(()=>`Copying failed because more than one (${r.length}) load handlers for source URL ${e}.`));const s=r[0],o=$s.getSaveHandlers(t);i(o.length>0,(()=>`Copying failed because no save handler is found for destination URL ${t}.`)),i(o.length<2,(()=>`Copying failed because more than one (${r.length}) save handlers for destination URL ${t}.`));const a=o[0],l=Zs(e).scheme,u=Zs(e).path,c=l===Zs(e).scheme,h=await s.load();n&&c&&await js.getManager(l).removeModel(u);const d=await a.save(h);return n&&!c&&await js.getManager(l).removeModel(u),d.modelArtifactsInfo}class Ys{constructor(){this.messageName="setTimeoutCustom",this.functionRefs=[],this.handledMessageCount=0,this.hasEventListener=!1}fetch(e,t){return fetch(e,t)}now(){return performance.now()}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error(`Browser's encoder only supports utf-8, but got ${t}`);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(e)}decode(e,t){return new TextDecoder(t).decode(e)}setTimeoutCustom(e,t){"undefined"!=typeof window&&O().getBool("USE_SETTIMEOUTCUSTOM")?(this.functionRefs.push(e),setTimeout((()=>{window.postMessage({name:this.messageName,index:this.functionRefs.length-1},"*")}),t),this.hasEventListener||(this.hasEventListener=!0,window.addEventListener("message",(e=>{if(e.source===window&&e.data.name===this.messageName){e.stopPropagation();(0,this.functionRefs[e.data.index])(),this.handledMessageCount++,this.handledMessageCount===this.functionRefs.length&&(this.functionRefs=[],this.handledMessageCount=0)}}),!0))):setTimeout(e,t)}isTypedArray(e){return e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray}}if(O().get("IS_BROWSER")){O().setPlatform("browser",new Ys);try{js.registerManager(Ks.URL_SCHEME,new Vs)}catch(e){}try{js.registerManager(Ts.URL_SCHEME,new Rs)}catch(e){}}const Xs=()=>require("node-fetch");let Qs;class eo{constructor(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}fetch(e,t){return null!=O().global.fetch?O().global.fetch(e,t):(null==Qs&&(Qs=Xs()),Qs(e,t))}now(){const e=process.hrtime();return 1e3*e[0]+e[1]/1e6}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error(`Node built-in encoder only supports utf-8, but got ${t}`);return this.textEncoder.encode(e)}decode(e,t){return 0===e.length?"":new this.util.TextDecoder(t).decode(e)}isTypedArray(e){return this.util.types.isFloat32Array(e)||this.util.types.isInt32Array(e)||this.util.types.isUint8Array(e)||this.util.types.isUint8ClampedArray(e)}}function to(e,t="float32",n){return t=t||"float32",R(e),new _r(e,t,n)}O().get("IS_NODE")&&!O().get("IS_BROWSER")&&O().setPlatform("node",new eo);const no=ls({cast_:function(e,t){const n=os(e,"x","cast");if(!w(t))throw new Error(`Failed to cast to unknown dtype ${t}`);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const r={x:n},s={dtype:t};return Jr.runKernel(oe,r,s)}});const ro=ls({clone_:function(e){const t={x:os(e,"x","clone","string_or_numeric")};return Jr.runKernel(We,t)}});function so(e,t=!1){console.log(e.toString(t))}Zr();function oo(e,t){return Jr.tidy(e,t)}function ao(e){Gr(e).forEach((e=>e.dispose()))}function io(e){return Jr.keep(e)}Nr={buffer:to,cast:no,clone:ro,print:so};const lo=ls({add_:function(e,t){let n=os(e,"a","add"),r=os(t,"b","add");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel(K,s)}});const uo=ls({floorDiv_:function(e,t){let n=os(e,"a","floorDiv"),r=os(t,"b","floorDiv");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel(Be,s)}});const co=ls({div_:function(e,t){let n=os(e,"a","div"),r=os(t,"b","div");if([n,r]=Wr(n,r),"int32"===n.dtype&&"int32"===r.dtype)return uo(n,r);const s={a:n,b:r};return Jr.runKernel(_e,s,{})}});const ho=ls({mul_:function(e,t){let n=os(e,"a","mul"),r=os(t,"b","mul");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel(ut,s)}});const po=ls({abs_:function(e){const t=os(e,"x","abs");if("complex64"===t.dtype){const e={x:t};return Jr.runKernel(ue,e)}{const e={x:t};return Jr.runKernel("Abs",e)}}});const fo=ls({acos_:function(e){const t={x:os(e,"x","acos")};return Jr.runKernel(U,t)}});const go=ls({acosh_:function(e){const t={x:os(e,"x","acosh")};return Jr.runKernel(G,t)}});const mo=ls({addN_:function(e){i(Array.isArray(e),(()=>"The argument passed to tf.addN() must be a list of tensors")),i(e.length>=1,(()=>`Must pass at least one tensor to tf.addN(), but got ${e.length}`));const t=e.map(((e,t)=>os(e,`tensors${t}`,"addN"))),n=t[0];t.forEach((e=>{if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),t.forEach((e=>{if(!h(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));const r=t;return Jr.runKernel(q,r)}});const bo=ls({all_:function(e,t=null,n=!1){const r={x:os(e,"x","all","bool")},s={axis:t,keepDims:n};return Jr.runKernel("All",r,s)}});const yo=ls({any_:function(e,t=null,n=!1){const r={x:os(e,"x","any","bool")},s={axis:t,keepDims:n};return Jr.runKernel("Any",r,s)}});const wo=ls({argMax_:function(e,t=0){const n={x:os(e,"x","argMax")},r={axis:t};return Jr.runKernel(V,n,r)}});const ko=ls({argMin_:function(e,t=0){const n={x:os(e,"x","argMin")},r={axis:t};return Jr.runKernel(H,n,r)}});const vo=ls({asin_:function(e){const t={x:os(e,"x","asin")};return Jr.runKernel(j,t)}});const xo=ls({asinh_:function(e){const t={x:os(e,"x","asinh")};return Jr.runKernel(Z,t)}});const Eo=ls({atan_:function(e){const t={x:os(e,"x","atan")};return Jr.runKernel(J,t)}});const So=ls({atan2_:function(e,t){let n=os(e,"a","atan2"),r=os(t,"b","atan2");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel(X,s)}});const $o=ls({atanh_:function(e){const t={x:os(e,"x","atanh")};return Jr.runKernel(Y,t)}});function Ao(e,t,n,r,s,o,a="channelsLast"){const[i,l]=Mo(t);let u;if("channelsLast"===a)u=[i,l,e[3],e[3]];else{if("channelsFirst"!==a)throw new Error(`Unknown dataFormat ${a}`);u=[i,l,e[1],e[1]]}return _o(e,u,n,r,s,o,!1,a)}function _o(e,t,n,r,s,o,a=!1,i="channelsLast"){let[l,u,c,h]=[-1,-1,-1,-1];if("channelsLast"===i)[l,u,c,h]=e;else{if("channelsFirst"!==i)throw new Error(`Unknown dataFormat ${i}`);[l,h,u,c]=e}const[d,p,,f]=t,[g,m]=Mo(n),[b,y]=Mo(r),w=Do(d,b),k=Do(p,y),{padInfo:v,outHeight:x,outWidth:E}=function(e,t,n,r,s,o,a,i,l){let u,c,h;if("number"==typeof e){u={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};const s=function(e,t,n,r,s){null==r&&(r=No(e,t,n));const o=e[0],a=e[1],i=Ro((o-t+2*r)/n+1,s),l=Ro((a-t+2*r)/n+1,s);return[i,l]}([t,n],o,r,e,i);c=s[0],h=s[1]}else if("same"===e){c=Math.ceil(t/r),h=Math.ceil(n/s);const e=Math.max(0,(c-1)*r+o-t),i=Math.max(0,(h-1)*s+a-n),l=Math.floor(e/2),d=e-l,p=Math.floor(i/2);u={top:l,bottom:d,left:p,right:i-p,type:"SAME"}}else if("valid"===e)u={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((t-o+1)/r),h=Math.ceil((n-a+1)/s);else{if("object"!=typeof e)throw Error(`Unknown padding parameter: ${e}`);{const d="channelsLast"===l?e[1][0]:e[2][0],p="channelsLast"===l?e[1][1]:e[2][1],f="channelsLast"===l?e[2][0]:e[3][0],g="channelsLast"===l?e[2][1]:e[3][1];u={top:d,bottom:p,left:f,right:g,type:0===d&&0===p&&0===f&&0===g?"VALID":"EXPLICIT"},c=Ro((t-o+d+p)/r+1,i),h=Ro((n-a+f+g)/s+1,i)}}return{padInfo:u,outHeight:c,outWidth:h}}(s,u,c,g,m,w,k,o,i),S=a?f*h:f;let $;return"channelsFirst"===i?$=[l,S,x,E]:"channelsLast"===i&&($=[l,x,E,S]),{batchSize:l,dataFormat:i,inHeight:u,inWidth:c,inChannels:h,outHeight:x,outWidth:E,outChannels:S,padInfo:v,strideHeight:g,strideWidth:m,filterHeight:d,filterWidth:p,effectiveFilterHeight:w,effectiveFilterWidth:k,dilationHeight:b,dilationWidth:y,inShape:e,outShape:$,filterShape:t}}function Io(e,t,n,r,s,o=!1,a="channelsLast",i){let[l,u,c,h,d]=[-1,-1,-1,-1,-1];if("channelsLast"===a)[l,u,c,h,d]=e;else{if("channelsFirst"!==a)throw new Error(`Unknown dataFormat ${a}`);[l,d,u,c,h]=e}const[p,f,g,,m]=t,[b,y,w]=To(n),[k,v,x]=To(r),E=Do(p,k),S=Do(f,v),$=Do(g,x),{padInfo:A,outDepth:_,outHeight:I,outWidth:N}=function(e,t,n,r,s,o,a,i,l,u,c){let h,d,p,f;"valid"===e&&(e=0);if("number"==typeof e){h={top:e,bottom:e,left:e,right:e,front:e,back:e,type:0===e?"VALID":"NUMBER"};const g=function(e,t,n,r,s,o){null==s&&(s=No(e,t[0],r[0]));const a=[0,0,0,n];for(let n=0;n<3;n++)e[n]+2*s>=t[n]&&(a[n]=Ro((e[n]-t[n]+2*s)/r[n]+1,o));return a}([t,n,r,1],[i,l,u],1,[s,o,a],e,c);d=g[0],p=g[1],f=g[2]}else{if("same"!==e)throw Error(`Unknown padding parameter: ${e}`);{d=Math.ceil(t/s),p=Math.ceil(n/o),f=Math.ceil(r/a);const e=(d-1)*s+i-t,c=(p-1)*o+l-n,g=(f-1)*a+u-r,m=Math.floor(e/2),b=e-m,y=Math.floor(c/2),w=c-y,k=Math.floor(g/2);h={top:y,bottom:w,left:k,right:g-k,front:m,back:b,type:"SAME"}}}return{padInfo:h,outDepth:d,outHeight:p,outWidth:f}}(s,u,c,h,b,y,w,E,S,$,i),M=o?m*d:m;let T;return"channelsFirst"===a?T=[l,M,_,I,N]:"channelsLast"===a&&(T=[l,_,I,N,M]),{batchSize:l,dataFormat:a,inDepth:u,inHeight:c,inWidth:h,inChannels:d,outDepth:_,outHeight:I,outWidth:N,outChannels:M,padInfo:A,strideDepth:b,strideHeight:y,strideWidth:w,filterDepth:p,filterHeight:f,filterWidth:g,effectiveFilterDepth:E,effectiveFilterHeight:S,effectiveFilterWidth:$,dilationDepth:k,dilationHeight:v,dilationWidth:x,inShape:e,outShape:T,filterShape:t}}function No(e,t,n,r=1){const s=Do(t,r);return Math.floor((e[0]*(n-1)-n+s)/2)}function Mo(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function To(e){return"number"==typeof e?[e,e,e]:e}function Do(e,t){return t<=1?e:e+(e-1)*(t-1)}function Ro(e,t){if(!t)return Math.trunc(e);switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error(`Unknown roundingMode ${t}`)}}function Fo(e){const[t,n,r]=Mo(e);return 1===t&&1===n&&1===r}function Bo(e,t){return Fo(e)||Fo(t)}function Co(e){return Mo(e).every((e=>e>0))}function Po(e){if("NHWC"===e)return"channelsLast";if("NCHW"===e)return"channelsFirst";throw new Error(`Unknown dataFormat ${e}`)}function Oo(e,t,n){if(null!=n){if("string"==typeof t)throw Error(`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`);if("number"==typeof t)i(d(t),(()=>`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`));else{if("object"!=typeof t)throw Error(`Error in ${e}: Unknown padding parameter: ${t}`);t.forEach((t=>{t.forEach((t=>{i(d(t),(()=>`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`))}))}))}}}const Lo=ls({reshape_:function(e,t){const n={x:os(e,"x","reshape","string_or_numeric")},r={shape:t};return Jr.runKernel(_t,n,r)}});const zo=ls({avgPool_:function(e,t,n,r,s){const o=os(e,"x","avgPool","float32");i(Bo(n,1),(()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`));let a=o,l=!1;3===o.rank&&(l=!0,a=Lo(o,[1,o.shape[0],o.shape[1],o.shape[2]])),i(4===a.rank,(()=>`Error in avgPool: x must be rank 4 but got rank ${a.rank}.`)),Oo("avgPool",r,s);const u={x:a},c={filterSize:t,strides:n,pad:r,dimRoundingMode:s};let h=Jr.runKernel(Q,u,c);return h=no(h,o.dtype),l?Lo(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const Wo=ls({avgPool3d_:function(e,t,n,r,s,o="NDHWC"){const a=os(e,"x","avgPool3d","float32");let l=a,u=!1;4===a.rank&&(u=!0,l=Lo(a,[1,a.shape[0],a.shape[1],a.shape[2],a.shape[3]])),i(5===l.rank,(()=>`Error in avgPool3d: x must be rank 5 but got rank ${l.rank}.`)),i("NDHWC"===o,(()=>`Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of ${o}`)),i("number"==typeof n&&n>0||Array.isArray(n)&&n[0]>0&&n[1]>0&&n[2]>0,(()=>`Error in avgPool3d: Stride must be > 0, but got '${n}'`)),Oo("avgPool3d",r,s);const c={x:l},h={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:o};let d=Jr.runKernel(ee,c,h);return d=no(d,l.dtype),u?Lo(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const Uo=ls({concat_:function(e,t=0){i(e.length>=1,(()=>"Pass at least one tensor to concat"));const n=as(e,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach((e=>{if("complex64"!==e.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${e.dtype}. `)})),1===n.length)return ro(n[0]);const r=n,s={axis:t};return Jr.runKernel(ce,r,s)}});const Go=ls({matMul_:function(e,t,n=!1,r=!1){let s=os(e,"a","matMul"),o=os(t,"b","matMul");[s,o]=Wr(s,o);const a={a:s,b:o},i={transposeA:n,transposeB:r};return Jr.runKernel(te,a,i)}});const Ko=ls({sigmoid_:function(e){const t={x:os(e,"x","sigmoid","float32")};return Jr.runKernel(Ut,t)}});const qo=ls({slice_:function(e,t,n){const r=os(e,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");const s={x:r},o={begin:t,size:n};return Jr.runKernel(Lt,s,o)}});const Vo=ls({tanh_:function(e){const t={x:os(e,"x","tanh","float32")};return Jr.runKernel(on,t)}});const Ho=ls({basicLSTMCell_:function(e,t,n,r,s,o){const a=os(e,"forgetBias","basicLSTMCell"),i=os(t,"lstmKernel","basicLSTMCell"),l=os(n,"lstmBias","basicLSTMCell"),u=os(r,"data","basicLSTMCell"),c=os(s,"c","basicLSTMCell"),h=os(o,"h","basicLSTMCell"),d=Uo([u,h],1),p=Go(d,i),f=lo(p,l),g=f.shape[0],m=f.shape[1]/4,b=[g,m],y=qo(f,[0,0],b),w=qo(f,[0,m],b),k=qo(f,[0,2*m],b),v=qo(f,[0,3*m],b),x=lo(ho(Ko(y),Vo(w)),ho(c,Ko(lo(a,k))));return[x,ho(Vo(x),Ko(v))]}});const jo=ls({batchToSpaceND_:function(e,t,n){const r=os(e,"x","batchToSpaceND"),s=t.reduce(((e,t)=>e*t));i(r.rank>=1+t.length,(()=>`input rank is ${r.rank} but should be > than blockShape.length ${t.length}`)),i(n.length===t.length,(()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${t.length}`)),i(r.shape[0]%s==0,(()=>`input tensor batch is ${r.shape[0]} but is not divisible by the product of the elements of blockShape ${t.join(" * ")} === ${s}`));const o={x:r},a={blockShape:t,crops:n};return Jr.runKernel(ne,o,a)}});const Zo=ls({batchNorm_:function(e,t,n,r,s,o){null==o&&(o=.001);const a=os(e,"x","batchNorm"),l=os(t,"mean","batchNorm"),u=os(n,"variance","batchNorm");let c,h;null!=s&&(c=os(s,"scale","batchNorm")),null!=r&&(h=os(r,"offset","batchNorm")),i(l.rank===u.rank,(()=>"Batch normalization gradient requires mean and variance to have equal ranks.")),i(null==h||l.rank===h.rank,(()=>"Batch normalization gradient requires mean and offset to have equal ranks.")),i(null==c||l.rank===c.rank,(()=>"Batch normalization gradient requires mean and scale to have equal ranks."));const d=function(e){let t;return t=0===e.rank||1===e.rank?Lo(e,[1,1,1,e.size]):2===e.rank?Lo(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?Lo(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e,t}(a),p={x:d,scale:c,offset:h,mean:l,variance:u},f={varianceEpsilon:o},g=Jr.runKernel(Ce,p,f);return Lo(g,a.shape)}});const Jo=ls({batchNorm2d_:function(e,t,n,r,s,o){const a=os(e,"x","batchNorm"),l=os(t,"mean","batchNorm"),u=os(n,"variance","batchNorm");let c,h;return null!=s&&(c=os(s,"scale","batchNorm")),null!=r&&(h=os(r,"offset","batchNorm")),i(2===a.rank,(()=>`Error in batchNorm2D: x must be rank 2 but got rank ${a.rank}.`)),i(2===l.rank||1===l.rank,(()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${l.rank}.`)),i(2===u.rank||1===u.rank,(()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`)),null!=c&&i(2===c.rank||1===c.rank,(()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${c.rank}.`)),null!=h&&i(2===h.rank||1===h.rank,(()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${h.rank}.`)),Zo(a,l,u,h,c,o)}});const Yo=ls({batchNorm3d_:function(e,t,n,r,s,o){const a=os(e,"x","batchNorm"),l=os(t,"mean","batchNorm"),u=os(n,"variance","batchNorm");let c,h;return null!=s&&(c=os(s,"scale","batchNorm")),null!=r&&(h=os(r,"offset","batchNorm")),i(3===a.rank,(()=>`Error in batchNorm3D: x must be rank 3 but got rank ${a.rank}.`)),i(3===l.rank||1===l.rank,(()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${l.rank}.`)),i(3===u.rank||1===u.rank,(()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`)),null!=c&&i(3===c.rank||1===c.rank,(()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${c.rank}.`)),null!=h&&i(3===h.rank||1===h.rank,(()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${h.rank}.`)),Zo(a,l,u,h,c,o)}});const Xo=ls({batchNorm4d_:function(e,t,n,r,s,o){const a=os(e,"x","batchNorm"),l=os(t,"mean","batchNorm"),u=os(n,"variance","batchNorm");let c,h;return null!=s&&(c=os(s,"scale","batchNorm")),null!=r&&(h=os(r,"offset","batchNorm")),i(4===a.rank,(()=>`Error in batchNorm4D: x must be rank 4 but got rank ${a.rank}.`)),i(4===l.rank||1===l.rank,(()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${l.rank}.`)),i(4===u.rank||1===u.rank,(()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`)),null!=c&&i(4===c.rank||1===c.rank,(()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${c.rank}.`)),null!=h&&i(4===h.rank||1===h.rank,(()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${h.rank}.`)),Zo(a,l,u,h,c,o)}});const Qo=ls({bincount_:function(e,t,n){const r=os(e,"x","bincount"),s=os(t,"weights","bincount");i("int32"===r.dtype,(()=>`Error in bincount: input dtype must be int32, but got ${r.dtype}`)),i(n>=0,(()=>`size must be non-negative, but got ${n}.`)),i(s.size===r.size||0===s.size,(()=>`Error in bincount: weights must have the same size as input or0-length, but got input shape: ${r.shape}, weights shape: ${s.shape}.`));const o={x:r,weights:s},a={size:n};return Jr.runKernel(re,o,a)}});const ea=ls({broadcastArgs_:function(e,t){const n=os(e,"s0","broadcastArgs","int32"),r=os(t,"s1","broadcastArgs","int32");if(1!==n.rank)throw new Error(`broadcastArgs(): first input must be a vector (rank=1). Has rank ${n.rank}`);if(1!==r.rank)throw new Error(`broadcastArgs(): second input must be a vector (rank=1). Has rank ${r.rank}`);const s={s0:n,s1:r};return Jr.runKernel(se,s)}});const ta=ls({broadcastTo_:function(e,t){let n=os(e,"broadcastTo","x");const r=n.shape;if(R(t),t.length<n.rank)throw new Error(`broadcastTo(): shape.length=${t.length} < input.rank=${n.rank}.`);if(t.length>n.rank){const e=n.shape.slice();for(;e.length<t.length;)e.unshift(1);n=Lo(n,e)}const s=n.shape,o=Array.from(t);for(let e=t.length-1;e>=0;e--)if(s[e]===t[e])o[e]=1;else if(1!==n.shape[e])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${t}].`);if(0===o.map(((e,t)=>e>1?t:-1)).filter((e=>e>=0)).length)return ro(n);const a={x:n},i={reps:o};return Jr.runKernel(an,a,i)}});const na=ls({ceil_:function(e){const t={x:os(e,"x","ceil","float32")};return Jr.runKernel(ae,t)}});function ra(e,t,n){R(e);const r={shape:e,value:t,dtype:n=n||$(t)};return Jr.runKernel(De,{},r)}const sa=ls({clipByValue_:function(e,t,n){const r=os(e,"x","clipByValue");if(i(t<=n,(()=>`Error in clip: min (${t}) must be less than or equal to max (${n}).`)),t===n)return ra(r.shape,t,r.dtype);const s={x:r},o={clipValueMin:t,clipValueMax:n};return Jr.runKernel(ie,s,o)}});const oa=ls({concat1d_:function(e){return Uo(e,0)}});const aa=ls({concat2d_:function(e,t){return Uo(e,t)}});const ia=ls({concat3d_:function(e,t){return Uo(e,t)}});const la=ls({concat4d_:function(e,t){return Uo(e,t)}});const ua=ls({conv2d_:function(e,t,n,r,s="NHWC",o=[1,1],a){const l=os(e,"x","conv2d","float32"),u=os(t,"filter","conv2d","float32");let c=l,h=!1;3===l.rank&&(h=!0,c=Lo(l,[1,l.shape[0],l.shape[1],l.shape[2]])),i(4===c.rank,(()=>`Error in conv2d: input must be rank 4, but got rank ${c.rank}.`)),i(4===u.rank,(()=>`Error in conv2d: filter must be rank 4, but got rank ${u.rank}.`)),Oo("conv2d",r,a);const d="NHWC"===s?c.shape[3]:c.shape[1];i(d===u.shape[2],(()=>`Error in conv2d: depth of input (${d}) must match input depth for filter ${u.shape[2]}.`)),i(Bo(n,o),(()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`)),i(Co(o),(()=>"Error in conv2D: Dilated rates should be larger than 0.")),i(Co(n),(()=>"Error in conv2D: Strides should be larger than 0."));const p={x:c,filter:u},f={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a},g=Jr.runKernel(he,p,f);return h?Lo(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const ca=ls({conv1d_:function(e,t,n,r,s="NWC",o=1,a){const l=os(e,"x","conv1d"),u=os(t,"filter","conv1d");let c=l,h=!1;2===l.rank&&(h=!0,c=Lo(l,[1,l.shape[0],l.shape[1]])),i(3===c.rank,(()=>`Error in conv1d: input must be rank 3, but got rank ${c.rank}.`)),i(3===u.rank,(()=>`Error in conv1d: filter must be rank 3, but got rank ${u.rank}.`)),Oo("conv1d",r,a),i(c.shape[2]===u.shape[1],(()=>`Error in conv1d: depth of input (${c.shape[2]}) must match input depth for filter ${u.shape[1]}.`)),i(Bo(n,o),(()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${o}'`)),i(Co(o),(()=>"Error in conv1D: Dilated rates should be larger than 0.")),i(Co(n),(()=>"Error in conv1D: Stride should be larger than 0.")),i("NWC"===s,(()=>`Error in conv1d: got dataFormat of ${s} but only NWC is currently supported.`));const d=Lo(u,[1,u.shape[0],u.shape[1],u.shape[2]]),p=Lo(c,[c.shape[0],1,c.shape[1],c.shape[2]]),f=ua(p,d,[1,n],r,"NHWC",[1,o],a);return Lo(f,h?[f.shape[2],f.shape[3]]:[f.shape[0],f.shape[2],f.shape[3]])}});const ha=ls({conv2DBackpropInput_:function(e,t,n,r,s,o="NHWC",a){i(e.length===t.rank,(()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`));let l=e,u=t,c=!1;3===t.rank&&(c=!0,u=Lo(t,[1,t.shape[0],t.shape[1],t.shape[2]]),l=[1,e[0],e[1],e[2]]),i(4===l.length,(()=>`Error in conv2dDerInput: inShape must be length 4, but got length ${l.length}.`)),i(4===u.rank,(()=>`Error in conv2dDerInput: dy must be rank 4, but got rank ${u.rank}`)),i(4===n.rank,(()=>`Error in conv2dDerInput: filter must be rank 4, but got rank ${n.rank}`));const h="NHWC"===o?l[3]:l[1],d="NHWC"===o?u.shape[3]:u.shape[1];i(h===n.shape[2],(()=>`Error in conv2dDerInput: depth of input (${h}) must match input depth for filter ${n.shape[2]}.`)),i(d===n.shape[3],(()=>`Error in conv2dDerInput: depth of output (${d}) must match output depth for filter ${n.shape[3]}.`)),Oo("conv2dDerInput",s,a);const p={dy:u,filter:n},f={strides:r,pad:s,dataFormat:o,dimRoundingMode:a,inputShape:l},g=Jr.runKernel(pe,p,f);return c?Lo(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const da=ls({conv2dTranspose_:function(e,t,n,r,s,o){const a=os(e,"x","conv2dTranspose"),i=os(t,"filter","conv2dTranspose");return ha(n,a,i,r,s,"NHWC",o)}});const pa=ls({conv3d_:function(e,t,n,r,s="NDHWC",o=[1,1,1]){const a=os(e,"x","conv3d"),l=os(t,"filter","conv3d");let u=a,c=!1;4===a.rank&&(c=!0,u=Lo(a,[1,a.shape[0],a.shape[1],a.shape[2],a.shape[3]])),i(5===u.rank,(()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`)),i(5===l.rank,(()=>`Error in conv3d: filter must be rank 5, but got rank ${l.rank}.`)),i(u.shape[4]===l.shape[3],(()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${l.shape[3]}.`)),i(Bo(n,o),(()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`)),i("NDHWC"===s,(()=>`Error in conv3d: got dataFormat of ${s} but only NDHWC is currently supported.`)),i(Co(o),(()=>"Error in conv3D: Dilated rates should be larger than 0.")),i(Co(n),(()=>"Error in conv3D: Strides should be larger than 0."));const h={x:u,filter:l},d={strides:n,pad:r,dataFormat:s,dilations:o},p=Jr.runKernel(fe,h,d);return c?Lo(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const fa=ls({conv3DBackpropInput_:function(e,t,n,r,s){i(e.length===t.rank,(()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`));let o=e,a=t,l=!1;4===t.rank&&(l=!0,a=Lo(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),o=[1,e[0],e[1],e[2],e[3]]);const u=o[4],c=a.shape[4];i(5===o.length,(()=>`Error in conv3dDerInput: inShape must be length 5, but got length ${o.length}.`)),i(5===a.rank,(()=>`Error in conv3dDerInput: dy must be rank 5, but got rank ${a.rank}`)),i(5===n.rank,(()=>`Error in conv3dDerInput: filter must be rank 5, but got rank ${n.rank}`)),i(u===n.shape[3],(()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`)),i(c===n.shape[4],(()=>`Error in conv3dDerInput: depth of output (${c}) must match output depth for filter ${n.shape[4]}.`));const h={dy:a,filter:n},d={pad:s,strides:r,inputShape:o},p=Jr.runKernel(ge,h,d);return l?Lo(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const ga=ls({conv3dTranspose_:function(e,t,n,r,s){const o=os(e,"x","conv3dTranspose"),a=os(t,"filter","conv3dTranspose");return fa(n,o,a,r,s)}});const ma=ls({cos_:function(e){const t={x:os(e,"x","cos","float32")};return Jr.runKernel("Cos",t)}});const ba=ls({cosh_:function(e){const t={x:os(e,"x","cosh","float32")};return Jr.runKernel(me,t)}});const ya=ls({cumprod_:function(e,t=0,n=!1,r=!1){const s={x:os(e,"x","cumprod")},o={axis:t,exclusive:n,reverse:r};return Jr.runKernel(be,s,o)}});const wa=ls({cumsum_:function(e,t=0,n=!1,r=!1){const s={x:os(e,"x","cumsum")},o={axis:t,exclusive:n,reverse:r};return Jr.runKernel(ye,s,o)}});const ka=ls({denseBincount_:function(e,t,n,r=!1){const s=os(e,"x","denseBincount"),o=os(t,"weights","denseBincount");i("int32"===s.dtype,(()=>`Error in denseBincount: input dtype must be int32, but got ${s.dtype}`)),i(s.rank<=2,(()=>`Error in denseBincount: input must be at most rank 2, but got rank ${s.rank}.`)),i(n>=0,(()=>`size must be non-negative, but got ${n}.`)),i(o.size===s.size||0===o.size,(()=>`Error in denseBincount: weights must have the same shape as x or 0-length, but got x shape: ${s.shape}, weights shape: ${o.shape}.`));const a={x:s,weights:o},l={size:n,binaryOutput:r};return Jr.runKernel(ke,a,l)}});const va=ls({depthToSpace_:function(e,t,n="NHWC"){const r=os(e,"x","depthToSpace","float32"),s="NHWC"===n?r.shape[1]:r.shape[2],o="NHWC"===n?r.shape[2]:r.shape[3],a="NHWC"===n?r.shape[3]:r.shape[1];i(t>1,(()=>`blockSize should be > 1 for depthToSpace, but was: ${t}`)),i(s*t>=0,(()=>`Negative dimension size caused by overflow when multiplying\n    ${s} and ${t}  for depthToSpace with input shape\n    ${r.shape}`)),i(o*t>=0,(()=>`Negative dimension size caused by overflow when multiplying\n    ${o} and ${t} for depthToSpace with input shape\n        ${r.shape}`)),i(a%(t*t)==0,(()=>`Dimension size must be evenly divisible by ${t*t} but is ${a} for depthToSpace with input shape ${r.shape}`));const l={x:r},u={blockSize:t,dataFormat:n};return Jr.runKernel(ve,l,u)}});const xa=ls({depthwiseConv2d_:function(e,t,n,r,s="NHWC",o=[1,1],a){const l=os(e,"x","depthwiseConv2d","float32"),u=os(t,"filter","depthwiseConv2d","float32");let c=l,h=!1;3===l.rank&&(h=!0,c=Lo(l,[1,l.shape[0],l.shape[1],l.shape[2]])),i(4===c.rank,(()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${c.rank}.`)),i(4===u.rank,(()=>`Error in depthwiseConv2d: filter must be rank 4, but got rank ${u.rank}.`));const d="NHWC"===s?c.shape[3]:c.shape[1];i(d===u.shape[2],(()=>`Error in depthwiseConv2d: number of input channels (${d}) must match the inChannels dimension in filter ${u.shape[2]}.`)),Oo("depthwiseConv2d",r,a);const p={x:c,filter:u},f={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a},g=Jr.runKernel(xe,p,f);return h?Lo(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const Ea=ls({diag_:function(e){const t={x:os(e,"x","diag")};return Jr.runKernel($e,t)}});const Sa=ls({dilation2d_:function(e,t,n,r,s=[1,1],o="NHWC"){const a=os(e,"x","dilation2d"),l=os(t,"filter","dilation2d");i(3===a.rank||4===a.rank,(()=>`Error in dilation2d: input must be rank 3 or 4, but got rank ${a.rank}.`)),i(3===l.rank,(()=>`Error in dilation2d: filter must be rank 3, but got rank ${l.rank}.`)),i("NHWC"===o,(()=>`Error in dilation2d: Only NHWC is currently supported, but got dataFormat of ${o}`));let u=a,c=!1;3===a.rank&&(u=Lo(a,[1,a.shape[0],a.shape[1],a.shape[2]]),c=!0),i(u.shape[3]===l.shape[2],(()=>`Error in dilation2d:  input and filter must have the same depth: ${u.shape[3]} vs ${l.shape[2]}`));const h={x:u,filter:l},d={strides:n,pad:r,dilations:s},p=Jr.runKernel(Ae,h,d);return c?Lo(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});function $a(e,t){const n=e.length,r=[];for(let s=0;s<n;s++){const o=n-1-s,a=e[o]||1;(t[t.length-1-s]||1)>1&&1===a&&r.unshift(o)}return r}function Aa(e,t){const n=[];for(let r=0;r<t.length;r++){const s=e[e.length-r-1],o=t.length-r-1,a=t[o];(null==s||1===s&&a>1)&&n.unshift(o)}return n}function _a(e,t){const n=Math.max(e.length,t.length),r=new Array(n);for(let s=0;s<n;s++){let o=e[e.length-s-1];null==o&&(o=1);let a=t[t.length-s-1];if(null==a&&(a=1),1===o)r[n-s-1]=a;else if(1===a)r[n-s-1]=o;else{if(o!==a){throw Error(`Operands could not be broadcast together with shapes ${e} and ${t}.`)}r[n-s-1]=o}}return r}var Ia={__proto__:null,getBroadcastDims:$a,getReductionAxes:Aa,assertAndGetBroadcastShape:_a};const Na=ls({equal_:function(e,t){let n=os(e,"a","equal","string_or_numeric"),r=os(t,"b","equal","string_or_numeric");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(Ne,s)}});const Ma=ls({where_:function(e,t,n){const r=os(t,"a","where"),s=os(n,"b","where"),o=os(e,"condition","where","bool"),a=_a(_a(o.shape,r.shape),s.shape),i={condition:ta(o,a),t:ta(r,a),e:ta(s,a)};return Jr.runKernel(Pt,i)}});const Ta=ls({zerosLike_:function(e){const t={x:os(e,"x","zerosLike")};return Jr.runKernel(fn,t)}});const Da=ls({divNoNan_:function(e,t){let n=os(e,"a","div"),r=os(t,"b","div");[n,r]=Wr(n,r);const s=co(n,r),o=Ta(s),a=Na(r,o);return Ma(a,o,s)}});const Ra=ls({dot_:function(e,t){const n=os(e,"t1","dot"),r=os(t,"t2","dot");i(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${r.rank}.`));const s=1===n.rank?n.size:n.shape[1],o=1===r.rank?r.size:r.shape[0];if(i(s===o,(()=>`Error in dot: inner dimensions of inputs must match, but got ${s} and ${o}.`)),1===n.rank&&1===r.rank){const e=Lo(n,[1,-1]),t=Lo(r,[-1,1]),s=Go(e,t);return Lo(s,[])}if(1===n.rank&&2===r.rank){const e=Lo(n,[1,-1]),t=Lo(r,[r.shape[0],r.shape[1]]),s=Go(e,t);return Lo(s,[s.size])}if(2===n.rank&&1===r.rank){const e=Lo(r,[-1,1]),t=Go(n,e);return Lo(t,[t.size])}{const e=Lo(r,[r.shape[0],r.shape[1]]);return Go(n,e)}}});const Fa=ls({einsum_:function(e,...t){const n=t.map(((e,t)=>os(e,`tensors${t}`,"einsum"))),r={equation:e};return Jr.runKernel(Ie,n,r)}});const Ba=ls({elu_:function(e){const t={x:os(e,"x","elu","float32")};return Jr.runKernel("Elu",t)}});const Ca=ls({erf_:function(e){let t=os(e,"x","erf");i("int32"===t.dtype||"float32"===t.dtype,(()=>"Input dtype must be `int32` or `float32`.")),"int32"===t.dtype&&(t=no(t,"float32"));const n={x:t};return Jr.runKernel("Erf",n)}});function Pa(e,t){for(let n=0;n<e.length;++n)if(e[e.length-n-1]!==t-1-n)return!1;return!0}function Oa(e,t,n){const r=e.length+t.length,s=[];let o=0,a=0;for(let i=0;i<r;i++)-1===n.indexOf(i)?s.push(e[o++]):s.push(t[a++]);return s}function La(e,t){return Oa(e,t.map((e=>1)),t)}const za=ls({max_:function(e,t=null,n=!1){const r={x:os(e,"x","max")},s={reductionIndices:t,keepDims:n};return Jr.runKernel("Max",r,s)}});const Wa=ls({min_:function(e,t=null,n=!1){const r={x:os(e,"x","min")},s={axis:t,keepDims:n};return Jr.runKernel("Min",r,s)}});const Ua=ls({pow_:function(e,t){let n=os(e,"base","pow"),r=os(t,"exp","pow");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel("Pow",s)}});function Ga(e,t){if((mr(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&mr(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return cs(e,[],[],t)}const Ka=ls({sqrt_:function(e){const t={x:os(e,"x","sqrt","float32")};return Jr.runKernel(Kt,t)}});const qa=ls({square_:function(e){const t=os(e,"x","square");return Jr.runKernel("Square",{x:t},{})}});const Va=ls({sum_:function(e,t=null,n=!1){let r=os(e,"x","sum");"bool"===r.dtype&&(r=no(r,"int32"));const s={x:r},o={axis:t,keepDims:n};return Jr.runKernel("Sum",s,o)}});function Ha(e,t,n=null){if(0===e.rank)return po(e);if(1!==e.rank&&null===n)return Ha(Lo(e,[-1]),t,n);if(1===e.rank||"number"==typeof n||Array.isArray(n)&&1===n.length){if(1===t)return Va(po(e),n);if(t===1/0)return za(po(e),n);if(t===-1/0)return Wa(po(e),n);if("euclidean"===t||2===t)return Ka(Va(Ua(po(e),Ga(2,"int32")),n));throw new Error(`Error in norm: invalid ord value: ${t}`)}if(Array.isArray(n)&&2===n.length){if(1===t)return za(Va(po(e),n[0]),n[1]-1);if(t===1/0)return za(Va(po(e),n[1]),n[0]);if(t===-1/0)return Wa(Va(po(e),n[1]),n[0]);if("fro"===t||"euclidean"===t)return Ka(Va(qa(e),n));throw new Error(`Error in norm: invalid ord value: ${t}`)}throw new Error(`Error in norm: invalid axis: ${n}`)}const ja=ls({norm_:function(e,t="euclidean",n=null,r=!1){const s=Ha(e=os(e,"x","norm"),t,n);let o=s.shape;if(r){const t=f(n,e.shape);o=La(s.shape,t)}return Lo(s,o)}});const Za=ls({euclideanNorm_:function(e,t=null,n=!1){return ja(e,"euclidean",t,n)}});const Ja=ls({exp_:function(e){const t={x:os(e,"x","exp")};return Jr.runKernel("Exp",t)}});const Ya=ls({expandDims_:function(e,t=0){const n=os(e,"x","expandDims","string_or_numeric");i(t<=n.rank,(()=>"Axis must be <= rank of the tensor"));const r={input:n},s={dim:t};return Jr.runKernel(Me,r,s)}});const Xa=ls({expm1_:function(e){const t={x:os(e,"x","expm1")};return Jr.runKernel(Te,t)}});const Qa=ls({tile_:function(e,t){const n=os(e,"x","tile","string_or_numeric");i(n.rank===t.length,(()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${t}.`));const r={x:n},s={reps:t};return Jr.runKernel(an,r,s)}});const ei=ls({eye_:function(e,t,n,r="float32"){null==t&&(t=e);const s=to([e,t],r),o=e<=t?e:t;for(let e=0;e<o;++e)s.set(1,e,e);const a=Lo(s.toTensor(),[e,t]);if(null==n)return a;if(1===n.length)return Qa(Ya(a,0),[n[0],1,1]);if(2===n.length)return Qa(Ya(Ya(a,0),0),[n[0],n[1],1,1]);if(3===n.length)return Qa(Ya(Ya(Ya(a,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});const ti=ls({floor_:function(e){const t={x:os(e,"x","floor","float32")};return Jr.runKernel(Fe,t)}});const ni=ls({gather_:function(e,t,n=0,r=0){const s={x:os(e,"x","gather"),indices:os(t,"indices","gather","int32")},o={axis:n,batchDims:r};return Jr.runKernel(Pe,s,o)}});const ri=ls({greater_:function(e,t){let n=os(e,"a","greater","string_or_numeric"),r=os(t,"b","greater","string_or_numeric");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(Le,s)}});const si=ls({greaterEqual_:function(e,t){let n=os(e,"a","greaterEqual","string_or_numeric"),r=os(t,"b","greaterEqual","string_or_numeric");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(ze,s)}});const oi=ls({imag_:function(e){const t={input:os(e,"input","imag")};return Jr.runKernel(Ge,t)}});const ai=ls({isFinite_:function(e){const t={x:os(e,"x","isFinite")};return Jr.runKernel(Ke,t)}});const ii=ls({isInf_:function(e){const t={x:os(e,"x","isInf")};return Jr.runKernel(qe,t)}});const li=ls({isNaN_:function(e){const t={x:os(e,"x","isNaN")};return Jr.runKernel(Ve,t)}});const ui=ls({leakyRelu_:function(e,t=.2){const n={x:os(e,"x","leakyRelu")},r={alpha:t};return Jr.runKernel(He,n,r)}});const ci=ls({less_:function(e,t){let n=os(e,"a","less","string_or_numeric"),r=os(t,"b","less","string_or_numeric");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(je,s)}});const hi=ls({lessEqual_:function(e,t){let n=os(e,"a","lessEqual","string_or_numeric"),r=os(t,"b","lessEqual","string_or_numeric");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(Ze,s)}});const di=ls({localResponseNormalization_:function(e,t=5,n=1,r=1,s=.5){const o=os(e,"x","localResponseNormalization");i(4===o.rank||3===o.rank,(()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${o.rank}.`)),i(d(t),(()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${t}.`));let a=o,l=!1;3===o.rank&&(l=!0,a=Lo(o,[1,o.shape[0],o.shape[1],o.shape[2]]));const u={x:a},c={depthRadius:t,bias:n,alpha:r,beta:s},h=Jr.runKernel("LRN",u,c);return l?Lo(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const pi=ls({log_:function(e){const t={x:os(e,"x","log","float32")};return Jr.runKernel("Log",t)}});const fi=ls({log1p_:function(e){const t={x:os(e,"x","log1p")};return Jr.runKernel(Ye,t)}});function gi(e,t){i(A(e),(()=>"The f passed in variableGrads(f) must be a function")),i(null==t||Array.isArray(t)&&t.every((e=>e instanceof Tr)),(()=>"The varList passed in variableGrads(f, varList) must be an array of variables"));const n=null!=t;if(!n){t=[];for(const e in Jr.registeredVariables)t.push(Jr.registeredVariables[e])}const r=n?t.filter((e=>!e.trainable)):null,s=t.length;t=t.filter((e=>e.trainable)),i(t.length>0,(()=>`variableGrads() expects at least one of the input variables to be trainable, but none of the ${s} variables is trainable.`));const{value:o,grads:a}=Jr.gradients(e,t,null,!0);i(a.some((e=>null!=e)),(()=>"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize().")),i(0===o.rank,(()=>`The f passed in variableGrads(f) must return a scalar, but it returned a rank-${o.rank} tensor`));const l={};return t.forEach(((e,t)=>{null!=a[t]&&(l[e.name]=a[t])})),null!=r&&r.forEach((e=>l[e.name]=null)),{value:o,grads:l}}function mi(e){return Jr.customGrad(e)}function bi(e){if(e.filter((e=>null==e)).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}const yi=ls({neg_:function(e){const t={x:os(e,"x","neg")};return Jr.runKernel("Neg",t)}});const wi=ls({softplus_:function(e){const t={x:os(e,"x","softplus")};return Jr.runKernel(Gt,t)}});const ki=ls({logSigmoid_:function(e){const t=os(e,"x","logSigmoid"),n=mi((e=>({value:yi(wi(yi(e))),gradFunc:t=>ho(t,Ko(yi(e)))})));return n(t)}});const vi=ls({sub_:function(e,t){let n=os(e,"a","sub"),r=os(t,"b","sub");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel("Sub",s)}});const xi=ls({logSoftmax_:function(e,t=-1){const n=os(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${t}`);const r=mi(((e,n)=>{const r=za(e,t,!0),s=vi(e,r),o=vi(no(s,"float32"),pi(Va(Ja(s),t,!0)));n([o]);return{value:o,gradFunc:(e,n)=>{const[r]=n,s=Ja(r);return vi(e,ho(Va(e,t,!0),s))}}}));return r(n)}});const Ei=ls({logSumExp_:function(e,t=null,n=!1){const r=os(e,"x","logSumExp"),s=f(t,r.shape),o=za(r,s,!0),a=vi(r,o),i=Ja(a),l=Va(i,s),u=pi(l),c=lo(Lo(o,u.shape),u);if(n){const e=La(c.shape,s);return Lo(c,e)}return c}});const Si=ls({logicalAnd_:function(e,t){const n=os(e,"a","logicalAnd","bool"),r=os(t,"b","logicalAnd","bool");_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(Xe,s)}});const $i=ls({logicalNot_:function(e){const t={x:os(e,"x","logicalNot","bool")};return Jr.runKernel(Qe,t)}});const Ai=ls({logicalOr_:function(e,t){const n=os(e,"a","logicalOr","bool"),r=os(t,"b","logicalOr","bool");_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(et,s)}});const _i=ls({logicalXor_:function(e,t){const n=os(e,"a","logicalXor","bool"),r=os(t,"b","logicalXor","bool");return _a(n.shape,r.shape),Si(Ai(e,t),$i(Si(e,t)))}}),Ii=2147483648;const Ni=ls({searchSorted_:function(e,t,n="left"){const r=os(e,"sortedSequence","searchSorted"),s=os(t,"values","searchSorted"),o=r.shape[r.shape.length-1],a=s.shape[s.shape.length-1],i=Lo(r,[-1,o]),l=Lo(s,[-1,a]);if(i.rank<2)throw new Error("Sorted input argument must be at least 2-dimensional");if(i.shape[0]!==l.shape[0])throw new Error("Leading dimension of 'sortedSequence' and 'values' must match.");if(c(l.shape)>=Ii)throw new Error("values tensor size must less than 2147483648");if(i.shape[1]>=Ii)throw new Error(`trailing dim_size must less than 2147483648 for int32 output type, was ${i.shape[1]}`);const u={sortedSequence:i,values:l},h={side:n};return Jr.runKernel(Ct,u,h)}});const Mi=ls({maxPool_:function(e,t,n,r,s){const o=os(e,"x","maxPool");let a=o,l=!1;3===o.rank&&(l=!0,a=Lo(o,[1,o.shape[0],o.shape[1],o.shape[2]])),i(4===a.rank,(()=>`Error in maxPool: input must be rank 4 but got rank ${a.rank}.`)),i(Bo(n,1),(()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`)),Oo("maxPool",r,s);const u={x:a},c={filterSize:t,strides:n,pad:r,dimRoundingMode:s},h=Jr.runKernel(nt,u,c);return l?Lo(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const Ti=ls({maxPool3d_:function(e,t=[1,1,1],n,r,s,o="NDHWC"){const a=os(e,"x","maxPool3d");let l=a,u=!1;4===a.rank&&(u=!0,l=Lo(a,[1,a.shape[0],a.shape[1],a.shape[2],a.shape[3]])),i(5===l.rank,(()=>`Error in maxPool3d: x must be rank 5 but got rank ${l.rank}.`)),i("NDHWC"===o,(()=>`Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of ${o}`)),Oo("maxPool3d",r,s);const c={x:l},h={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:o},d=Jr.runKernel(rt,c,h);return u?Lo(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const Di=ls({maxPoolWithArgmax_:function(e,t,n,r,s=!1){const o={x:os(e,"x","maxPoolWithArgmax")},a={filterSize:t,strides:n,pad:r,includeBatchInIndex:s},i=Jr.runKernel(st,o,a);return{result:i[0],indexes:i[1]}}});const Ri=ls({maximum_:function(e,t){let n=os(e,"a","maximum"),r=os(t,"b","maximum");[n,r]=Wr(n,r),"bool"===n.dtype&&(n=no(n,"int32"),r=no(r,"int32")),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(tt,s)}});const Fi=ls({mean_:function(e,t=null,n=!1){const r={x:os(e,"x","mean")},s={axis:t,keepDims:n};return Jr.runKernel(ot,r,s)}});function Bi(e,t="float32"){if(R(e),"complex64"===t){const t=Bi(e,"float32"),n=Bi(e,"float32");return us(t,n)}const n=D(c(e),t);return Jr.makeTensor(n,e,t)}function Ci(e,t="float32"){if(R(e),"complex64"===t){const t=Ci(e,"float32"),n=Bi(e,"float32");return us(t,n)}const n=T(c(e),t);return Jr.makeTensor(n,e,t)}const Pi=ls({minimum_:function(e,t){let n=os(e,"a","minimum"),r=os(t,"b","minimum");[n,r]=Wr(n,r),"bool"===n.dtype&&(n=no(n,"int32"),r=no(r,"int32")),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(at,s)}});const Oi=ls({mirrorPad_:function(e,t,n){i("reflect"===n||"symmetric"===n,(()=>`Invalid mode. Mode must be either reflect or symmetric. Got ${n}.`));const r=os(e,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");i(t.length===r.rank,(()=>`Padding doesn't match input. Must be ${r.rank}. Got ${t.length}.`));const s="reflect"===n?1:0;for(let e=0;e<r.rank;e++)i(2===t[e].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),i(t[e][0]>=0&&t[e][0]<=r.shape[e]-s&&t[e][1]>=0&&t[e][1]<=r.shape[e]-s,(()=>`Padding in dimension ${e} cannot be greater than or equal to ${r.shape[e]-s} or less than 0 for input of shape ${r.shape}`));const o={paddings:t,mode:n},a={x:r};return Jr.runKernel(it,a,o)}});const Li=ls({mod_:function(e,t){let n=os(e,"a","mod"),r=os(t,"b","mod");[n,r]=Wr(n,r);const s={a:n,b:r};return Jr.runKernel("Mod",s)}});const zi=ls({moments_:function(e,t=null,n=!1){const r=f(t,(e=os(e,"x","moments")).shape),s=Fi(e,r,n);let o=s.shape;n||(o=La(s.shape,r));const a=qa(vi(no(e,"float32"),Lo(s,o)));return{mean:s,variance:Fi(a,r,n)}}});const Wi=ls({multiRNNCell_:function(e,t,n,r){const s=os(t,"data","multiRNNCell"),o=as(n,"c","multiRNNCell"),a=as(r,"h","multiRNNCell");let i=s;const l=[];for(let t=0;t<e.length;t++){const n=e[t](i,o[t],a[t]);l.push(n[0]),l.push(n[1]),i=n[1]}const u=[],c=[];for(let e=0;e<l.length;e+=2)u.push(l[e]),c.push(l[e+1]);return[u,c]}});const Ui=ls({multinomial_:function(e,t,n,r=!1){const s=os(e,"logits","multinomial"),o=s.size,a=s.rank;if(o<2)throw new Error(`Error in multinomial: you need at least 2 outcomes, but got ${o}.`);if(a>2)throw new Error(`Rank of probabilities must be 1 or 2, but is ${a}`);n=n||Math.random();const i={logits:1===a?Lo(s,[1,-1]):s},l={numSamples:t,seed:n,normalized:r},u=Jr.runKernel(lt,i,l);return 1===a?Lo(u,[u.size]):u}});const Gi=ls({notEqual_:function(e,t){let n=os(e,"a","notEqual","string_or_numeric"),r=os(t,"b","notEqual","string_or_numeric");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(ct,s)}});const Ki=ls({oneHot_:function(e,t,n=1,r=0,s="int32"){if(t<2)throw new Error(`Error in oneHot: depth must be >=2, but it is ${t}`);const o={indices:os(e,"indices","oneHot","int32")},a={dtype:s,depth:t,onValue:n,offValue:r};return Jr.runKernel(gt,o,a)}});const qi=ls({onesLike_:function(e){const t={x:os(e,"x","onesLike")};return Jr.runKernel(ft,t)}});const Vi=ls({outerProduct_:function(e,t){const n=os(e,"v1","outerProduct"),r=os(t,"v2","outerProduct");i(1===n.rank&&1===r.rank,(()=>`Error in outerProduct: inputs must be rank 1, but got ranks ${n.rank} and ${r.rank}.`));const s=Lo(n,[-1,1]),o=Lo(r,[1,-1]);return Go(s,o)}});const Hi=ls({pad_:function(e,t,n=0){const r=os(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const s={paddings:t,constantValue:n},o={x:r};return Jr.runKernel(bt,o,s)}});const ji=ls({pad1d_:function(e,t,n=0){return i(2===t.length,(()=>"Invalid number of paddings. Must be length of 2.")),Hi(e,[t],n)}});const Zi=ls({pad2d_:function(e,t,n=0){return i(2===t.length&&2===t[0].length&&2===t[1].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),Hi(e,t,n)}});const Ji=ls({pad3d_:function(e,t,n=0){return i(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),Hi(e,t,n)}});const Yi=ls({pad4d_:function(e,t,n=0){return i(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),Hi(e,t,n)}});const Xi=ls({spaceToBatchND_:function(e,t,n){const r=os(e,"x","spaceToBatchND");i(r.rank>=1+t.length,(()=>`input rank ${r.rank} should be > than [blockShape] ${t.length}`)),i(n.length===t.length,(()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${t.length}`)),i(r.shape.reduce(((e,r,s)=>s>0&&s<=t.length?e&&(r+n[s-1][0]+n[s-1][1])%t[s-1]==0:e),!0),(()=>`input spatial dimensions ${r.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${t.toString()}`));const s={x:r},o={blockShape:t,paddings:n};return Jr.runKernel(qt,s,o)}});const Qi=ls({pool_:function(e,t,n,r,s,o,a){null==s&&(s=[1,1]),null==o&&(o=1),0===r&&(r="valid");const l=os(e,"x","maxPool");let u=l,c=!1;3===l.rank&&(c=!0,u=Lo(l,[1,l.shape[0],l.shape[1],l.shape[2]])),i(Bo(o,s),(()=>`Error in pool: Either strides or dilations must be 1. Got strides ${o} and dilations '${s}'`));const h=Ao(u.shape,t,o,s,r),d=[h.dilationHeight,h.dilationWidth];let p;p="same"===r?function(e,t){const n=e.map(((e,n)=>e+(e-1)*(t[n]-1))).map((e=>e-1)),r=n.map((e=>Math.floor(e/2))),s=n.map(((e,t)=>e-r[t]));return n.map(((e,t)=>[r[t],s[t]]))}([h.filterHeight,h.filterWidth],d):[[0,0],[0,0]];const f=1===d[0]&&1===d[1],[g,m]=function(e,t,n){const r=n.map((e=>e[0])),s=n.map((e=>e[1])),o=e.concat(r,s),a=t.map(((e,t)=>(e-o[t]%e)%e)),i=s.map(((e,t)=>e+a[t])),l=t.map(((e,t)=>[r[t],i[t]])),u=t.map(((e,t)=>[0,a[t]]));return[l,u]}([h.inHeight,h.inWidth],d,p),b=f?r:"valid",y=f?u:Xi(u,d,g),w=("avg"===n?()=>zo(y,t,o,b,a):()=>Mi(y,t,o,b,a))(),k=f?w:jo(w,d,m);return c?Lo(k,[k.shape[1],k.shape[2],k.shape[3]]):k}});const el=ls({prelu_:function(e,t){const n={x:os(e,"x","prelu"),alpha:os(t,"alpha","prelu")};return Jr.runKernel(yt,n)}});const tl=ls({prod_:function(e,t=null,n=!1){let r=os(e,"x","prod");"bool"===r.dtype&&(r=no(r,"int32"));const s={x:r},o={axis:t,keepDims:n};return Jr.runKernel(wt,s,o)}});const nl=ls({raggedGather_:function(e,t,n,r){const s={paramsNestedSplits:e.map(((e,t)=>os(e,`tensors${t}`,"raggedGather","int32"))),paramsDenseValues:os(t,"paramsDenseValues","raggedGather"),indices:os(n,"indices","raggedGather","int32")},o={outputRaggedRank:r},a=Jr.runKernel(kt,s,o);return{outputNestedSplits:a.slice(0,a.length-1),outputDenseValues:a[a.length-1]}}});const rl=ls({raggedRange_:function(e,t,n){const r=os(e,"starts","raggedRange"),s={starts:r,limits:os(t,"limits","raggedRange",r.dtype),deltas:os(n,"deltas","raggedRange",r.dtype)},o=Jr.runKernel(vt,s);return{rtNestedSplits:o[0],rtDenseValues:o[1]}}});const sl=ls({raggedTensorToTensor_:function(e,t,n,r,s){const o=os(e,"shape","raggedTensorToTensor","int32"),a=os(t,"values","raggedTensorToTensor"),i={shape:o,values:a,defaultValue:os(n,"defaultValue","raggedTensorToTensor",a.dtype),rowPartitionTensors:r.map(((e,t)=>os(e,`tensors${t}`,"raggedTensorToTensor","int32")))},l={rowPartitionTypes:s};return Jr.runKernel(xt,i,l)}});const ol=ls({rand_:function(e,t,n){R(e);const r=c(e);let s=null;if(null==n||"float32"===n)s=new Float32Array(r);else if("int32"===n)s=new Int32Array(r);else{if("bool"!==n)throw new Error(`Unknown data type ${n}`);s=new Uint8Array(r)}for(let e=0;e<r;e++)s[e]=t();return Jr.makeTensor(s,e,n)}});var al="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function il(e){var t={exports:{}};return e(t,t.exports),t.exports}var ll=il((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=String(e);for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function s(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function o(e,t){var n=new r(e),o=t&&t.state,a=n.next;return a.int32=function(){return 4294967296*n.next()|0},a.double=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.alea=o}(0,e,!1)})),ul=il((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor128=o}(0,e,!1)})),cl=il((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorwow=o}(0,e,!1)})),hl=il((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,s=t.i;return e=r[s],n=(e^=e>>>7)^e<<24,n^=(e=r[s+1&7])^e>>>10,n^=(e=r[s+3&7])^e>>>3,n^=(e=r[s+4&7])^e<<7,e=r[s+7&7],n^=(e^=e<<13)^e<<9,r[s]=n,t.i=s+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n&&(r[7]=-1),e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function s(e,t){return t.x=e.x.slice(),t.i=e.i,t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&(o.x&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorshift7=o}(0,e,!1)})),dl=il((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,s=t.X,o=t.i;return t.w=r=r+1640531527|0,n=s[o+34&127],e=s[o=o+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=s[o]=n^e,t.i=o,n+(r^r>>>16)|0},function(e,t){var n,r,s,o,a,i=[],l=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,l=Math.max(l,t.length)),s=0,o=-32;o<l;++o)t&&(r^=t.charCodeAt((o+32)%t.length)),0===o&&(a=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,o>=0&&(a=a+1640531527|0,s=0==(n=i[127&o]^=r+a)?s+1:0);for(s>=128&&(i[127&(t&&t.length||0)]=-1),s=127,o=512;o>0;--o)r=i[s+34&127],n=i[s=s+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[s]=r^n;e.w=a,e.X=i,e.i=s}(t,e)}function s(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&(o.X&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor4096=o}(0,e,!1)})),pl=il((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,s=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^s,s=s-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^s,t.a=s-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.tychei=o}(0,e,!1)})),fl=il((function(e){!function(t,n,r){var s,o=256,a=r.pow(o,6),i=r.pow(2,52),l=2*i,u=255;function c(e,u,c){var m=[],b=f(p((u=1==u?{entropy:!0}:u||{}).entropy?[e,g(n)]:null==e?function(){try{var e;return s&&(e=s.randomBytes)?e=e(o):(e=new Uint8Array(o),(t.crypto||t.msCrypto).getRandomValues(e)),g(e)}catch(e){var r=t.navigator,a=r&&r.plugins;return[+new Date,t,a,t.screen,g(n)]}}():e,3),m),y=new h(m),w=function(){for(var e=y.g(6),t=a,n=0;e<i;)e=(e+n)*o,t*=o,n=y.g(1);for(;e>=l;)e/=2,t/=2,n>>>=1;return(e+n)/t};return w.int32=function(){return 0|y.g(4)},w.quick=function(){return y.g(4)/4294967296},w.double=w,f(g(y.S),n),(u.pass||c||function(e,t,n,s){return s&&(s.S&&d(s,y),e.state=function(){return d(y,{})}),n?(r.random=e,t):e})(w,b,"global"in u?u.global:this==r,u.state)}function h(e){var t,n=e.length,r=this,s=0,a=r.i=r.j=0,i=r.S=[];for(n||(e=[n++]);s<o;)i[s]=s++;for(s=0;s<o;s++)i[s]=i[a=u&a+e[s%n]+(t=i[s])],i[a]=t;(r.g=function(e){for(var t,n=0,s=r.i,a=r.j,i=r.S;e--;)t=i[s=u&s+1],n=n*o+i[u&(i[s]=i[a=u&a+t])+(i[a]=t)];return r.i=s,r.j=a,n})(o)}function d(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function p(e,t){var n,r=[],s=typeof e;if(t&&"object"==s)for(n in e)try{r.push(p(e[n],t-1))}catch(e){}return r.length?r:"string"==s?e:e+"\0"}function f(e,t){for(var n,r=e+"",s=0;s<r.length;)t[u&s]=u&(n^=19*t[u&s])+r.charCodeAt(s++);return g(t)}function g(e){return String.fromCharCode.apply(0,e)}if(f(r.random(),n),e.exports){e.exports=c;try{s=require("crypto")}catch(e){}}else r.seedrandom=c}("undefined"!=typeof self?self:al,[],Math)}));fl.alea=ll,fl.xor128=ul,fl.xorwow=cl,fl.xorshift7=hl,fl.xor4096=dl,fl.tychei=pl;var gl=fl;function ml(){return 32===Jr.backend.floatPrecision()?.001:.1}function bl(e,t,n){let r=!0;if((mr(e)||mr(t))&&(r=!1),mr(e)&&mr(t)&&(r=!0),r){const n=e.constructor.name,r=t.constructor.name;if(n!==r)throw new Error(`Arrays are of different type. Actual: ${n}. Expected: ${r}`)}if(Array.isArray(e)&&Array.isArray(t)){const n=ns(e),r=ns(t);if(!h(n,r))throw new Error(`Arrays have different shapes. Actual: [${n}]. Expected: [${r}]`)}const s=mr(e)?e:br(e),o=mr(t)?t:br(t);if(s.length!==o.length)throw new Error(`Arrays have different lengths actual: ${s.length} vs expected: ${o.length}.\nActual:   ${s}.\nExpected: ${o}.`);for(let e=0;e<o.length;++e){const t=s[e],r=o[e];if(!n(t,r))throw new Error(`Arrays differ: actual[${e}] = ${t}, expected[${e}] = ${r}.\nActual:   ${s}.\nExpected: ${o}.`)}"undefined"!=typeof expect&&expect().nothing()}function yl(e,t,n){return!isFinite(e)&&!isFinite(t)||!(isNaN(e)||isNaN(t)||Math.abs(e-t)>n)}var wl={__proto__:null,TEST_EPSILON_FLOAT16:.1,expectArraysClose:function(e,t,n){return null==n&&(n=ml()),bl(e,t,((e,t)=>yl(e,t,n)))},testEpsilon:ml,expectPromiseToFail:function(e,t){e().then((()=>t.fail()),(()=>t())),"undefined"!=typeof expect&&expect().nothing()},expectArraysEqual:function(e,t){const n="string"==typeof t||"number"==typeof t||"boolean"==typeof t?[t]:t;return x(e)||x(e[0])||x(t)||x(t[0])?bl(e,n,((e,t)=>e==t)):bl(e,t,((e,t)=>yl(e,t,0)))},expectNumbersClose:function(e,t,n){if(null==n&&(n=ml()),!yl(e,t,n))throw new Error(`Numbers differ: actual === ${e}, expected === ${t}`);"undefined"!=typeof expect&&expect().nothing()},expectValuesInRange:function(e,t,n){for(let r=0;r<e.length;r++)if(e[r]<t||e[r]>n)throw new Error(`Value out of range:${e[r]} low: ${t}, high: ${n}`)},expectArrayBuffersEqual:function(e,t){const n=new Float32Array(e),r=new Float32Array(t);if(n.length!==r.length)throw new Error(`Expected ArrayBuffer to be of length ${r.length}, but it was ${n.length}`);for(let e=0;e<r.length;e++)if(n[e]!==r[e])throw new Error(`Expected ArrayBuffer value at ${e} to be ${r[e]} but got ${n[e]} instead`)},encodeStrings:function e(t){for(let n=0;n<t.length;n++){const r=t[n];Array.isArray(r)?e(r):t[n]=fr(r)}return t},createVideoElement:function(e){const t=document.createElement("video");return"playsInline"in t&&(t.playsInline=!0),t.muted=!0,t.loop=!0,t.style.position="fixed",t.style.left="0px",t.style.top="0px",t.preload="auto",t.appendChild(e),new Promise((e=>{t.addEventListener("loadeddata",(n=>e(t))),t.load()}))},play:async function(e){await e.play(),"requestVideoFrameCallback"in e&&await new Promise((t=>{e.requestVideoFrameCallback(t)}))}};class kl{constructor(e,t,n,r,s){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const o=s||Math.random();this.random=gl.alea(o.toString())}nextValue(){if(!isNaN(this.nextVal)){const e=this.nextVal;return this.nextVal=NaN,e}let e,t,n=!1;for(;!n;){let r,s,o;do{r=2*this.random()-1,s=2*this.random()-1,o=r*r+s*s}while(o>=1||0===o);const a=Math.sqrt(-2*Math.log(o)/o);e=this.mean+this.stdDev*r*a,t=this.mean+this.stdDev*s*a,this.truncated&&!this.isValidTruncated(e)||(n=!0)}return this.truncated&&!this.isValidTruncated(t)||(this.nextVal=this.convertValue(t)),this.convertValue(e)}convertValue(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)}isValidTruncated(e){return e<=this.upper&&e>=this.lower}}class vl{constructor(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;const s=r||Math.random();this.randu=gl.alea(s.toString()),this.randn=new kl(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}nextValue(){let e,t,n,r,s,o;for(;;){do{r=this.randn.nextValue(),o=1+this.c*r}while(o<=0);if(o*=o*o,e=r*r,t=1-.331*e*e,n=.5*e+this.d*(1-o+Math.log(o)),s=this.randu(),s<t||Math.log(s)<n)break}return o=1/this.beta*this.d*o,this.alpha<1&&(o*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(o)}convertValue(e){return"float32"===this.dtype?e:Math.round(e)}}class xl{constructor(e=0,t=1,n,r){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${e} - ${t} <= 1 and dtype is not float`);this.random=gl.alea(r)}convertValue(e){return this.canReturnFloat()?e:Math.round(e)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const El=ls({randomGamma_:function(e,t,n=1,r="float32",s){if(R(e),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error(`Unsupported data type ${r}`);const o=new vl(t,n,r,s),a=to(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const Sl=ls({randomNormal_:function(e,t=0,n=1,r,s){if(R(e),null!=r&&"bool"===r)throw new Error(`Unsupported data type ${r}`);const o=new kl(t,n,r,!1,s),a=to(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const $l=ls({randomStandardNormal_:function(e,t,n){if(null!=t&&"bool"===t)throw new Error(`Unsupported data type ${t}`);return Sl(e,0,1,t,n)}});const Al=ls({randomUniform_:function(e,t=0,n=1,r="float32",s){R(e);const o=to(e,r),a=new xl(t,n,null,s);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});function _l(e,t,n=1,r="float32"){if(0===n)throw new Error("Cannot have a step of zero");const s={start:e,stop:t,step:n,dtype:r};return Jr.runKernel(Et,{},s)}const Il=ls({real_:function(e){const t={input:os(e,"input","real")};return Jr.runKernel(St,t)}});const Nl=ls({reciprocal_:function(e){const t={x:os(e,"x","reciprocal")};return Jr.runKernel($t,t)}});const Ml=ls({relu_:function(e){const t={x:os(e,"x","relu")};return Jr.runKernel(At,t)}});const Tl=ls({relu6_:function(e){const t={x:os(e,"x","relu6")};return Jr.runKernel(Mt,t)}});const Dl=ls({reverse_:function(e,t){const n={x:os(e,"x","reverse")},r={dims:t};return Jr.runKernel(Tt,n,r)}});const Rl=ls({reverse1d_:function(e){const t=os(e,"x","reverse");return i(1===t.rank,(()=>`Error in reverse1D: x must be rank 1 but got rank ${t.rank}.`)),Dl(t,0)}});const Fl=ls({reverse2d_:function(e,t){const n=os(e,"x","reverse");return i(2===n.rank,(()=>`Error in reverse2D: x must be rank 2 but got rank ${n.rank}.`)),Dl(n,t)}});const Bl=ls({reverse3d_:function(e,t){const n=os(e,"x","reverse");return i(3===n.rank,(()=>`Error in reverse3D: x must be rank 3 but got rank ${n.rank}.`)),Dl(n,t)}});const Cl=ls({reverse4d_:function(e,t){const n=os(e,"x","reverse");return i(4===n.rank,(()=>`Error in reverse4D: x must be rank 4 but got rank ${n.rank}.`)),Dl(n,t)}});const Pl=ls({round_:function(e){const t={x:os(e,"x","round")};return Jr.runKernel(Dt,t)}});const Ol=ls({rsqrt_:function(e){const t={x:os(e,"x","rsqrt","float32")};return Jr.runKernel(Rt,t)}});const Ll=ls({selu_:function(e){const t={x:os(e,"x","selu")};return Jr.runKernel(Ot,t)}});const zl=ls({separableConv2d_:function(e,t,n,r,s,o=[1,1],a="NHWC"){const l=os(e,"x","separableConv2d"),u=os(t,"depthwiseFilter","separableConv2d"),c=os(n,"pointwiseFilter","separableConv2d");let h=l,d=!1;if(3===l.rank&&(d=!0,h=Lo(l,[1,l.shape[0],l.shape[1],l.shape[2]])),"NCHW"===a)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");i(4===h.rank,(()=>`Error in separableConv2d: input must be rank 4, but got rank ${h.rank}.`)),i(4===u.rank,(()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`)),i(4===c.rank,(()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`)),i(1===c.shape[0],(()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${c.shape[0]}.`)),i(1===c.shape[1],(()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${c.shape[1]}.`));const p=u.shape[2],f=u.shape[3];i(c.shape[2]===p*f,(()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${p*f}, but got ${c.shape[2]}.`));const g=xa(h,u,r,s,a,o),m=ua(g,c,1,"valid",a);return d?Lo(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const Wl=async function(e,t){const n=os(e,"x","setdiff1d"),r=os(t,"y","setdiff1d");i(n.dtype===r.dtype,(()=>`x and y should have the same dtype, but got x (${n.dtype}) and y (${r.dtype}).`)),i(1===n.rank,(()=>`x should be 1D tensor, but got x (${n.shape}).`)),i(1===r.rank,(()=>`y should be 1D tensor, but got y (${r.shape}).`));const s=await n.data(),o=await r.data(),a=new Set(o);let l=0;for(let e=0;e<s.length;e++)a.has(s[e])||l++;const u=new _r([l],n.dtype),c=new _r([l],"int32");for(let e=0,t=0;e<s.length;e++)a.has(s[e])||(u.values[t]=s[e],c.values[t]=e,t++);return[u.toTensor(),c.toTensor()]};const Ul=ls({sign_:function(e){const t={x:os(e,"x","sign")};return Jr.runKernel(Wt,t)}});const Gl=ls({sin_:function(e){const t={x:os(e,"x","sin","float32")};return Jr.runKernel("Sin",t)}});const Kl=ls({sinh_:function(e){const t={x:os(e,"x","sinh")};return Jr.runKernel(zt,t)}});const ql=ls({slice1d_:function(e,t,n){const r=os(e,"x","slice1d");return i(1===r.rank,(()=>`slice1d expects a rank-1 tensor, but got a rank-${r.rank} tensor`)),qo(r,[t],[n])}});const Vl=ls({slice2d_:function(e,t,n){const r=os(e,"x","slice2d");return i(2===r.rank,(()=>`slice2d expects a rank-2 tensor, but got a rank-${r.rank} tensor`)),qo(r,t,n)}});const Hl=ls({slice3d_:function(e,t,n){const r=os(e,"x","slice3d");return i(3===r.rank,(()=>`slice3d expects a rank-3 tensor, but got a rank-${r.rank} tensor`)),qo(r,t,n)}});const jl=ls({slice4d_:function(e,t,n){const r=os(e,"x","slice4d");return i(4===r.rank,(()=>`slice4d expects a rank-4 tensor, but got a rank-${r.rank} tensor`)),qo(r,t,n)}});const Zl=ls({softmax_:function(e,t=-1){const n=os(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${t}`);const r={logits:n},s={dim:t};return Jr.runKernel(Ht,r,s)}});const Jl=ls({fft_:function(e){i("complex64"===e.dtype,(()=>`The dtype for tf.spectral.fft() must be complex64 but got ${e.dtype}.`));const t={input:e};return Jr.runKernel("FFT",t)}});const Yl=ls({ifft_:function(e){i("complex64"===e.dtype,(()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${e.dtype}.`));const t={input:e};return Jr.runKernel(Ue,t)}});const Xl=ls({irfft_:function(e){const t=e.shape[e.shape.length-1],n=e.size/t;let r;if(t<=2){const s=Lo(e,[n,t]);r=Yl(s)}else{const s=[n,2*(t-1)],o=Lo(Il(e),[n,t]),a=Lo(oi(e),[n,t]),i=Dl(qo(o,[0,1],[n,t-2]),1),l=ho(Dl(qo(a,[0,1],[n,t-2]),1),Ga(-1)),u=Uo([o,i],1),c=Uo([a,l],1),h=Lo(us(u,c),[s[0],s[1]]);r=Yl(h)}if(r=Il(r),3===e.rank&&0!==e.shape[0]){const t=r,n=e.shape[0];r=Lo(r,[n,r.shape[0]/n,r.shape[1]]),t.dispose()}return r}});const Ql=ls({split_:function(e,t,n=0){const r={x:os(e,"x","split")},s={numOrSizeSplits:t,axis:n};return Jr.runKernel(Vt,r,s)}});const eu=ls({rfft_:function(e,t){i("float32"===e.dtype,(()=>`The dtype for rfft() must be real value but got ${e.dtype}`));let n=e.shape[e.shape.length-1];const r=e.size/n;let s;if(null!=t&&t<n){const r=e.shape.map((e=>0)),o=e.shape.map((e=>e));o[e.shape.length-1]=t,s=qo(e,r,o),n=t}else if(null!=t&&t>n){const r=e.shape.map((e=>e));r[e.shape.length-1]=t-n,s=Uo([e,Bi(r)],e.shape.length-1),n=t}else s=e;const o=Ta(s),a=Lo(us(s,o),[r,n]),l=Jl(a),u=Math.floor(n/2)+1,c=Il(l),h=oi(l),d=Ql(c,[u,n-u],c.shape.length-1),p=Ql(h,[u,n-u],h.shape.length-1),f=s.shape.slice();return f[s.shape.length-1]=u,Lo(us(d[0],p[0]),f)}});const tu=ls({squaredDifference_:function(e,t){let n=os(e,"a","squaredDifference"),r=os(t,"b","squaredDifference");[n,r]=Wr(n,r),_a(n.shape,r.shape);const s={a:n,b:r};return Jr.runKernel(Qt,s,{})}});const nu=ls({squeeze_:function(e,t){const n=os(e,"x","squeeze","string_or_numeric");return Lo(n,g(n.shape,t).newShape)}});const ru=ls({stack_:function(e,t=0){const n=as(e,"tensors","stack","string_or_numeric");i(n.length>=1,(()=>"Pass at least one tensor to tf.stack")),n.length>0&&i(t<=n[0].rank,(()=>"Axis must be <= rank of the tensor"));const r=n,s={axis:t};return Jr.runKernel(mt,r,s)}});const su=ls({step_:function(e,t=0){const n={x:os(e,"x","step")},r={alpha:t};return Jr.runKernel(gn,n,r)}});const ou=ls({stridedSlice_:function(e,t,n,r,s=0,o=0,a=0,i=0,l=0){const u={x:os(e,"x","stridedSlice","string_or_numeric")},c={begin:t,end:n,strides:r,beginMask:s,endMask:o,ellipsisMask:a,newAxisMask:i,shrinkAxisMask:l};return Jr.runKernel(tn,u,c)}});const au=ls({tan_:function(e){const t={x:os(e,"x","tan","float32")};return Jr.runKernel("Tan",t)}});function iu(e,t){u(e);const n=ns(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return cs(e,null,n,t)}function lu(e,t,n){if(u(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");const r=ns(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return cs(e,t,r,n)}function uu(e,t,n){if(u(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");const r=ns(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return cs(e,t,r,n)}function cu(e,t,n){const r=t.rank>1?t.shape[t.rank-1]:1,s=t.rank>1?t.rank-1:1,o=`Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: ${n.shape}, indices.shape: ${t.shape}, shape: ${e}, sliceDim: ${r}, and batchDim: ${s}.`;if(n.rank<s)throw new Error(o+` update.rank < ${s}. `);if(e.length<r+(n.rank-s))throw new Error(o+` Output shape length < ${r+(n.rank-s)}`);if(n.rank!==s+e.length-r)throw new Error(o+" update.rank != "+(s+e.length-r));for(let e=0;e<s;++e)if(n.shape[e]!==t.shape[e])throw new Error(o+` updates.shape[${e}] (${n.shape[e]}) != indices.shape[${e}] (${t.shape[e]}).`);for(let t=0;t<n.rank-s;++t)if(n.shape[t+s]!==e[t+r])throw new Error(o+` updates.shape[${t+s}] (${n.shape[t+s]}) != shape[${t+s}] (${e[t+s]})`)}function hu(e,t,n){if(t.rank<1)throw new Error(`tf.scatterND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if(e.rank<1)throw new Error(`tf.scatterND() expects the updates to be rank 1 or higher, but the rank was ${e.rank}.`);if("int32"!==t.dtype)throw new Error(`The dtype of 'indices' should be int32, but got dtype: ${t.dtype}`);if(n.length<1)throw new Error(`Output rank must be greater or equal to 1, but got shape: ${n}`);if(0===n.length){if(0===t.size)throw new Error(`Indices specified for empty output. indices shape: ${t.shape}`);if(0===e.size)throw new Error(`Updates specified for empty output. updates shape: ${e.shape}`)}cu(n,t,e)}function du(e,t,n){const r=t.shape.length,s=r>1?t.shape[r-1]:1,o=n.length;let a=1;for(let e=s;e<o;++e)a*=n[e];const i=s<1?1:s;return{sliceRank:s,numUpdates:c(t.shape)/i,sliceSize:a,strides:[...I(n.slice(0,s)),1],outputSize:c(n)}}var pu={__proto__:null,validateUpdateShape:cu,validateInput:hu,calculateShapes:du};const fu=ls({tensorScatterUpdate_:function(e,t,n){const r=os(e,"tensor","tensorScatterupdate"),s=os(t,"indices","tensorScatterupdate","int32"),o=os(n,"updates","tensorScatterupdate");if(hu(o,s,r.shape),r.dtype!==o.dtype)throw new Error(`tensor and updates must have the same dtype, instead they are ${r.dtype} and ${o.dtype}.`);const a={tensor:r,indices:s,updates:o};return Jr.runKernel(Bt,a,{})}});const gu=ls({topk_:function(e,t=1,n=!0){const r=os(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const s=r.shape[r.shape.length-1];if(t<0)throw new Error(`'k' passed to topk() must be >= 0 but got ${t}`);if(t>s)throw new Error(`'k' passed to topk() must be <= the last dimension (${s}) but got ${t}`);const o={x:r},a={k:t,sorted:n},[i,l]=Jr.runKernel(ln,o,a);return{values:i,indices:l}}});const mu=ls({truncatedNormal_:function(e,t=0,n=1,r,s){if(R(e),null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");const o=new kl(t,n,r,!0,s),a=to(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const bu=ls({unique_:function(e,t=0){const n=os(e,"x","unique","string_or_numeric");i(n.rank>0,(()=>"The input tensor must be at least 1D"));const r={x:n},s={axis:t},[o,a]=Jr.runKernel(hn,r,s);return{values:o,indices:a}}});const yu=ls({unsortedSegmentSum_:function(e,t,n){const r=os(e,"x","unsortedSegmentSum"),s=os(t,"segmentIds","unsortedSegmentSum","int32");i(d(n),(()=>"numSegments must be of dtype int"));const o={x:r,segmentIds:s},a={numSegments:n};return Jr.runKernel(pn,o,a)}});const wu=ls({unstack_:function(e,t=0){const n=os(e,"x","unstack","string_or_numeric");i(t>=-n.shape.length&&t<n.shape.length,(()=>`Axis = ${t} is not in [-${n.shape.length}, ${n.shape.length})`));const r={value:n},s={axis:t};return Jr.runKernel(dn,r,s)}});function ku(e,t){const n=[];for(let e=0;e<t.length;e++)t[e]&&n.push(e);const r=to(e,"int32"),s=to([n.length,e.length],"int32");for(let t=0;t<n.length;t++){const o=r.indexToLoc(n[t]),a=t*e.length;s.values.set(o,a)}return s.toTensor()}const vu=async function(e){const t=os(e,"condition","whereAsync","bool"),n=await t.data(),r=ku(t.shape,n);return e!==t&&t.dispose(),r};const xu=async function(e,t,n){const r=os(e,"tensor","boolMask"),s=os(t,"mask","boolMask","bool"),o=null==n?0:n,a=s.rank,u=r.shape;i(a>0,(()=>"mask cannot be scalar")),l(u.slice(o,o+a),s.shape,"mask's shape must match the first K dimensions of tensor's shape,");let c=1;for(let e=o;e<o+a;e++)c*=u[e];const h=u.slice(0,o).concat([c],u.slice(o+a)),d=Lo(r,h),p=Lo(s,[-1]),f=await vu(p),g=nu(f,[1]),m=ni(d,g,o);return e!==r&&r.dispose(),t!==s&&s.dispose(),g.dispose(),d.dispose(),p.dispose(),f.dispose(),m};const Eu=ls({transpose_:function(e,t,n){const r=os(e,"x","transpose");if(null==t&&(t=r.shape.map(((e,t)=>t)).reverse()),i(r.rank===t.length,(()=>`Error in transpose: rank of input ${r.rank} must match length of perm ${t}.`)),t.forEach((e=>{i(e>=0&&e<r.rank,(()=>"All entries in 'perm' must be between 0 and "+(r.rank-1)+` but got ${t}`))})),r.rank<=1)return r.clone();const s={x:r},o={perm:t};return"complex64"===r.dtype?oo((()=>{let e=Il(r),t=oi(r);return e=Jr.runKernel(cn,{x:e},o),t=Jr.runKernel(cn,{x:t},o),n&&(t=yi(t)),us(e,t)})):Jr.runKernel(cn,s,o)}});const Su=ls({movingAverage_:function(e,t,n,r,s=!0){const o=os(e,"v","movingAverage"),a=os(t,"x","movingAverage"),l=os(n,"decay","movingAverage");Ur(o,a),i(h(o.shape,a.shape),(()=>"Shape mismatch in v and x"));const u=Ga(1),c=vi(u,l);let d=ho(vi(a,o),c);if(s){i(null!=r,(()=>"When using zeroDebias: true, step is required."));const e=os(r,"step","movingAverage");d=co(d,vi(u,Ua(l,e)))}return lo(o,d)}});const $u=ls({scatterND_:function(e,t,n){R(n);const r=os(e,"indices","scatterND","int32"),s=os(t,"updates","scatterND");hu(s,r,n);const o={indices:r,updates:s},a={shape:n};return Jr.runKernel(Ft,o,a)}});const Au=ls({sparseToDense_:function(e,t,n,r=0){R(n);const s=os(e,"sparseIndices","sparseToDense","int32"),o=os(t,"sparseValues","sparseToDense","string_or_numeric"),a=os(r,"defaultValue","sparseToDense",o.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error(`tf.sparseToDense() expects the indices to be int32 type, but the dtype was ${e.dtype}.`);if(e.rank>2)throw new Error(`sparseIndices should be a scalar, vector, or matrix, but got shape ${e.shape}.`);const s=e.rank>0?e.shape[0]:1,o=e.rank>1?e.shape[1]:1;if(n.length!==o)throw new Error(`outputShape has incorrect number of elements:, ${n.length}, should be: ${o}.`);const a=t.size;if(0!==t.rank&&(1!==t.rank||a!==s))throw new Error(`sparseValues has incorrect shape ${t.shape}, should be [] or [${s}]`);if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(s,o,n,a);const i={sparseIndices:s,sparseValues:o,defaultValue:a},l={outputShape:n};return Jr.runKernel(Xt,i,l)}});const _u=ls({gatherND_:function(e,t){const n=os(t,"indices","gatherND","int32"),r={params:os(e,"x","gatherND","string_or_numeric"),indices:n};return Jr.runKernel(Oe,r)}});const Iu=ls({dropout_:function(e,t,n,r){const s=os(e,"x","dropout");if(i("float32"===s.dtype,(()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${s.dtype} tensor instead.`)),i(t>=0&&t<1,(()=>`rate must be a float in the range [0, 1), but got ${t}.`)),0===t)return e instanceof Mr?s.clone():s;const o=function(e,t){if(null==t)return e.shape.slice();if(h(e.shape,t))return t;if(e.shape.length===t.length){const n=[];for(let r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(s,n),a=1-t,l=co(ti(lo(Al(o,0,1,"float32",r),a)),a);return ho(s,l)}});function Nu(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function Mu(e,t,n){const r=1-e%2,s=new Float32Array(e);for(let o=0;o<e;++o){const a=2*Math.PI*o/(e+r-1);s[o]=t-n*Math.cos(a)}return iu(s,"float32")}const Tu=async function(e,t,n=1){const r=os(e,"predictions","inTopK"),s=os(t,"targets","inTopK");i(r.rank>1,(()=>`inTopK() expects the predictions to be of rank 2 or higher, but got ${r.rank}`)),i(r.rank-1===s.rank,(()=>`predictions rank should be 1 larger than targets rank, but got predictions rank ${r.rank} and targets rank ${s.rank}`)),l(r.shape.slice(0,r.shape.length-1),s.shape,"predictions's shape should be align with the targets' shape, except the last dimension.");const o=r.shape[r.shape.length-1];i(n>0&&n<=o,(()=>`'k' passed to inTopK() must be > 0 && <= the predictions last dimension (${o}), but got ${n}`));const a=await r.data(),u=await s.data(),[c,h]=[a.length/o,o],d=m("bool",c);for(let e=0;e<c;e++){const t=e*h,r=a.subarray(t,t+h),s=[];for(let e=0;e<r.length;e++)s.push({value:r[e],index:e});s.sort(((e,t)=>t.value-e.value)),d[e]=0;for(let t=0;t<n;t++)if(s[t].index===u[e]){d[e]=1;break}}return e!==r&&r.dispose(),t!==s&&s.dispose(),hs(d,s.shape,"bool")};const Du=ls({conv2DBackpropFilter_:function(e,t,n,r,s,o="NHWC",a){let l=e;3===e.rank&&(l=Lo(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=Lo(t,[1,t.shape[0],t.shape[1],t.shape[2]])),i(4===l.rank,(()=>`Error in conv2dDerFilter: input must be rank 4, but got shape ${l.shape}.`)),i(4===u.rank,(()=>`Error in conv2dDerFilter: dy must be rank 4, but got shape ${u.shape}.`)),i(4===n.length,(()=>`Error in conv2dDerFilter: filterShape must be length 4, but got ${n}.`));const c="NHWC"===o?l.shape[3]:l.shape[1],h="NHWC"===o?u.shape[3]:u.shape[1];i(c===n[2],(()=>`Error in conv2dDerFilter: depth of input ${c}) must match input depth in filter (${n[2]}.`)),i(h===n[3],(()=>`Error in conv2dDerFilter: depth of dy (${h}) must match output depth for filter (${n[3]}).`)),Oo("conv2dDerFilter",s,a);const d={x:l,dy:u},p={strides:r,pad:s,dataFormat:o,dimRoundingMode:a,filterShape:n};return Jr.runKernel(de,d,p)}});function Ru(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return ho(e,su(t));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function Fu(e,t){let n=t;const r=Aa(e.shape,t.shape);return r.length>0&&(n=Va(n,r)),Lo(n,e.shape)}function Bu(e,t,n,r){if("linear"===t)return e;if("relu"===t)return Ml(e);if("elu"===t)return Ba(e);if("relu6"===t)return Tl(e);if("prelu"===t)return el(e,n);if("leakyrelu"===t)return ui(e,r);if("sigmoid"===t)return Ko(e);throw new Error(`Unknown fused activation ${t}.`)}const Cu=(e,t)=>!(e>0)||"linear"===t;const Pu=ls({fusedConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:o=[1,1],dimRoundingMode:a,bias:l,activation:u="linear",preluActivationWeights:c,leakyreluAlpha:h}){if(u=u||"linear",!1===Cu(Jr.state.gradientDepth,u)){i("NHWC"===s,(()=>`Error in fused conv2d: got dataFormat of ${s} but only NHWC is currently supported for the case of gradient depth is 0 and the activation is not linear.`));let d=ua(e,t,n,r,s,o,a);return null!=l&&(d=lo(d,l)),Bu(d,u,c,h)}const d=os(e,"x","conv2d","float32"),p=os(t,"filter","conv2d","float32");let f=d,g=!1;3===d.rank&&(g=!0,f=Lo(d,[1,d.shape[0],d.shape[1],d.shape[2]])),i(4===f.rank,(()=>`Error in fused conv2d: input must be rank 4, but got rank ${f.rank}.`)),i(4===p.rank,(()=>`Error in fused conv2d: filter must be rank 4, but got rank ${p.rank}.`)),Oo("fused conv2d",r,a);const m="NHWC"===s?f.shape[3]:f.shape[1];i(p.shape[2]===m,(()=>`Error in conv2d: depth of input (${m}) must match input depth for filter ${p.shape[2]}.`)),i(Bo(n,o),(()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`));const b=_o(f.shape,p.shape,n,o,r,a);let y,w;if(null!=l&&(y=os(l,"bias","fused conv2d"),[y]=Wr(y,d),"NHWC"===s?_a(b.outShape,y.shape):(i(y.shape.length<=1,(()=>`Error in fused conv2d: only supports scalar or 1-D Tensor bias for NCHW format but got the bias of rank-${y.shape.length}.`)),i(0===y.shape.length||y.shape[0]===b.outChannels||1===y.shape[0],(()=>`Error in fused conv2d: bias shape (${y.shape}) is not compatible with the number of output channels (${b.outChannels})`)))),null!=c){const e=c.shape;if(i(e.length<=1||3===e.length,(()=>`Error in fused conv2d: only supports scalar, 1-D Tensor or 3-D Tensor PReLU activation weights but got a tensor of rank-${e.length}.`)),1===e.length)i(1===e[0]||e[0]===b.outChannels,(()=>`Error in fused conv2d: PReLU activation weights (${e}) is not compatible with the number of output channels (${b.outChannels}).`));else if(3===e.length)try{_a(e,b.outShape)}catch(t){const n=`Error in fused conv2d: PReLU activation weights (${e}) is not compatible with the output shape of the conv2d (${b.outShape}).`;throw Error(n)}w=os(c,"prelu weights","fused conv2d")}const k=(e,t)=>{i("NHWC"===s,(()=>`Error in gradient of fused conv2D: got dataFormat of ${s} but only NHWC is currently supported.`));const[a,l,c,h]=t,d=Ru(e,c,u);i(Fo(o),(()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${o}'`));const p=[ha(l.shape,d,a,n,r),Du(l,d,a.shape,n,r)];if(null!=h){const e=Fu(h,d);p.push(e)}return p},v={x:f,filter:p,bias:y,preluActivationWeights:w},x={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a,activation:u,leakyreluAlpha:h};if(null==l){const e=mi(((e,t,n)=>{let r=Jr.runKernel(wn,v,x);return n([t,e,r]),g&&(r=Lo(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:k}}));return e(f,p)}{const e=mi(((e,t,n,r)=>{let s=Jr.runKernel(wn,v,x);return r([t,e,s,n]),g&&(s=Lo(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:k}}));return e(f,p,y)}}});const Ou=ls({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r,s,o=[1,1],a){let i=e;3===e.rank&&(i=Lo(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let l=t;3===l.rank&&(l=Lo(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const u={x:i,dy:l},c={strides:r,pad:s,dimRoundingMode:a,dilations:o,filterShape:n};return Jr.runKernel(Ee,u,c)}});const Lu=ls({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r,s,o=[1,1],a){let i=t,l=!1;3===t.rank&&(l=!0,i=Lo(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const u={dy:i,filter:n},c={strides:r,pad:s,dimRoundingMode:a,dilations:o,inputShape:e},h=Jr.runKernel(Se,u,c);return l?Lo(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const zu=ls({fusedDepthwiseConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:o=[1,1],dimRoundingMode:a,bias:l,activation:u="linear",preluActivationWeights:c,leakyreluAlpha:h}){if(!1===Cu(Jr.state.gradientDepth,u)){let i=xa(e,t,n,r,s,o,a);return null!=l&&(i=lo(i,l)),Bu(i,u,c,h)}const d=os(e,"x","depthwiseConv2d","float32"),p=os(t,"filter","depthwiseConv2d","float32");let f=d,g=!1;3===d.rank&&(g=!0,f=Lo(d,[1,d.shape[0],d.shape[1],d.shape[2]])),i(4===f.rank,(()=>`Error in fused depthwiseConv2d: input must be rank 4, but got rank ${f.rank}.`)),i(4===p.rank,(()=>`Error in fused depthwiseConv2d: filter must be rank 4, but got rank ${p.rank}.`)),i(f.shape[3]===p.shape[2],(()=>`Error in fused depthwiseConv2d: number of input channels (${f.shape[3]}) must match the inChannels dimension in filter ${p.shape[2]}.`)),null==o&&(o=[1,1]),i(Bo(n,o),(()=>`Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`)),Oo("fused depthwiseConv2d",r,a);const m=_o(f.shape,p.shape,n,o,r,a,!0);let b,y;null!=l&&(b=os(l,"bias","fused conv2d"),[b]=Wr(b,d),_a(m.outShape,b.shape)),null!=c&&(y=os(c,"prelu weights","fused depthwiseConv2d"));const w=(e,t)=>{i(Fo(o),(()=>`Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '${o}'`));const[s,l,c,h]=t,d=Ru(e,c,u),p=Lu(l.shape,d,s,n,r,o,a),f=Ou(l,d,s.shape,n,r,o,a);if(null!=h){return[p,f,Fu(b,d)]}return[p,f]},k={x:f,filter:p,bias:b,preluActivationWeights:y},v={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a,activation:u,leakyreluAlpha:h};if(null==l){const e=mi(((e,t,n)=>{let r=Jr.runKernel(kn,k,v);return n([t,e,r]),g&&(r=Lo(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:w}}));return e(f,p)}{const e=mi(((e,t,n,r)=>{let s=Jr.runKernel(kn,k,v);return r([t,e,s,n]),g&&(s=Lo(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:w}}));return e(f,p,b)}}});const Wu=ls({fusedMatMul_:function({a:e,b:t,transposeA:n=!1,transposeB:r=!1,bias:s,activation:o="linear",preluActivationWeights:a,leakyreluAlpha:l=.2}){if(!1===Cu(Jr.state.gradientDepth,o)){let i=Go(e,t,n,r);return null!=s&&(i=lo(i,s)),Bu(i,o,a,l)}let u=os(e,"a","fused matMul"),h=os(t,"b","fused matMul");[u,h]=Wr(u,h);const d=n?u.shape[u.rank-2]:u.shape[u.rank-1],p=r?h.shape[h.rank-1]:h.shape[h.rank-2],f=n?u.shape[u.rank-1]:u.shape[u.rank-2],g=r?h.shape[h.rank-2]:h.shape[h.rank-1],m=u.shape.slice(0,-2),b=h.shape.slice(0,-2),y=c(m),w=c(b);i(d===p,(()=>`Error in fused matMul: inner shapes (${d}) and (${p}) of Tensors with shapes ${u.shape} and ${h.shape} and transposeA=${n} and transposeB=${r} must match.`));const k=_a(u.shape.slice(0,-2),h.shape.slice(0,-2)).concat([f,g]),v=Lo(u,n?[y,d,f]:[y,f,d]),x=Lo(h,r?[w,g,p]:[w,p,g]);let E,S;null!=s&&(E=os(s,"bias","fused matMul"),[E]=Wr(E,u),_a(k,E.shape)),null!=a&&(S=os(a,"prelu weights","fused matMul"));const $=(e,t)=>{const[a,i,l,u]=t,c=Ru(Lo(e,l.shape),l,o);let h,d;if(n||r?!n&&r?(h=Go(c,i,!1,!1),d=Go(c,a,!0,!1)):n&&!r?(h=Go(i,c,!1,!0),d=Go(a,c,!1,!1)):(h=Go(i,c,!0,!0),d=Go(c,a,!0,!0)):(h=Go(c,i,!1,!0),d=Go(a,c,!0,!1)),null!=s){return[h,d,Fu(u,c)]}return[h,d]},A={a:v,b:x,bias:E,preluActivationWeights:S},_={transposeA:n,transposeB:r,activation:o,leakyreluAlpha:l};if(null==s){const e=mi(((e,t,n)=>{const r=Jr.runKernel(yn,A,_);return n([e,t,r]),{value:Lo(r,k),gradFunc:$}}));return e(v,x)}{const e=mi(((e,t,n,r)=>{const s=Jr.runKernel(yn,A,_);return r([e,t,s,n]),{value:Lo(s,k),gradFunc:$}}));return e(v,x,E)}}});var Uu={__proto__:null,conv2d:Pu,depthwiseConv2d:zu,matMul:Wu};const Gu=ls({hammingWindow_:function(e){return Mu(e,.54,.46)}});const Ku=ls({hannWindow_:function(e){return Mu(e,.5,.5)}});const qu=ls({frame_:function(e,t,n,r=!1,s=0){let o=0;const a=[];for(;o+t<=e.size;)a.push(qo(e,o,t)),o+=n;if(r)for(;o<e.size;){const r=o+t-e.size,i=Uo([qo(e,o,t-r),ra([r],s)]);a.push(i),o+=n}return 0===a.length?lu([],[0,t]):Lo(Uo(a),[a.length,t])}});const Vu=ls({stft_:function(e,t,n,r,s=Ku){null==r&&(r=Nu(t));const o=qu(e,t,n),a=ho(o,s(t));return eu(a,r)}});const Hu=ls({cropAndResize_:function(e,t,n,r,s="bilinear",o=0){const a=os(e,"image","cropAndResize"),l=os(t,"boxes","cropAndResize","float32"),u=os(n,"boxInd","cropAndResize","int32"),c=l.shape[0];i(4===a.rank,(()=>`Error in cropAndResize: image must be rank 4,but got rank ${a.rank}.`)),i(2===l.rank&&4===l.shape[1],(()=>`Error in cropAndResize: boxes must be have size [${c},4] but had shape ${l.shape}.`)),i(1===u.rank&&u.shape[0]===c,(()=>`Error in cropAndResize: boxInd must be have size [${c}] but had shape ${l.shape}.`)),i(2===r.length,(()=>`Error in cropAndResize: cropSize must be of length 2, but got length ${r.length}.`)),i(r[0]>=1&&r[1]>=1,(()=>`cropSize must be atleast [1,1], but was ${r}`)),i("bilinear"===s||"nearest"===s,(()=>`method must be bilinear or nearest, but was ${s}`));const h={image:a,boxes:l,boxInd:u},d={method:s,extrapolationValue:o,cropSize:r};return Jr.runKernel(we,h,d)}});const ju=ls({flipLeftRight_:function(e){const t=os(e,"image","flipLeftRight","float32");i(4===t.rank,(()=>`Error in flipLeftRight: image must be rank 4,but got rank ${t.rank}.`));const n={image:t};return Jr.runKernel(Re,n,{})}});const Zu=ls({grayscaleToRGB_:function(e){const t=os(e,"image","grayscaleToRGB"),n=t.rank-1,r=t.shape[n];i(t.rank>=2,(()=>`Error in grayscaleToRGB: images must be at least rank 2, but got rank ${t.rank}.`)),i(1===r,(()=>`Error in grayscaleToRGB: last dimension of a grayscale image should be size 1, but got size ${r}.`));const s=new Array(t.rank);return s.fill(1,0,n),s[n]=3,Qa(t,s)}});const Ju=ls({rotateWithOffset_:function(e,t,n=0,r=.5){const s=os(e,"image","rotateWithOffset","float32");i(4===s.rank,(()=>`Error in rotateWithOffset: image must be rank 4,but got rank ${s.rank}.`));const o={image:s},a={radians:t,fillValue:n,center:r};return Jr.runKernel(bn,o,a)}});function Yu(e,t,n,r,s,o){null==r&&(r=.5),null==s&&(s=Number.NEGATIVE_INFINITY),null==o&&(o=0);const a=e.shape[0];return n=Math.min(n,a),i(0<=r&&r<=1,(()=>`iouThreshold must be in [0, 1], but was '${r}'`)),i(2===e.rank,(()=>`boxes must be a 2D tensor, but was of rank '${e.rank}'`)),i(4===e.shape[1],(()=>`boxes must have 4 columns, but 2nd dimension was ${e.shape[1]}`)),i(1===t.rank,(()=>"scores must be a 1D tensor")),i(t.shape[0]===a,(()=>`scores has incompatible shape with boxes. Expected ${a}, but was ${t.shape[0]}`)),i(0<=o&&o<=1,(()=>`softNmsSigma must be in [0, 1], but was '${o}'`)),{maxOutputSize:n,iouThreshold:r,scoreThreshold:s,softNmsSigma:o}}const Xu=ls({nonMaxSuppression_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const o=os(e,"boxes","nonMaxSuppression","float32"),a=os(t,"scores","nonMaxSuppression","float32"),i=Yu(o,a,n,r,s),l={maxOutputSize:n=i.maxOutputSize,iouThreshold:r=i.iouThreshold,scoreThreshold:s=i.scoreThreshold};return Jr.runKernel(ht,{boxes:o,scores:a},l)}});function Qu(e,t,n){const r=function(e,t,n){return function(e,t,n){let r=0,s=e.length,o=0,a=!1;for(;r<s;){o=r+(s-r>>>1);const i=n(t,e[o]);i>0?r=o+1:(s=o,a=!i)}return a?r:-r-1}(e,t,n||ec)}(e,t,n),s=r<0?-(r+1):r;e.splice(s,0,t)}function ec(e,t){return e>t?1:e<t?-1:0}function tc(e,t,n,r,s){return sc(e,t,n,r,s,0)}function nc(e,t,n,r,s,o){return sc(e,t,n,r,s,0,!1,o,!0)}function rc(e,t,n,r,s,o){return sc(e,t,n,r,s,o,!0)}function sc(e,t,n,r,s,o,a=!1,i=!1,l=!1){const u=[];for(let e=0;e<t.length;e++)t[e]>s&&u.push({score:t[e],boxIndex:e,suppressBeginIndex:0});u.sort(ic);const c=o>0?-.5/o:0,h=[],d=[];for(;h.length<n&&u.length>0;){const t=u.pop(),{score:n,boxIndex:o,suppressBeginIndex:a}=t;if(n<s)break;let i=!1;for(let n=h.length-1;n>=a;--n){const a=oc(e,o,h[n]);if(a>=r){i=!0;break}if(t.score=t.score*ac(r,c,a),t.score<=s)break}t.suppressBeginIndex=h.length,i||(t.score===n?(h.push(o),d.push(t.score)):t.score>s&&Qu(u,t,ic))}const p=h.length,f=n-p;i&&f>0&&(h.push(...new Array(f).fill(0)),d.push(...new Array(f).fill(0)));const g={selectedIndices:h};return a&&(g.selectedScores=d),l&&(g.validOutputs=p),g}function oc(e,t,n){const r=e.subarray(4*t,4*t+4),s=e.subarray(4*n,4*n+4),o=Math.min(r[0],r[2]),a=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),l=Math.max(r[1],r[3]),u=Math.min(s[0],s[2]),c=Math.min(s[1],s[3]),h=Math.max(s[0],s[2]),d=Math.max(s[1],s[3]),p=(i-o)*(l-a),f=(h-u)*(d-c);if(p<=0||f<=0)return 0;const g=Math.max(o,u),m=Math.max(a,c),b=Math.min(i,h),y=Math.min(l,d),w=Math.max(b-g,0)*Math.max(y-m,0);return w/(p+f-w)}function ac(e,t,n){const r=Math.exp(t*n*n);return n<=e?r:0}function ic(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}const lc=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const o=os(e,"boxes","nonMaxSuppressionAsync"),a=os(t,"scores","nonMaxSuppressionAsync"),i=Yu(o,a,n,r,s);n=i.maxOutputSize,r=i.iouThreshold,s=i.scoreThreshold;const l=await Promise.all([o.data(),a.data()]),u=l[0],c=l[1],{selectedIndices:h}=tc(u,c,n,r,s);return o!==e&&o.dispose(),a!==t&&a.dispose(),iu(h,"int32")};const uc=ls({nonMaxSuppressionWithScore_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=0){const a=os(e,"boxes","nonMaxSuppression"),i=os(t,"scores","nonMaxSuppression"),l=Yu(a,i,n,r,s,o),u={boxes:a,scores:i},c={maxOutputSize:n=l.maxOutputSize,iouThreshold:r=l.iouThreshold,scoreThreshold:s=l.scoreThreshold,softNmsSigma:o=l.softNmsSigma},h=Jr.runKernel(pt,u,c);return{selectedIndices:h[0],selectedScores:h[1]}}});const cc=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=0){const a=os(e,"boxes","nonMaxSuppressionAsync"),i=os(t,"scores","nonMaxSuppressionAsync"),l=Yu(a,i,n,r,s,o);n=l.maxOutputSize,r=l.iouThreshold,s=l.scoreThreshold,o=l.softNmsSigma;const u=await Promise.all([a.data(),i.data()]),c=u[0],h=u[1],{selectedIndices:d,selectedScores:p}=rc(c,h,n,r,s,o);return a!==e&&a.dispose(),i!==t&&i.dispose(),{selectedIndices:iu(d,"int32"),selectedScores:iu(p)}};const hc=ls({nonMaxSuppressionPadded_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=!1){const a=os(e,"boxes","nonMaxSuppression"),i=os(t,"scores","nonMaxSuppression"),l=Yu(a,i,n,r,s,null),u={boxes:a,scores:i},c={maxOutputSize:l.maxOutputSize,iouThreshold:l.iouThreshold,scoreThreshold:l.scoreThreshold,padToMaxOutputSize:o},h=Jr.runKernel(dt,u,c);return{selectedIndices:h[0],validOutputs:h[1]}}});const dc=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=!1){const a=os(e,"boxes","nonMaxSuppressionAsync"),i=os(t,"scores","nonMaxSuppressionAsync"),l=Yu(a,i,n,r,s,null),u=l.maxOutputSize,c=l.iouThreshold,h=l.scoreThreshold,[d,p]=await Promise.all([a.data(),i.data()]),{selectedIndices:f,validOutputs:g}=nc(d,p,u,c,h,o);return a!==e&&a.dispose(),i!==t&&i.dispose(),{selectedIndices:iu(f,"int32"),validOutputs:Ga(g,"int32")}};const pc=ls({resizeBilinear_:function(e,t,n=!1,r=!1){const s=os(e,"images","resizeBilinear");i(3===s.rank||4===s.rank,(()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${s.rank}.`)),i(2===t.length,(()=>`Error in resizeBilinear: new shape must 2D, but got shape ${t}.`)),i(!1===r||!1===n,(()=>"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false."));let o=s,a=!1;3===s.rank&&(a=!0,o=Lo(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const l={images:o},u={alignCorners:n,halfPixelCenters:r,size:t},c=Jr.runKernel(Nt,l,u);return a?Lo(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const fc=ls({resizeNearestNeighbor_:function(e,t,n=!1,r=!1){const s=os(e,"images","resizeNearestNeighbor");i(3===s.rank||4===s.rank,(()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${s.rank}.`)),i(2===t.length,(()=>`Error in resizeNearestNeighbor: new shape must 2D, but got shape ${t}.`)),i("float32"===s.dtype||"int32"===s.dtype,(()=>"`images` must have `int32` or `float32` as dtype")),i(!1===r||!1===n,(()=>"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false."));let o=s,a=!1;3===s.rank&&(a=!0,o=Lo(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const l={images:o},u={alignCorners:n,halfPixelCenters:r,size:t},c=Jr.runKernel(It,l,u);return a?Lo(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const gc=ls({threshold_:function(e,t="binary",n=!1,r=.5){const s=os(e,"image","threshold"),o=s.shape[0]*s.shape[1];let a,l,u,c,h=ho(iu([r]),255);if(i(3===s.rank,(()=>`Error in threshold: image must be rank 3,but got rank ${s.rank}.`)),i(3===s.shape[2]||1===s.shape[2],(()=>`Error in threshold: image color channel must be equal to 3 or 1but got ${s.shape[2]}.`)),i("int32"===s.dtype||"float32"===s.dtype,(()=>`Error in dtype: image dtype must be int32 or float32,but got dtype ${s.dtype}.`)),i("otsu"===t||"binary"===t,(()=>`Method must be binary or otsu, but was ${t}`)),3===s.shape[2]){[a,l,u]=Ql(s,[1,1,1],-1);const e=ho(a,.2989),t=ho(l,.587),n=ho(u,.114);c=lo(lo(e,t),n)}else c=e;if("otsu"===t){h=function(e,t){let n,r,s,o,a,i,l=iu([-1]),u=iu([0]),c=iu([0]);for(let h=0;h<e.size-1;h++){n=qo(e,0,h+1),r=qo(e,h+1),a=co(Va(n),t),i=co(Va(r),t);const d=Va(ho(n,_l(0,n.size)));s=co(d,Va(n));const p=ra(r.shape,n.size),f=lo(_l(0,r.size),p),g=ho(r,f);o=co(Va(g),Va(r));const m=vi(s,o),b=vi(s,o),y=ho(a,i);c=ho(ho(y,m),b);const w=ri(c,u);u=Ma(w,c,u),l=Ma(w,iu([h]),l)}return l}(Qo(no(Pl(c),"int32"),hs([]),256),o)}const d=n?hi(c,h):ri(c,h);return no(ho(d,255),"int32")}});const mc=ls({transform_:function(e,t,n="nearest",r="constant",s=0,o){const a=os(e,"image","transform","float32"),l=os(t,"transforms","transform","float32");i(4===a.rank,(()=>`Error in transform: image must be rank 4,but got rank ${a.rank}.`)),i(2===l.rank&&(l.shape[0]===a.shape[0]||1===l.shape[0])&&8===l.shape[1],(()=>"Error in transform: Input transform should be batch x 8 or 1 x 8")),i(null==o||2===o.length,(()=>`Error in transform: outputShape must be [height, width] or null, but got ${o}.`));const u={image:a,transforms:l},c={interpolation:n,fillMode:r,fillValue:s,outputShape:o};return Jr.runKernel(un,u,c)}});const bc=ls({bandPart_:function(e,t,n){const r=os(e,"a","bandPart");i(r.rank>=2,(()=>`bandPart(): Rank must be at least 2, got ${r.rank}.`));const s=r.shape,[o,a]=r.shape.slice(-2);let l,u;"number"==typeof t?(i(t%1==0,(()=>`bandPart(): numLower must be an integer, got ${t}.`)),i(t<=o,(()=>`bandPart(): numLower (${t}) must not be greater than the number of rows (${o}).`)),l=os(t<0?o:t,"numLower","bandPart")):(i("int32"===t.dtype,(()=>"bandPart(): numLower's dtype must be an int32.")),l=Ma(ci(t,0),o,Pi(t,o))),"number"==typeof n?(i(n%1==0,(()=>`bandPart(): numUpper must be an integer, got ${n}.`)),i(n<=a,(()=>`bandPart(): numUpper (${n}) must not be greater than the number of columns (${a}).`)),u=os(n<0?a:n,"numUpper","bandPart")):(i("int32"===n.dtype,(()=>"bandPart(): numUpper's dtype must be an int32.")),u=Ma(ci(n,0),a,Pi(n,a)));const c=Lo(_l(0,o,1,"int32"),[-1,1]),h=_l(0,a,1,"int32"),d=vi(c,h),p=Si(hi(d,l),si(d,yi(u))),f=Bi([o,a],r.dtype);return Lo(ru(wu(Lo(r,[-1,o,a])).map((e=>Ma(p,e,f)))),s)}});const yc=ls({gramSchmidt_:function(e){let t;if(Array.isArray(e)){t=!1,i(null!=e&&e.length>0,(()=>"Gram-Schmidt process: input must not be null, undefined, or empty"));const n=e[0].shape[0];for(let t=1;t<e.length;++t)i(e[t].shape[0]===n,(()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${e[t].shape[0]} vs. ${n})`))}else t=!0,e=Ql(e,e.shape[0],0).map((e=>nu(e,[0])));i(e.length<=e[0].shape[0],(()=>`Gram-Schmidt: Number of vectors (${e.length}) exceeds number of dimensions (${e[0].shape[0]}).`));const n=[],r=e;for(let t=0;t<e.length;++t)n.push(Jr.tidy((()=>{let e=r[t];if(t>0)for(let r=0;r<t;++r){const t=ho(Va(ho(n[r],e)),n[r]);e=vi(e,t)}return co(e,ja(e,"euclidean"))})));return t?ru(n,0):n}});function wc(e,t=!1){return Jr.tidy((()=>{i(2===e.shape.length,(()=>`qr2d() requires a 2D Tensor, but got a ${e.shape.length}D Tensor.`));const n=e.shape[0],r=e.shape[1];let s=ei(n),o=ro(e);const a=lu([[1]],[1,1]);let l=ro(a);const u=n>=r?r:n;for(let e=0;e<u;++e){const t=o,i=l,u=s;[l,o,s]=Jr.tidy((()=>{const t=qo(o,[e,e],[n-e,1]),i=ja(t),u=qo(o,[e,e],[1,1]),c=Ma(ri(u,0),lu([[-1]]),lu([[1]])),h=vi(u,ho(c,i)),d=co(t,h);l=1===d.shape[0]?ro(a):Uo([a,qo(d,[1,0],[d.shape[0]-1,d.shape[1]])],0);const p=yi(co(Go(c,h),i)),f=qo(o,[e,0],[n-e,r]),g=ho(p,l),m=Eu(l);if(0===e)o=vi(f,Go(g,Go(m,f)));else{const t=vi(f,Go(g,Go(m,f)));o=Uo([qo(o,[0,0],[e,r]),t],0)}const b=Eu(g),y=qo(s,[0,e],[n,s.shape[1]-e]);if(0===e)s=vi(y,Go(Go(y,l),b));else{const t=vi(y,Go(Go(y,l),b));s=Uo([qo(s,[0,0],[n,e]),t],1)}return[l,o,s]})),ao([t,i,u])}return!t&&n>r&&(s=qo(s,[0,0],[n,r]),o=qo(o,[0,0],[r,r])),[s,o]}))}const kc=ls({qr_:function(e,t=!1){if(i(e.rank>=2,(()=>`qr() requires input tensor to have a rank >= 2, but got rank ${e.rank}`)),2===e.rank)return wc(e,t);{const n=e.shape.slice(0,e.shape.length-2).reduce(((e,t)=>e*t)),r=wu(Lo(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),s=[],o=[];r.forEach((e=>{const[n,r]=wc(e,t);s.push(n),o.push(r)}));return[Lo(ru(s,0),e.shape),Lo(ru(o,0),e.shape)]}}});var vc;e.Reduction=void 0,(vc=e.Reduction||(e.Reduction={}))[vc.NONE=0]="NONE",vc[vc.MEAN=1]="MEAN",vc[vc.SUM=2]="SUM",vc[vc.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS";const xc=ls({computeWeightedLoss_:function(t,n,r=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const s=os(t,"losses","computeWeightedLoss");let o=null;null!=n&&(o=os(n,"weights","computeWeightedLoss"));const a=null==o?s:ho(s,o);if(r===e.Reduction.NONE)return a;if(r===e.Reduction.SUM)return Va(a);if(r===e.Reduction.MEAN){if(null==o)return Fi(a);{const e=s.size/o.size,t=co(Va(a),Va(o));return e>1?co(t,Ga(e)):t}}if(r===e.Reduction.SUM_BY_NONZERO_WEIGHTS){if(null==o)return co(Va(a),Ga(s.size));{const e=ho(o,Ci(s.shape)),t=no(Va(Gi(e,Ga(0))),"float32");return co(Va(a),t)}}throw Error(`Unknown reduction: ${r}`)}});const Ec=ls({absoluteDifference_:function(t,n,r,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const o=os(t,"labels","absoluteDifference"),a=os(n,"predictions","absoluteDifference");let i=null;null!=r&&(i=os(r,"weights","absoluteDifference")),l(o.shape,a.shape,"Error in absoluteDifference: ");const u=po(vi(o,a));return xc(u,i,s)}});const Sc=ls({cosineDistance_:function(t,n,r,s,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=os(t,"labels","cosineDistance"),i=os(n,"predictions","cosineDistance");let u=null;null!=s&&(u=os(s,"weights","cosineDistance")),l(a.shape,i.shape,"Error in cosineDistance: ");const c=Ga(1),h=vi(c,Va(ho(a,i),r,!0));return xc(h,u,o)}});const $c=ls({hingeLoss_:function(t,n,r,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let o=os(t,"labels","hingeLoss");const a=os(n,"predictions","hingeLoss");let i=null;null!=r&&(i=os(r,"weights","hingeLoss")),l(o.shape,a.shape,"Error in hingeLoss: ");const u=Ga(1);o=vi(ho(Ga(2),o),u);const c=Ml(vi(u,ho(o,a)));return xc(c,i,s)}});const Ac=ls({huberLoss_:function(t,n,r,s=1,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=os(t,"labels","huberLoss"),i=os(n,"predictions","huberLoss");let u=null;null!=r&&(u=os(r,"weights","huberLoss")),l(a.shape,i.shape,"Error in huberLoss: ");const c=Ga(s),h=po(vi(i,a)),d=Pi(h,c),p=vi(h,d),f=lo(ho(Ga(.5),qa(d)),ho(c,p));return xc(f,u,o)}});const _c=ls({logLoss_:function(t,n,r,s=1e-7,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=os(t,"labels","logLoss"),i=os(n,"predictions","logLoss");let u=null;null!=r&&(u=os(r,"weights","logLoss")),l(a.shape,i.shape,"Error in logLoss: ");const c=Ga(1),h=Ga(s),d=yi(ho(a,pi(lo(i,h)))),p=ho(vi(c,a),pi(lo(vi(c,i),h))),f=vi(d,p);return xc(f,u,o)}});const Ic=ls({meanSquaredError_:function(t,n,r,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const o=os(t,"labels","meanSquaredError"),a=os(n,"predictions","meanSquaredError");let i=null;null!=r&&(i=os(r,"weights","meanSquaredError")),l(o.shape,a.shape,"Error in meanSquaredError: ");const u=tu(o,a);return xc(u,i,s)}});const Nc=ls({sigmoidCrossEntropy_:function(t,n,r,s=0,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let a=os(t,"multiClassLabels","sigmoidCrossEntropy");const i=os(n,"logits","sigmoidCrossEntropy");let u=null;if(null!=r&&(u=os(r,"weights","sigmoidCrossEntropy")),l(a.shape,i.shape,"Error in sigmoidCrossEntropy: "),s>0){const e=Ga(s),t=Ga(1),n=Ga(.5);a=lo(ho(a,vi(t,e)),ho(n,e))}const c=function(e,t){const n=os(e,"labels","sigmoidCrossEntropyWithLogits"),r=os(t,"logits","sigmoidCrossEntropyWithLogits");l(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");const s=Ml(r),o=ho(r,n),a=fi(Ja(yi(po(r))));return lo(vi(s,o),a)}(a,i);return xc(c,u,o)}});const Mc=ls({softmaxCrossEntropy_:function(t,n,r,s=0,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let a=os(t,"onehotLabels","softmaxCrossEntropy");const i=os(n,"logits","softmaxCrossEntropy");let u=null;if(null!=r&&(u=os(r,"weights","softmaxCrossEntropy")),l(a.shape,i.shape,"Error in softmaxCrossEntropy: "),s>0){const e=Ga(s),t=Ga(1),n=Ga(a.shape[1]);a=lo(ho(a,vi(t,e)),co(e,n))}const c=function(e,t,n=-1){if(-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error(`Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank ${t.rank} and dim was ${n}`);const r=mi(((e,t,r)=>{const s=Ei(t,[n],!0),o=vi(no(t,"float32"),s);r([e,o]);const a=yi(ho(o,e));return{value:Va(a,[n]),gradFunc:(e,t)=>{const[r,s]=t,o=La(e.shape,[n]);return[ho(Lo(e,o),vi(no(r,"float32"),Ja(s))),ho(Lo(e,o),vi(Ja(s),no(r,"float32")))]}}}));return r(e,t)}(a,i);return xc(c,u,o)}});const Tc=ls({sparseFillEmptyRows_:function(e,t,n,r){const s=os(e,"indices","sparseFillEmptyRows","int32"),o=os(t,"values","sparseFillEmptyRows"),a=os(n,"denseShape","sparseFillEmptyRows","int32"),i=os(r,"defaultValue","sparseFillEmptyRows",o.dtype);if(2!==s.rank)throw new Error(`Indices should be Tensor2D but received shape\n        ${s.shape}`);if(1!==o.rank)throw new Error(`Values should be Tensor1D but received shape ${o.shape}`);if(1!==a.rank)throw new Error(`Dense shape should be Tensor1D but received shape ${a.shape}`);if(0!==i.rank)throw new Error(`Default value should be a scalar but received shape ${i.shape}`);const l={indices:s,values:o,denseShape:a,defaultValue:i},u=Jr.runKernel(jt,l);return{outputIndices:u[0],outputValues:u[1],emptyRowIndicator:u[2],reverseIndexMap:u[3]}}});const Dc=ls({sparseReshape_:function(e,t,n){const r=os(e,"inputIndices","sparseReshape","int32"),s=os(t,"inputShape","sparseReshape","int32"),o=os(n,"newShape","sparseReshape","int32");if(2!==r.rank)throw new Error(`Input indices should be Tensor2D but received shape\n        ${r.shape}`);if(1!==s.rank)throw new Error(`Input shape should be Tensor1D but received shape ${s.shape}`);if(1!==o.rank)throw new Error(`New shape should be Tensor1D but received shape ${o.shape}`);const a={inputIndices:r,inputShape:s,newShape:o},i=Jr.runKernel(Zt,a);return{outputIndices:i[0],outputShape:i[1]}}});const Rc=ls({sparseSegmentMean_:function(e,t,n){const r=os(e,"data","sparseSegmentMean"),s=os(t,"indices","sparseSegmentMean","int32"),o=os(n,"segmentIds","sparseSegmentMean","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==s.rank)throw new Error(`Indices should be Tensor1D but received shape\n          ${s.shape}`);if(1!==o.rank)throw new Error(`Segment ids should be Tensor1D but received shape\n          ${o.shape}`);const a={data:r,indices:s,segmentIds:o};return Jr.runKernel(Jt,a)}});const Fc=ls({sparseSegmentSum_:function(e,t,n){const r=os(e,"data","sparseSegmentSum"),s=os(t,"indices","sparseSegmentSum","int32"),o=os(n,"segmentIds","sparseSegmentSum","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==s.rank)throw new Error(`Indices should be Tensor1D but received shape\n         ${s.shape}`);if(1!==o.rank)throw new Error(`Segment ids should be Tensor1D but received shape\n         ${o.shape}`);const a={data:r,indices:s,segmentIds:o};return Jr.runKernel(Yt,a)}});const Bc=ls({stringNGrams_:function(e,t,n,r,s,o,a,i){const l=os(e,"data","stringNGrams","string");if("string"!==l.dtype)throw new Error("Data must be of datatype string");if(1!==l.shape.length)throw new Error(`Data must be a vector, saw: ${l.shape}`);const u=os(t,"dataSplits","stringNGrams");if("int32"!==u.dtype)throw new Error("Data splits must be of datatype int32");const c={separator:n,nGramWidths:r,leftPad:s,rightPad:o,padWidth:a,preserveShortSequences:i},h={data:l,dataSplits:u},d=Jr.runKernel(nn,h,c);return{nGrams:d[0],nGramsSplits:d[1]}}});const Cc={fft:Jl,ifft:Yl,rfft:eu,irfft:Xl},Pc={hammingWindow:Gu,hannWindow:Ku,frame:qu,stft:Vu},Oc={flipLeftRight:ju,grayscaleToRGB:Zu,resizeNearestNeighbor:fc,resizeBilinear:pc,rotateWithOffset:Ju,cropAndResize:Hu,nonMaxSuppression:Xu,nonMaxSuppressionAsync:lc,nonMaxSuppressionWithScore:uc,nonMaxSuppressionWithScoreAsync:cc,nonMaxSuppressionPadded:hc,nonMaxSuppressionPaddedAsync:dc,threshold:gc,transform:mc},Lc={bandPart:bc,gramSchmidt:yc,qr:kc},zc={absoluteDifference:Ec,computeWeightedLoss:xc,cosineDistance:Sc,hingeLoss:$c,huberLoss:Ac,logLoss:_c,meanSquaredError:Ic,sigmoidCrossEntropy:Nc,softmaxCrossEntropy:Mc},Wc={sparseFillEmptyRows:Tc,sparseReshape:Dc,sparseSegmentMean:Rc,sparseSegmentSum:Fc},Uc={stringNGrams:Bc,stringSplit:ls({stringSplit_:function(e,t,n=!0){const r=os(e,"input","stringSplit","string"),s=os(t,"delimiter","stringSplit","string");if(1!==r.rank)throw new Error(`Input should be Tensor1D but received shape ${r.shape}`);if(0!==s.rank)throw new Error(`Delimiter should be a scalar but received shape ${s.shape}`);const o={skipEmpty:n},a={input:r,delimiter:s},i=Jr.runKernel(rn,a,o);return{indices:i[0],values:i[1],shape:i[2]}}}),stringToHashBucketFast:ls({stringToHashBucketFast_:function(e,t){const n=os(e,"input","stringToHashBucketFast","string"),r={numBuckets:t};if(t<=0)throw new Error("Number of buckets must be at least 1");const s={input:n};return Jr.runKernel(sn,s,r)}}),staticRegexReplace:ls({staticRegexReplace_:function(e,t,n,r=!0){const s=os(e,"input","staticRegexReplace","string"),o={pattern:t,rewrite:n,replaceGlobal:r};return Jr.runKernel(en,{x:s},o)}})};class Gc{getClassName(){return this.constructor.className}static fromConfig(e,t){return new e(t)}}class Kc{constructor(){this.classNameMap={}}static getMap(){return null==Kc.instance&&(Kc.instance=new Kc),Kc.instance}static register(e){Kc.getMap().classNameMap[e.className]=[e,e.fromConfig]}}function qc(e){i(null!=e.className,(()=>"Class being registered does not have the static className property defined.")),i("string"==typeof e.className,(()=>"className is required to be a string, but got type "+typeof e.className)),i(e.className.length>0,(()=>"Class being registered has an empty-string as its className, which is disallowed.")),Kc.register(e)}var Vc={__proto__:null,Serializable:Gc,SerializationMap:Kc,registerClass:qc};class Hc extends Gc{minimize(e,t=!1,n){const{value:r,grads:s}=this.computeGradients(e,n);if(null!=n){const e=n.map((e=>({name:e.name,tensor:s[e.name]})));this.applyGradients(e)}else this.applyGradients(s);return ao(s),t?r:(r.dispose(),null)}get iterations(){return null==this.iterations_&&(this.iterations_=0),this.iterations_}incrementIterations(){this.iterations_=this.iterations+1}computeGradients(e,t){return gi(e,t)}dispose(){null!=this.iterations_&&ao(this.iterations_)}async saveIterations(){return null==this.iterations_&&(this.iterations_=0),{name:"iter",tensor:Ga(this.iterations_,"int32")}}async getWeights(){throw new Error("getWeights() is not implemented for this optimizer yet.")}async setWeights(e){throw new Error(`setWeights() is not implemented for this optimizer class ${this.getClassName()}`)}async extractIterations(e){return this.iterations_=(await e[0].tensor.data())[0],e.slice(1)}}Object.defineProperty(Hc,Symbol.hasInstance,{value:e=>null!=e.minimize&&null!=e.computeGradients&&null!=e.applyGradients});class jc extends Hc{static get className(){return"Adadelta"}constructor(e,t,n=null){super(),this.learningRate=e,this.rho=t,this.epsilon=n,this.accumulatedGrads=[],this.accumulatedUpdates=[],null==n&&(this.epsilon=Jr.backend.epsilon())}applyGradients(e){(Array.isArray(e)?e.map((e=>e.name)):Object.keys(e)).forEach(((t,n)=>{const r=Jr.registeredVariables[t];null==this.accumulatedGrads[n]&&(this.accumulatedGrads[n]={originalName:`${t}/accum_grad`,variable:oo((()=>Ta(r).variable(false)))}),null==this.accumulatedUpdates[n]&&(this.accumulatedUpdates[n]={originalName:`${t}/accum_var`,variable:oo((()=>Ta(r).variable(false)))});const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedGrads[n].variable,a=this.accumulatedUpdates[n].variable;oo((()=>{const e=lo(ho(o,this.rho),ho(qa(s),1-this.rho)),t=ho(co(Ka(lo(a,this.epsilon)),Ka(lo(o,this.epsilon))),s),n=lo(ho(a,this.rho),ho(qa(t),1-this.rho));o.assign(e),a.assign(n);const i=lo(ho(t,-this.learningRate),r);r.assign(i)}))})),this.incrementIterations()}dispose(){null!=this.accumulatedUpdates&&(ao(this.accumulatedGrads.map((e=>e.variable))),ao(this.accumulatedUpdates.map((e=>e.variable))))}async getWeights(){const e=[...this.accumulatedGrads,...this.accumulatedUpdates];return[await this.saveIterations()].concat(e.map((e=>({name:e.originalName,tensor:e.variable}))))}async setWeights(e){const t=(e=await this.extractIterations(e)).length/2;this.accumulatedGrads=e.slice(0,t).map((e=>({originalName:e.name,variable:e.tensor.variable(false)}))),this.accumulatedUpdates=e.slice(t,2*t).map((e=>({originalName:e.name,variable:e.tensor.variable(false)})))}getConfig(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.rho,t.epsilon)}}class Zc extends Hc{static get className(){return"Adagrad"}constructor(e,t=.1){super(),this.learningRate=e,this.initialAccumulatorValue=t,this.accumulatedGrads=[]}applyGradients(e){(Array.isArray(e)?e.map((e=>e.name)):Object.keys(e)).forEach(((t,n)=>{const r=Jr.registeredVariables[t];if(null==this.accumulatedGrads[n]){const e=!1;this.accumulatedGrads[n]={originalName:`${t}/accumulator`,variable:oo((()=>ra(r.shape,this.initialAccumulatorValue).variable(e)))}}const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedGrads[n].variable;oo((()=>{const e=lo(o,qa(s));o.assign(e);const t=lo(ho(co(s,Ka(lo(e,Jr.backend.epsilon()))),-this.learningRate),r);r.assign(t)}))})),this.incrementIterations()}dispose(){null!=this.accumulatedGrads&&ao(this.accumulatedGrads.map((e=>e.variable)))}async getWeights(){return[await this.saveIterations()].concat(this.accumulatedGrads.map((e=>({name:e.originalName,tensor:e.variable}))))}async setWeights(e){e=await this.extractIterations(e);this.accumulatedGrads=e.map((e=>({originalName:e.name,variable:e.tensor.variable(false)})))}getConfig(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}}static fromConfig(e,t){return new e(t.learningRate,t.initialAccumulatorValue)}}class Jc extends Hc{static get className(){return"Adam"}constructor(e,t,n,r=null){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.accumulatedFirstMoment=[],this.accumulatedSecondMoment=[],oo((()=>{this.accBeta1=Ga(t).variable(),this.accBeta2=Ga(n).variable()})),null==r&&(this.epsilon=Jr.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map((e=>e.name)):Object.keys(e);oo((()=>{const n=vi(1,this.accBeta1),r=vi(1,this.accBeta2);t.forEach(((t,s)=>{const o=Jr.registeredVariables[t];null==this.accumulatedFirstMoment[s]&&(this.accumulatedFirstMoment[s]={originalName:`${t}/m`,variable:oo((()=>Ta(o).variable(false)))}),null==this.accumulatedSecondMoment[s]&&(this.accumulatedSecondMoment[s]={originalName:`${t}/v`,variable:oo((()=>Ta(o).variable(false)))});const a=Array.isArray(e)?e[s].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[s].variable,l=this.accumulatedSecondMoment[s].variable,u=lo(ho(i,this.beta1),ho(a,1-this.beta1)),c=lo(ho(l,this.beta2),ho(qa(a),1-this.beta2)),h=co(u,n),d=co(c,r);i.assign(u),l.assign(c);const p=lo(ho(co(h,lo(Ka(d),this.epsilon)),-this.learningRate),o);o.assign(p)})),this.accBeta1.assign(ho(this.accBeta1,this.beta1)),this.accBeta2.assign(ho(this.accBeta2,this.beta2))})),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&ao(this.accumulatedFirstMoment.map((e=>e.variable))),null!=this.accumulatedSecondMoment&&ao(this.accumulatedSecondMoment.map((e=>e.variable)))}async getWeights(){const e=[...this.accumulatedFirstMoment,...this.accumulatedSecondMoment];return[await this.saveIterations()].concat(e.map((e=>({name:e.originalName,tensor:e.variable}))))}async setWeights(e){e=await this.extractIterations(e),oo((()=>{this.accBeta1.assign(Ua(this.beta1,this.iterations_+1)),this.accBeta2.assign(Ua(this.beta2,this.iterations_+1))}));const t=e.length/2;this.accumulatedFirstMoment=e.slice(0,t).map((e=>({originalName:e.name,variable:e.tensor.variable(false)}))),this.accumulatedSecondMoment=e.slice(t,2*t).map((e=>({originalName:e.name,variable:e.tensor.variable(false)})))}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon)}}class Yc extends Hc{static get className(){return"Adamax"}constructor(e,t,n,r=null,s=0){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.decay=s,this.accumulatedFirstMoment=[],this.accumulatedWeightedInfNorm=[],oo((()=>{this.iteration=Ga(0).variable(),this.accBeta1=Ga(t).variable()})),null==r&&(this.epsilon=Jr.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map((e=>e.name)):Object.keys(e);oo((()=>{const n=vi(1,this.accBeta1),r=co(-this.learningRate,lo(ho(this.iteration,this.decay),1));t.forEach(((t,s)=>{const o=Jr.registeredVariables[t];null==this.accumulatedFirstMoment[s]&&(this.accumulatedFirstMoment[s]={originalName:`${t}/m`,variable:Ta(o).variable(false)}),null==this.accumulatedWeightedInfNorm[s]&&(this.accumulatedWeightedInfNorm[s]={originalName:`${t}/v`,variable:Ta(o).variable(false)});const a=Array.isArray(e)?e[s].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[s].variable,l=this.accumulatedWeightedInfNorm[s].variable,u=lo(ho(i,this.beta1),ho(a,1-this.beta1)),c=ho(l,this.beta2),h=po(a),d=Ri(c,h);i.assign(u),l.assign(d);const p=lo(ho(co(r,n),co(u,lo(d,this.epsilon))),o);o.assign(p)})),this.iteration.assign(lo(this.iteration,1)),this.accBeta1.assign(ho(this.accBeta1,this.beta1))})),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&ao(this.accumulatedFirstMoment.map((e=>e.variable))),null!=this.accumulatedWeightedInfNorm&&ao(this.accumulatedWeightedInfNorm.map((e=>e.variable)))}async getWeights(){throw new Error("getWeights() is not implemented for Adamax yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for Adamax yet.")}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon,t.decay)}}class Xc extends Hc{static get className(){return"SGD"}constructor(e){super(),this.learningRate=e,this.setLearningRate(e)}applyGradients(e){(Array.isArray(e)?e.map((e=>e.name)):Object.keys(e)).forEach(((t,n)=>{const r=Array.isArray(e)?e[n].tensor:e[t];if(null==r)return;const s=Jr.registeredVariables[t];oo((()=>{const e=lo(ho(this.c,r),s);s.assign(e)}))})),this.incrementIterations()}setLearningRate(e){this.learningRate=e,null!=this.c&&this.c.dispose(),this.c=io(Ga(-e))}dispose(){this.c.dispose()}async getWeights(){return[await this.saveIterations()]}async setWeights(e){if(0!==(e=await this.extractIterations(e)).length)throw new Error("SGD optimizer does not have settable weights.")}getConfig(){return{learningRate:this.learningRate}}static fromConfig(e,t){return new e(t.learningRate)}}class Qc extends Xc{static get className(){return"Momentum"}constructor(e,t,n=!1){super(e),this.learningRate=e,this.momentum=t,this.useNesterov=n,this.accumulations=[],this.m=Ga(this.momentum)}applyGradients(e){(Array.isArray(e)?e.map((e=>e.name)):Object.keys(e)).forEach(((t,n)=>{const r=Jr.registeredVariables[t];if(null==this.accumulations[n]){const e=!1;this.accumulations[n]={originalName:`${t}/momentum`,variable:oo((()=>Ta(r).variable(e)))}}const s=this.accumulations[n].variable,o=Array.isArray(e)?e[n].tensor:e[t];null!=o&&oo((()=>{let e;const t=lo(ho(this.m,s),o);e=this.useNesterov?lo(ho(this.c,lo(o,ho(t,this.m))),r):lo(ho(this.c,t),r),s.assign(t),r.assign(e)}))})),this.incrementIterations()}dispose(){this.m.dispose(),null!=this.accumulations&&ao(this.accumulations.map((e=>e.variable)))}setMomentum(e){this.momentum=e}async getWeights(){return[await this.saveIterations()].concat(this.accumulations.map((e=>({name:e.originalName,tensor:e.variable}))))}async setWeights(e){e=await this.extractIterations(e);this.accumulations=e.map((e=>({originalName:e.name,variable:e.tensor.variable(false)})))}getConfig(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}}static fromConfig(e,t){return new e(t.learningRate,t.momentum,t.useNesterov)}}class eh extends Hc{static get className(){return"RMSProp"}constructor(e,t=.9,n=0,r=null,s=!1){if(super(),this.learningRate=e,this.decay=t,this.momentum=n,this.epsilon=r,this.accumulatedMeanSquares=[],this.accumulatedMoments=[],this.accumulatedMeanGrads=[],this.centered=s,null==r&&(this.epsilon=Jr.backend.epsilon()),null==e)throw new Error("learningRate for RMSPropOptimizer must be defined.")}applyGradients(e){(Array.isArray(e)?e.map((e=>e.name)):Object.keys(e)).forEach(((t,n)=>{const r=Jr.registeredVariables[t],s=!1;null==this.accumulatedMeanSquares[n]&&(this.accumulatedMeanSquares[n]={originalName:`${t}/rms`,variable:oo((()=>Ta(r).variable(s)))}),null==this.accumulatedMoments[n]&&(this.accumulatedMoments[n]={originalName:`${t}/momentum`,variable:oo((()=>Ta(r).variable(s)))}),null==this.accumulatedMeanGrads[n]&&this.centered&&(this.accumulatedMeanGrads[n]={originalName:`${t}/mg`,variable:oo((()=>Ta(r).variable(s)))});const o=Array.isArray(e)?e[n].tensor:e[t];if(null==o)return;const a=this.accumulatedMeanSquares[n].variable,i=this.accumulatedMoments[n].variable;oo((()=>{const e=lo(ho(a,this.decay),ho(qa(o),1-this.decay));if(this.centered){const t=this.accumulatedMeanGrads[n].variable,s=lo(ho(t,this.decay),ho(o,1-this.decay)),l=co(ho(o,this.learningRate),Ka(vi(e,lo(qa(s),this.epsilon)))),u=lo(ho(i,this.momentum),l);a.assign(e),t.assign(s),i.assign(u);const c=vi(r,u);r.assign(c)}else{const e=lo(ho(a,this.decay),ho(qa(o),1-this.decay)),t=lo(ho(i,this.momentum),co(ho(o,this.learningRate),Ka(lo(e,this.epsilon))));a.assign(e),i.assign(t);const n=vi(r,t);r.assign(n)}}))})),this.incrementIterations()}dispose(){null!=this.accumulatedMeanSquares&&ao(this.accumulatedMeanSquares.map((e=>e.variable))),null!=this.accumulatedMeanGrads&&this.centered&&ao(this.accumulatedMeanGrads.map((e=>e.variable))),null!=this.accumulatedMoments&&ao(this.accumulatedMoments.map((e=>e.variable)))}async getWeights(){const e=[...this.accumulatedMeanSquares,...this.accumulatedMoments];return this.centered&&e.push(...this.accumulatedMeanGrads),[await this.saveIterations()].concat(e.map((e=>({name:e.originalName,tensor:e.variable}))))}async setWeights(e){e=await this.extractIterations(e);const t=this.centered?e.length/3:e.length/2,n=!1;this.accumulatedMeanSquares=e.slice(0,t).map((e=>({originalName:e.name,variable:e.tensor.variable(n)}))),this.accumulatedMoments=e.slice(t,2*t).map((e=>({originalName:e.name,variable:e.tensor.variable(n)}))),this.centered&&(this.accumulatedMeanGrads=e.slice(2*t,3*t).map((e=>({originalName:e.name,variable:e.tensor.variable(n)}))))}getConfig(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}}static fromConfig(e,t){return new e(t.learningRate,t.decay,t.momentum,t.epsilon,t.centered)}}const th=[jc,Zc,Jc,Yc,Qc,eh,Xc];function nh(e){return new Promise((e=>setTimeout(e))).then(e)}class rh{constructor(e){if(!O().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(rh.URL_SCHEME)&&(e=e.slice(rh.URL_SCHEME.length)),null!=e&&0!==e.length||(e="model"),this.modelJsonFileName=e+".json",this.weightDataFileName=e+".weights.bin"}async save(e){if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");const t=window.URL.createObjectURL(new Blob([e.weightData],{type:"application/octet-stream"}));if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");{const n=ws(e,[{paths:["./"+this.weightDataFileName],weights:e.weightSpecs}]),r=window.URL.createObjectURL(new Blob([JSON.stringify(n)],{type:"application/json"})),s=null==this.modelJsonAnchor?document.createElement("a"):this.modelJsonAnchor;if(s.download=this.modelJsonFileName,s.href=r,await nh((()=>s.dispatchEvent(new MouseEvent("click")))),null!=e.weightData){const e=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor;e.download=this.weightDataFileName,e.href=t,await nh((()=>e.dispatchEvent(new MouseEvent("click"))))}return{modelArtifactsInfo:xs(e)}}}}rh.URL_SCHEME="downloads://";class sh{constructor(e){if(null==e||e.length<1)throw new Error(`When calling browserFiles, at least 1 file is required, but received ${e}`);this.jsonFile=e[0],this.weightsFiles=e.slice(1)}async load(){return new Promise(((e,t)=>{const n=new FileReader;n.onload=n=>{const r=JSON.parse(n.target.result),s=r.modelTopology;if(null==s)return void t(new Error(`modelTopology field is missing from file ${this.jsonFile.name}`));if(null==r.weightsManifest)return void t(new Error(`weightManifest field is missing from file ${this.jsonFile.name}`));if(0===this.weightsFiles.length)return void e({modelTopology:s});const o=vs(r,(e=>this.loadWeights(e)));e(o)},n.onerror=e=>t(`Failed to read model topology and weights manifest JSON from file '${this.jsonFile.name}'. BrowserFiles supports loading Keras-style tf.Model artifacts only.`),n.readAsText(this.jsonFile)}))}loadWeights(e){const t=[],n=[];for(const r of e)t.push(...r.weights),n.push(...r.paths);const r=this.checkManifestAndWeightFiles(e),s=n.map((e=>this.loadWeightsFile(e,r[e])));return Promise.all(s).then((e=>[t,bs(e)]))}loadWeightsFile(e,t){return new Promise(((n,r)=>{const s=new FileReader;s.onload=e=>{const t=e.target.result;n(t)},s.onerror=t=>r(`Failed to weights data from file of path '${e}'.`),s.readAsArrayBuffer(t)}))}checkManifestAndWeightFiles(e){const t=[],n=this.weightsFiles.map((e=>ys(e.name))),r={};for(const s of e)s.paths.forEach((e=>{const s=ys(e);if(-1!==t.indexOf(s))throw new Error(`Duplicate file basename found in weights manifest: '${s}'`);if(t.push(s),-1===n.indexOf(s))throw new Error(`Weight file with basename '${s}' is not provided.`);r[e]=this.weightsFiles[n.indexOf(s)]}));if(t.length!==this.weightsFiles.length)throw new Error(`Mismatch in the number of files in weights manifest (${t.length}) and the number of weight files provided (${this.weightsFiles.length}).`);return r}}function oh(e,t,n,r){!function(e){i(null!=e&&Array.isArray(e)&&e.length>0,(()=>"promises must be a none empty array"))}(e),function(e,t){i(e>=0&&e<=1,(()=>`Progress fraction must be in range [0, 1], but got startFraction ${e}`)),i(t>=0&&t<=1,(()=>`Progress fraction must be in range [0, 1], but got endFraction ${t}`)),i(t>=e,(()=>`startFraction must be no more than endFraction, but got startFraction ${e} and endFraction ${t}`))}(n=null==n?0:n,r=null==r?1:r);let s=0;return Promise.all(e.map((o=>(o.then((o=>{const a=n+ ++s/e.length*(r-n);return t(a),o})),o))))}async function ah(e,t){null==t&&(t={});const n=null==t.fetchFunc?O().platform.fetch:t.fetchFunc,r=e.map((e=>n(e,t.requestInit,{isBinary:!0}))),s=(null==t.onProgress?await Promise.all(r):await oh(r,t.onProgress,0,.5)).map((e=>e.arrayBuffer()));return null==t.onProgress?await Promise.all(s):await oh(s,t.onProgress,.5,1)}function ih(e){return async(t,n="",r)=>{const s=t.map((()=>!1)),o={},a=null!=r?r.map((()=>!1)):[],i=[];if(t.forEach(((e,t)=>{let n=0;e.weights.forEach((e=>{const l="quantization"in e?e.quantization.dtype:e.dtype,u=ds[l]*c(e.shape),h=()=>{s[t]=!0,null==o[t]&&(o[t]=[]),o[t].push({manifestEntry:e,groupOffset:n,sizeBytes:u})};null!=r?r.forEach(((t,n)=>{t===e.name&&(h(),a[n]=!0)})):h(),i.push(e.name),n+=u}))})),!a.every((e=>e))){const e=r.filter(((e,t)=>!a[t]));throw new Error(`Could not find weights in manifest with names: ${e.join(", ")}. \nManifest JSON has weights with names: ${i.join(", ")}.`)}const l=s.reduce(((e,t,n)=>(t&&e.push(n),e)),[]),u=[];l.forEach((e=>{t[e].paths.forEach((e=>{const t=n+(n.endsWith("/")?"":"/")+e;u.push(t)}))}));const h=await e(u),d={};let p=0;return l.forEach((e=>{const n=t[e].paths.length;let r=0;for(let e=0;e<n;e++)r+=h[p+e].byteLength;const s=new ArrayBuffer(r),a=new Uint8Array(s);let i=0;for(let e=0;e<n;e++){const t=new Uint8Array(h[p+e]);a.set(t,i),i+=t.byteLength}o[e].forEach((e=>{const t=ps(s.slice(e.groupOffset,e.groupOffset+e.sizeBytes),[e.manifestEntry]);for(const e in t)d[e]=t[e]})),p+=n})),d}}$s.registerSaveRouter((e=>O().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(rh.URL_SCHEME)?function(e="model"){return new rh(e)}(e.slice(rh.URL_SCHEME.length)):null));class lh{constructor(e,t){if(this.DEFAULT_METHOD="POST",null==t&&(t={}),this.weightPathPrefix=t.weightPathPrefix,this.onProgress=t.onProgress,this.weightUrlConverter=t.weightUrlConverter,null!=t.fetchFunc?(i("function"==typeof t.fetchFunc,(()=>"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)")),this.fetch=t.fetchFunc):this.fetch=O().platform.fetch,i(null!=e&&e.length>0,(()=>"URL path for http must not be null, undefined or empty.")),Array.isArray(e)&&i(2===e.length,(()=>`URL paths for http must have a length of 2, (actual length is ${e.length}).`)),this.path=e,null!=t.requestInit&&null!=t.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=t.requestInit||{}}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");const t=Object.assign({method:this.DEFAULT_METHOD},this.requestInit);t.body=new FormData;const n=ws(e,[{paths:["./model.weights.bin"],weights:e.weightSpecs}]);t.body.append("model.json",new Blob([JSON.stringify(n)],{type:"application/json"}),"model.json"),null!=e.weightData&&t.body.append("model.weights.bin",new Blob([e.weightData],{type:"application/octet-stream"}),"model.weights.bin");const r=await this.fetch(this.path,t);if(r.ok)return{modelArtifactsInfo:xs(e),responses:[r]};throw new Error(`BrowserHTTPRequest.save() failed due to HTTP response status ${r.status}.`)}async load(){const e=await this.fetch(this.path,this.requestInit);if(!e.ok)throw new Error(`Request to ${this.path} failed with status code ${e.status}. Please verify this URL points to the model JSON of the model to load.`);let t;try{t=await e.json()}catch(e){let t=`Failed to parse model JSON of response from ${this.path}.`;throw this.path.endsWith(".pb")?t+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":t+=" Please make sure the server is serving valid JSON for this request.",new Error(t)}const n=t.modelTopology,r=t.weightsManifest;if(null==n&&null==r)throw new Error(`The JSON from HTTP path ${this.path} contains neither model topology or manifest for weights.`);return vs(t,(e=>this.loadWeights(e)))}async loadWeights(e){const t=Array.isArray(this.path)?this.path[1]:this.path,[n,r]=function(e){const t=e.lastIndexOf("/"),n=e.lastIndexOf("?"),r=e.substring(0,t),s=n>t?e.substring(n):"";return[r+"/",s]}(t),s=this.weightPathPrefix||n,o=Es(e),a=[],i=[];for(const t of e)for(const e of t.paths)null!=this.weightUrlConverter?i.push(this.weightUrlConverter(e)):a.push(s+e+r);this.weightUrlConverter&&a.push(...await Promise.all(i));return[o,bs(await ah(a,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress}))]}}function uh(e){return null!=e.match(lh.URL_SCHEME_REGEX)}lh.URL_SCHEME_REGEX=/^https?:\/\//;const ch=(e,t)=>{if("undefined"==typeof fetch&&(null==t||null==t.fetchFunc))return null;{let n=!0;if(n=Array.isArray(e)?e.every((e=>uh(e))):uh(e),n)return hh(e,t)}return null};function hh(e,t){return new lh(e,t)}$s.registerSaveRouter(ch),$s.registerLoadRouter(ch);class dh{constructor(e){this.modelArtifacts=e}load(){return this.modelArtifacts}}class ph{constructor(e){this.saveHandler=e}save(e){return this.saveHandler(e)}}class fh{constructor(e){e.load&&(this.load=()=>Promise.resolve(e.load())),e.save&&(this.save=t=>Promise.resolve(e.save(t)))}}function gh(e,t,n,r){if(1===arguments.length){return null!=e.modelTopology||null!=e.weightSpecs?new dh(e):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new dh({modelTopology:e}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new dh({modelTopology:e,weightSpecs:t,weightData:n,trainingConfig:r})}var mh={__proto__:null,browserFiles:function(e){return new sh(e)},browserHTTPRequest:function(e,t){return hh(e,t)},concatenateArrayBuffers:bs,decodeWeights:ps,encodeWeights:async function(e,t){const n=[],r=[],s=Array.isArray(e)?e.map((e=>e.name)):Object.keys(e);for(let o=0;o<s.length;++o){const a=s[o],i=Array.isArray(e)?e[o].tensor:e[a];if("float32"!==i.dtype&&"int32"!==i.dtype&&"bool"!==i.dtype&&"string"!==i.dtype&&"complex64"!==i.dtype)throw new Error(`Unsupported dtype in weight '${a}': ${i.dtype}`);const l={name:a,shape:i.shape,dtype:i.dtype};if("string"===i.dtype){const e=new Promise((async e=>{const t=await i.bytes(),n=t.reduce(((e,t)=>e+t.length),0)+4*t.length,r=new Uint8Array(n);let s=0;for(let e=0;e<t.length;e++){const n=t[e],o=new Uint8Array(new Uint32Array([n.length]).buffer);r.set(o,s),s+=4,r.set(n,s),s+=n.length}e(r)}));r.push(e)}else r.push(i.data());null!=t&&(l.group=t),n.push(l)}return{data:fs(await Promise.all(r)),specs:n}},fromMemory:function(e,t,n,r){const s=arguments;return new fh(gh(...s))},fromMemorySync:gh,getLoadHandlers:(e,t)=>$s.getLoadHandlers(e,t),getModelArtifactsForJSON:vs,getModelArtifactsForJSONSync:ks,getModelArtifactsInfoForJSON:xs,getSaveHandlers:e=>$s.getSaveHandlers(e),getWeightSpecs:Es,http:hh,isHTTPScheme:uh,loadWeights:async function(e,t="",n,r){return ih((e=>ah(e,{requestInit:r})))(e,t,n)},registerLoadRouter:e=>$s.registerLoadRouter(e),registerSaveRouter:e=>$s.registerSaveRouter(e),weightsLoaderFactory:ih,withSaveHandler:function(e){return new ph(e)},withSaveHandlerSync:function(e){return new ph(e)},copyModel:async function(e,t){return Js(e,t,!1)},listModels:async function(){const e=js.getSchemes(),t={};for(const n of e){const e=await js.getManager(n).listModels();for(const r in e){t[n+Hs+r]=e[r]}}return t},moveModel:async function(e,t){return Js(e,t,!0)},removeModel:async function(e){const t=Zs(e);return js.getManager(t.scheme).removeModel(t.path)}};var bh={__proto__:null,confusionMatrix:ls({confusionMatrix_:function(e,t,n){const r=os(e,"labels","confusionMatrix"),s=os(t,"predictions","confusionMatrix");i(null==n||n>0&&Number.isInteger(n),(()=>`If provided, numClasses must be a positive integer, but got ${n}`)),i(1===r.rank,(()=>`Expected the rank of labels to be 1, but got ${r.rank}`)),i(1===s.rank,(()=>`Expected the rank of predictions to be 1, but got ${s.rank}`)),i(r.shape[0]===s.shape[0],(()=>`Mismatch in the number of examples: ${r.shape[0]} vs. ${s.shape[0]}. Labels and predictions should have the same number of elements.`)),i(n>0&&Number.isInteger(n),(()=>`numClasses is required to be a positive integer, but got ${n}`));const o=Ki(no(r,"int32"),n),a=Ki(no(s,"int32"),n),l=Eu(o),u=Go(l,a);return no(u,"int32")}})};let yh;function wh(e,t=3){if(t>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==e)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");let n=!1,r=!1,s=!1,o=!1,a=!1,i=!1;if(e.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&e instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&e instanceof HTMLVideoElement)s=!0;else if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement)o=!0;else if(null!=e.getContext)a=!0;else{if(!("undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap))throw new Error(`pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was ${e.constructor.name}`);i=!0}if(null!=Sn(mn,Jr.backendName)){const n={pixels:e},r={numChannels:t};return Jr.runKernel(mn,n,r)}const[l,u]=s?[e.videoWidth,e.videoHeight]:[e.width,e.height];let c,h;if(a)c=e.getContext("2d").getImageData(0,0,l,u).data;else if(r||n)c=e.data;else if(o||s||i){if(null==yh)if("undefined"==typeof document){if("undefined"==typeof OffscreenCanvas||"undefined"==typeof OffscreenCanvasRenderingContext2D)throw new Error("Cannot parse input in current context. Reason: OffscreenCanvas Context2D rendering is not supported.");yh=new OffscreenCanvas(1,1).getContext("2d")}else yh=document.createElement("canvas").getContext("2d",{willReadFrequently:!0});yh.canvas.width=l,yh.canvas.height=u,yh.drawImage(e,0,0,l,u),c=yh.getImageData(0,0,l,u).data}if(4===t)h=new Int32Array(c);else{const e=l*u;h=new Int32Array(e*t);for(let n=0;n<e;n++)for(let e=0;e<t;++e)h[n*t+e]=c[4*n+e]}return uu(h,[u,l,t],"int32")}function kh(e){return"undefined"!=typeof window&&"undefined"!=typeof ImageBitmap&&window.hasOwnProperty("createImageBitmap")&&!(e instanceof ImageBitmap)&&function(e){return null!=e&&0!==e.width&&0!==e.height}(e)&&!function(e){return null!=e&&e.data instanceof Uint8Array}(e)}var vh={__proto__:null,fromPixelsAsync:async function(e,t=3){let n=null;if(O().getBool("WRAP_TO_IMAGEBITMAP")&&kh(e)){let t;try{t=await createImageBitmap(e,{premultiplyAlpha:"none"})}catch(e){t=null}n=null!=t&&t.width===e.width&&t.height===e.height?t:e}else n=e;return wh(n,t)},toPixels:async function(e,t){let n=os(e,"img","toPixels");if(!(e instanceof Mr)){const e=n;n=no(e,"int32"),e.dispose()}if(2!==n.rank&&3!==n.rank)throw new Error(`toPixels only supports rank 2 or 3 tensors, got rank ${n.rank}.`);const[r,s]=n.shape.slice(0,2),o=2===n.rank?1:n.shape[2];if(o>4||2===o)throw new Error(`toPixels only supports depth of size 1, 3 or 4 but got ${o}`);if("float32"!==n.dtype&&"int32"!==n.dtype)throw new Error(`Unsupported type for toPixels: ${n.dtype}. Please use float32 or int32 tensors.`);const a=await n.data(),i="float32"===n.dtype?255:1,l=new Uint8ClampedArray(s*r*4);for(let e=0;e<r*s;++e){const t=[0,0,0,255];for(let r=0;r<o;r++){const s=a[e*o+r];if("float32"===n.dtype){if(s<0||s>1)throw new Error(`Tensor values for a float32 Tensor must be in the range [0 - 1] but encountered ${s}.`)}else if("int32"===n.dtype&&(s<0||s>255))throw new Error(`Tensor values for a int32 Tensor must be in the range [0 - 255] but encountered ${s}.`);1===o?(t[0]=s*i,t[1]=s*i,t[2]=s*i):t[r]=s*i}const r=4*e;l[r+0]=Math.round(t[0]),l[r+1]=Math.round(t[1]),l[r+2]=Math.round(t[2]),l[r+3]=Math.round(t[3])}if(null!=t){t.width=s,t.height=r;const e=t.getContext("2d"),n=new ImageData(l,s,r);e.putImageData(n,0,0)}return n!==e&&n.dispose(),l},fromPixels:ls({fromPixels_:wh})};function xh(e,t){const n=e.shape.length,r=t.shape.length;if(n<1)throw new Error(`tf.gatherND() expects the input to be rank 1 or higher, but the rank was ${n}.`);if(r<1)throw new Error(`tf.gatherND() expects the indices to be rank 1 or higher, but the rank was ${r}.`);if("int32"!==t.dtype)throw new Error(`tf.gatherND() expects the indices to be int32 type, but the dtype was ${t.dtype}.`);if(t.shape[r-1]>n)throw new Error(`index innermost dimension length must be <= tensor rank; saw: ${t.shape[r-1]} vs. ${n}`);if(0===c(e.shape))throw new Error(`Requested more than 0 entries, but input is empty. Input shape: ${e.shape}.`);const s=t.shape,o=s[s.length-1];let a=1;for(let e=0;e<s.length-1;++e)a*=s[e];const i=e.shape,l=s.slice();l.pop();let u=1;for(let e=o;e<n;++e)u*=i[e],l.push(i[e]);const h=[...I(e.shape).map((e=>e/u)),1].slice(0,o);return[l,a,u,h]}var Eh={__proto__:null,prepareAndValidate:xh};function Sh(e,t,n,r){const s=[...e];for(let e=s.length;e<r.length;e++)s.push(1);for(let e=0;e<n;e++)0===e?s[t]=1:(s.splice(t,0,1),s.pop());return s}function $h(e,t,n){return n<=e?n:n-(t-1)}function Ah(e,t){const n=[];for(let r=0;r<e;r++)n.push(t+r);return n}function _h(e,t,n,r,s){const o=[...s],a=Ah(n,t);for(let s=0;s<o.length;s++)if(a.indexOf(s)>-1)o[s]=0;else{const a=$h(t,n,s);let i=r[a];e&1<<a&&(i=0),o[s]=i}return o}function Ih(e,t,n,r,s){const a=[...s],i=Ah(n,t);for(let s=0;s<a.length;s++)if(i.indexOf(s)>-1)a[s]=Number.MAX_SAFE_INTEGER;else{const o=$h(t,n,s);let i=r[o];e&1<<o&&(i=Number.MAX_SAFE_INTEGER),a[s]=i}for(let e=0;e<a.length;e++){const t=s[e];a[e]<0&&(a[e]+=t),a[e]=o(0,a[e],s[e])}return a}function Nh(e,t,n){let r=e[t];return(n&1<<t||null==r)&&(r=1),r}function Mh(e,t,n,r,s,a){let i=t[s];const l=n[s]||1;(e&1<<s||a&1<<s||null==i)&&(i=l>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);const u=r[s];return i<0&&(i+=u),i=o(0,i,u-1),i}function Th(e,t,n,r,s,a){let i=t[s];const l=n[s]||1;(e&1<<s||a&1<<s||null==i)&&(i=l>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);const u=r[s];return i<0&&(i+=u),i=l>0?o(0,i,u):o(-1,i,u-1),i}function Dh(e,t,n,r,s,o){if(s[t])return n>0?o[t]:o[t+1&1];{const t=e<0?r+e:e;return t<o[0]?o[0]:t>o[1]?o[1]:t}}var Rh={__proto__:null,assertParamsValid:function(e,t,n){const r=e.shape.length;i(r===t.length,(()=>`Error in slice${r}D: Length of begin ${t} must match the rank of the array (${r}).`)),i(r===n.length,(()=>`Error in slice${r}D: Length of size ${n} must match the rank of the array (${r}).`));for(let s=0;s<r;++s)i(t[s]+n[s]<=e.shape[s],(()=>`Error in slice${r}D: begin[${s}] + size[${s}] (${t[s]+n[s]}) would overflow input.shape[${s}] (${e.shape[s]})`))},maskToAxes:function(e){const t=[];let n=0;for(;e>0;)1&e&&t.push(n),e/=2,n++;return t},computeOutShape:function(e,t,n){const r=[];for(let s=0;s<e.length;s++)r[s]=Math.ceil((t[s]-e[s])/n[s]);return r},stridesWithElidedDims:Sh,getNormalizedAxes:function(e,t,n,r,s,o,a,i,l){const u=e.length;let c=new Array(u),h=new Array(u),d=new Array(u);if(t.length&&n>0){const l=t[0],u=n+1;c=_h(a,l,u,r,e),h=Ih(i,l,u,s,e),d=Sh(o,l,u,e)}else for(let t=0;t<u;t++)c[t]=Mh(a,r,o,e,t,l),h[t]=Th(i,s,o,e,t,l),d[t]=Nh(o,t,l);return{begin:c,end:h,strides:d}},startIndicesWithElidedDims:_h,stopIndicesWithElidedDims:Ih,stridesForAxis:Nh,startForAxis:Mh,stopForAxis:Th,isSliceContinous:function(e,t,n){let r=n.length;for(let e=0;e<n.length;e++)if(n[e]>1){r=e;break}for(let s=r+1;s<n.length;s++)if(t[s]>0||n[s]!==e[s])return!1;return!0},computeFlatOffset:function(e,t){let n=e.length>0?e[e.length-1]:1;for(let r=0;r<e.length-1;r++)n+=e[r]*t[r];return n},parseSliceParams:function(e,t,n){let r;const s=e.shape.length;let o;return r="number"==typeof t?[t,...new Array(s-1).fill(0)]:t.length<s?t.concat(new Array(s-t.length).fill(0)):t.slice(),r.forEach((e=>{i(-1!==e,(()=>"slice() does not support negative begin indexing."))})),o=null==n?new Array(s).fill(-1):"number"==typeof n?[n,...new Array(s-1).fill(-1)]:n.length<s?n.concat(new Array(s-n.length).fill(-1)):n,o=o.map(((t,n)=>t>=0?t:(i(-1===t,(()=>`Negative size values should be exactly -1 but got ${t} for the slice() size at index ${n}.`)),e.shape[n]-r[n]))),[r,o]},sliceInfo:function(e,t,n,r,s,o,a,i,l){let u;if(null==r?(u=new Array(t.length),u.fill(1)):u=r,null!=a&&0!=(a&a-1))throw new Error("Multiple ellipses in slice is not allowed.");let c=!1;const h={dims:u.length,numAddAxisAfterEllipsis:0,begin:t.slice(),end:n.slice(),strides:u.slice(),beginMask:s,endMask:o,ellipsisMask:a,newAxisMask:i,shrinkAxisMask:l};for(let e=0;e<h.dims;e++)c&&0!=(1<<e&i)&&h.numAddAxisAfterEllipsis++,1<<e&a&&(c=!0);c||(h.ellipsisMask|=1<<h.dims,h.dims++);const d={dims:e.length,beginMask:0,endMask:0,beginValid:!1,endValid:!1};!function(e,t){t.beginMask=0,t.endMask=0,t.shrinkAxisMask=0;let n=0;t.beginValid=null!=e.begin,t.endValid=null!=e.end,t.begin=new Array(t.dims),t.end=new Array(t.dims),t.strides=new Array(t.dims),t.finalShapeGatherIndices=[],t.finalShapeGatherIndicesSparse=[],t.inputShapeGatherIndicesSparse=new Array(t.dims);for(let r=0;r<e.dims;r++)if(1<<r&e.ellipsisMask){const s=Math.min(t.dims-(e.dims-r)+1+e.numAddAxisAfterEllipsis,t.dims);for(;n<s;n++)t.begin[n]=0,t.end[n]=0,t.strides[n]=1,t.beginMask|=1<<n,t.endMask|=1<<n,t.finalShapeGatherIndices.push(n),t.finalShapeGatherIndicesSparse.push(-1),t.inputShapeGatherIndicesSparse[n]=r}else if(1<<r&e.newAxisMask)t.finalShapeGatherIndices.push(-2),t.finalShapeGatherIndicesSparse.push(-1);else{if(n===t.begin.length)throw Error(`Index out of range using input dim ${n}; input has only ${t.dims} dims, ${t.begin.length}.`);null!=e.begin&&(t.begin[n]=e.begin[r]),null!=e.end&&(t.end[n]=e.end[r]),t.strides[n]=e.strides[r],e.beginMask&1<<r&&(t.beginMask|=1<<n),e.endMask&1<<r&&(t.endMask|=1<<n),e.shrinkAxisMask&1<<r?(t.finalShapeGatherIndices.push(-1),t.finalShapeGatherIndicesSparse.push(-1),t.shrinkAxisMask|=1<<n):(t.finalShapeGatherIndices.push(n),t.finalShapeGatherIndicesSparse.push(r)),t.inputShapeGatherIndicesSparse[n]=r,n++}}(h,d);let p=!0,f=!0,g=!0;const m=[],b=[];for(let t=0;t<e.length;++t){if(0===d.strides[t])throw Error(`strides[${t}] must be non-zero`);const n=!!(d.shrinkAxisMask&1<<t),r=e[t];if(-1===r){m.push(n?1:-1);continue}const s=[d.beginMask&1<<t,d.endMask&1<<t],o=[d.strides[t]>0?0:-1,d.strides[t]>0?r:r-1];if(n&&d.strides[t]<=0)throw Error("only stride 1 allowed on non-range indexing.");g=g&&1===d.strides[t];const a=!!(d.beginMask&1<<t&&d.endMask&1<<t);if(d.beginValid&&d.endValid){if(n){const e=d.begin[t]<0?r+d.begin[t]:d.begin[t];if(d.begin[t]=e,d.end[t]=d.begin[t]+1,e<0||e>=r)throw Error(`slice index ${d.begin[t]} of dimension ${t} out of bounds.`)}else d.begin[t]=Dh(d.begin[t],0,d.strides[t],r,s,o),d.end[t]=Dh(d.end[t],1,d.strides[t],r,s,o);const e=1===d.strides[t]&&0===d.begin[t]&&d.end[t]===r;p=p&&e,f=f&&(0===t&&1===d.strides[t]||e)}else p=p&&1===d.strides[t]&&a,f=f&&(0===t&&1===d.strides[t]||a);let i,l=!1;if(d.beginValid&&d.endValid?(i=d.end[t]-d.begin[t],l=!0):n?(i=1,l=!0):a&&r>=0&&(i=d.strides[t]<0?-r:r,l=!0),l){let e;e=0===i||i<0!=d.strides[t]<0?0:Math.trunc(i/d.strides[t])+(i%d.strides[t]!=0?1:0),m.push(e)}else m.push(-1)}for(let e=0;e<d.finalShapeGatherIndices.length;++e){const t=d.finalShapeGatherIndices[e];t>=0?b.push(m[t]):-2===t&&b.push(1)}return{finalShapeSparse:b.filter(((e,t)=>-2!==d.finalShapeGatherIndices[t])),finalShape:b,isIdentity:p,sliceDim0:f,isSimpleSlice:g,begin:d.begin,end:d.end,strides:d.strides}}};class Fh{static sgd(e){return new Xc(e)}static momentum(e,t,n=!1){return new Qc(e,t,n)}static rmsprop(e,t=.9,n=0,r=null,s=!1){return new eh(e,t,n,r,s)}static adam(e=.001,t=.9,n=.999,r=null){return new Jc(e,t,n,r)}static adadelta(e=.001,t=.95,n=null){return new jc(e,t,n)}static adamax(e=.002,t=.9,n=.999,r=null,s=0){return new Yc(e,t,n,r,s)}static adagrad(e,t=.1){return new Zc(e,t)}}const Bh=Fh,Ch="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:e=>e();var Ph;!function(e){e[e.FIRST_DIM_SIZE=0]="FIRST_DIM_SIZE",e[e.VALUE_ROWIDS=1]="VALUE_ROWIDS",e[e.ROW_LENGTHS=2]="ROW_LENGTHS",e[e.ROW_SPLITS=3]="ROW_SPLITS",e[e.ROW_LIMITS=4]="ROW_LIMITS",e[e.ROW_STARTS=5]="ROW_STARTS"}(Ph||(Ph={}));const Oh="->",Lh=/->/g;function zh(e,t){const n=[];for(let r=0;r<e.length;++r)0!==e[r].length&&-1===e[r].indexOf(t)&&-1!==t||n.push(r);return n}var Wh={__proto__:null,slice_util:Rh,segment_util:{__proto__:null,segOpComputeOptimalWindowSize:function(e,t){let n,r=!1;for(e<=30?(n=e,r=!0):n=_(e,Math.floor(Math.sqrt(e)));!r;)n>t||n===e?r=!0:n=_(e,n+1);return n},computeOutShape:function(e,t,n){const r=[],s=e.length;for(let o=0;o<s;o++)o!==t?r.push(e[o]):r.push(n);return r},collectGatherOpShapeInfo:function(e,t,n,r){const s=t.shape.length,o=e.shape.length;if(0!==r&&(r<-s||r>s))throw new Error(`Expect batchDims in the range of [-${s}, ${s}], but got ${r}`);if(r<0&&(r+=s),r>o)throw new Error(`batchDims (${r}) must be less than rank(x) (\n    ${o}).`);if(n<r)throw new Error(`batchDims (${r}) must be less than or equal to axis (${n}).`);for(let n=0;n<r;++n)if(e.shape[n]!==t.shape[n])throw new Error(`x.shape[${n}]: ${e.shape[n]} should be equal to indices.shape[${n}]: ${t.shape[n]}.`);const a=e.shape[n],i=[];let l=1,u=1,c=1;for(let t=0;t<r;++t)i.push(e.shape[t]),l*=e.shape[t];for(let t=r;t<n;t++)i.push(e.shape[t]),u*=e.shape[t];for(let e=r;e<s;e++)i.push(t.shape[e]);for(let t=n+1;t<o;t++)i.push(e.shape[t]),c*=e.shape[t];return{batchSize:l,sliceSize:c,outerSize:u,dimSize:a,outputShape:i}}},fromUint8ToStringArray:function(e){try{return e.map((e=>gr(e)))}catch(e){throw new Error(`Failed to decode encoded string bytes into utf-8, error: ${e}`)}},fromStringArrayToUint8:function(e){return e.map((e=>fr(e)))},upcastType:Or,axesAreInnerMostDims:Pa,combineLocations:Oa,computeOutAndReduceShapes:function(e,t){const n=[],r=e.length;for(let s=0;s<r;s++)-1===t.indexOf(s)&&n.push(e[s]);return[n,t.map((t=>e[t]))]},expandShapeToKeepDim:La,assertAxesAreInnerMostDims:function(e,t,n){i(Pa(t,n),(()=>`${e} supports only inner-most axes for now. Got axes ${t} and rank-${n} input.`))},getAxesPermutation:function(e,t){if(Pa(e,t))return null;const n=[];for(let r=0;r<t;++r)-1===e.indexOf(r)&&n.push(r);return e.forEach((e=>n.push(e))),n},getUndoAxesPermutation:function(e){return e.map(((e,t)=>[t,e])).sort(((e,t)=>e[1]-t[1])).map((e=>e[0]))},getInnerMostAxes:function(e,t){const n=[];for(let r=t-e;r<t;++r)n.push(r);return n},getBroadcastDims:$a,getReductionAxes:Aa,assertAndGetBroadcastShape:_a,assertParamsConsistent:function(e,t){const n=e[0].length;e.forEach(((e,t)=>{i(e.length===n,(()=>`Error in concat${n}D: rank of tensors[${t}] must be the same as the rank of the rest (${n})`))})),i(t>=0&&t<n,(()=>`Error in concat${n}D: axis must be between 0 and ${n-1}.`));const r=e[0];e.forEach(((e,s)=>{for(let o=0;o<n;o++)i(o===t||e[o]===r[o],(()=>`Error in concat${n}D: Shape of tensors[${s}] (${e}) does not match the shape of the rest (${r}) along the non-concatenated axis ${s}.`))}))},computeOutShape:function(e,t){const n=e[0].slice();for(let r=1;r<e.length;r++)n[t]+=e[r][t];return n},computeDilation2DInfo:function(e,t,n,r,s="NHWC",o){return _o(e,[...t,e[3]],n,o,r,null,null,Po(s))},computePool2DInfo:Ao,computePool3DInfo:function(e,t,n,r,s,o,a="NDHWC"){const[i,l,u]=To(t);let c,h;if("NDHWC"===a)h="channelsLast",c=[i,l,u,e[4],e[4]];else{if("NCDHW"!==a)throw new Error(`Unknown dataFormat ${a}`);h="channelsFirst",c=[i,l,u,e[1],e[1]]}return Io(e,c,n,r,s,!1,h,o)},computeConv2DInfo:_o,computeConv3DInfo:Io,computeDefaultPad:No,tupleValuesAreOne:Fo,eitherStridesOrDilationsAreOne:Bo,stridesOrDilationsArePositive:Co,convertConv2DDataFormat:Po,checkPadOnDimRoundingMode:Oo,getFusedDyActivation:Ru,getFusedBiasGradient:Fu,applyActivation:Bu,shouldFuse:Cu,get RowPartitionType(){return Ph},combineRaggedTensorToTensorShapes:function(e,t,n){let r=new Array;if(null==n&&null==t)return r;if(null==t)for(;r.length<e+n.length;)r.push(-1);else r=t.slice();if(null==n)return r;if(e+n.length!==r.length)throw new Error(`rt input.shape and shape=${t} are incompatible: rt input.rank = ${e+n.length}, but shape.rank = ${r.length}`);for(let s=1;s<n.length;++s){const o=n[s],a=r[r.length-n.length+s],i=r[a];if(o>=0)if(i>=0){if(i!==o)throw new Error(`rt input.shape and shape=${t} are incompatible: rt input.shape[${s+e}] = ${o} but shape[${s+e}] = ${i}`)}else r[a]=o}return r},getRowPartitionTypesHelper:function(e){const t={FIRST_DIM_SIZE:Ph.FIRST_DIM_SIZE,VALUE_ROWIDS:Ph.VALUE_ROWIDS,ROW_LENGTHS:Ph.ROW_LENGTHS,ROW_SPLITS:Ph.ROW_SPLITS,ROW_LIMITS:Ph.ROW_LIMITS,ROW_STARTS:Ph.ROW_STARTS},n=[];for(const r of e){if(!(r in t))break;n.push(t[r])}return n},getRaggedRank:function(e){return 0===e.length?0:e[0]===Ph.FIRST_DIM_SIZE?e.length-1:e.length},validateDefaultValueShape:function(e,t){if(null==e||null==t)return;const n=e.length,r=t.length;if(n>=r)throw new Error(`defaultValue.shape=${e} and ragged tensor flatValues.shape=${t}, are incompatible: defaultValue.rank = ${n} must be less than ragged tensor input flatValues.rank = ${r})`);for(let s=0;s<Math.min(n,r-1);++s){const n=e[s],r=t[s+1];if(n>=0&&r>=0&&1!==n&&n!==r)throw new Error(`defaultValue.shape=${e}, and ragged tensor input flatValues.shape=${t} are incompatible: defaultValue.shape[${s-e.length}] = ${n} but ragged tensor input.flatValues.shape[${s-e.length}] = ${r}`)}},PARALLELIZE_THRESHOLD:30,computeOptimalWindowSize:function(e){return e<=30?e:_(e,Math.floor(Math.sqrt(e)))},getImageCenter:function(e,t,n){return[n*("number"==typeof e?e:e[0]),t*("number"==typeof e?e:e[1])]},getReshaped:function(e,t,n,r=!0){let s=[];if(r)s=s.concat(t.slice(0)),s.push(e[0]/n),s=s.concat(e.slice(1));else{s=s.concat(e[0]);const n=t.length;for(let r=0;r<n;++r)s=s.concat([e[r+1]/t[r],t[r]]);s=s.concat(e.slice(n+1))}return s},getPermuted:function(e,t,n=!0){const r=[];if(n){r.push(t);for(let n=t+1;n<e;++n)n<=2*t?(r.push(n),r.push(n-(t+1))):r.push(n)}else{const n=[],s=[];for(let r=1;r<e;++r)r>=2*t+1||r%2==1?s.push(r):n.push(r);r.push(...n),r.push(0),r.push(...s)}return r},getReshapedPermuted:function(e,t,n,r=!0){const s=[];r?s.push(e[0]/n):s.push(e[0]*n);for(let n=1;n<e.length;++n)n<=t.length?r?s.push(t[n-1]*e[n]):s.push(e[n]/t[n-1]):s.push(e[n]);return s},getSliceBeginCoords:function(e,t){const n=[0];for(let r=0;r<t;++r)n.push(e[r][0]);return n},getSliceSize:function(e,t,n){const r=e.slice(0,1);for(let s=0;s<n;++s)r.push(e[s+1]-t[s][0]-t[s][1]);return r},prepareAndValidate:xh,validateUpdateShape:cu,validateInput:hu,calculateShapes:du,SELU_SCALEALPHA:1.7580993408473768,SELU_SCALE:1.0507009873554805,ERF_P:.3275911,ERF_A1:.254829592,ERF_A2:-.284496736,ERF_A3:1.421413741,ERF_A4:-1.453152027,ERF_A5:1.061405429,warn:vn,log:function(...e){O().getBool("IS_TEST")||O().getBool("PROD")||console.log(...e)},mergeRealAndImagArrays:function(e,t){if(e.length!==t.length)throw new Error(`Cannot merge real and imag arrays of different lengths. real:${e.length}, imag: ${t.length}.`);const n=new Float32Array(2*e.length);for(let r=0;r<n.length;r+=2)n[r]=e[r/2],n[r+1]=t[r/2];return n},splitRealAndImagArrays:function(e){const t=new Float32Array(e.length/2),n=new Float32Array(e.length/2);for(let r=0;r<e.length;r+=2)t[r/2]=e[r],n[r/2]=e[r+1];return{real:t,imag:n}},complexWithEvenIndex:function(e){const t=Math.ceil(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=0;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},complexWithOddIndex:function(e){const t=Math.floor(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=2;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},getComplexWithIndex:function(e,t){return{real:e[2*t],imag:e[2*t+1]}},assignToTypedArray:function(e,t,n,r){e[2*r]=t,e[2*r+1]=n},exponents:function(e,t){const n=new Float32Array(e/2),r=new Float32Array(e/2);for(let s=0;s<Math.ceil(e/2);s++){const o=(t?2:-2)*Math.PI*(s/e);n[s]=Math.cos(o),r[s]=Math.sin(o)}return{real:n,imag:r}},exponent:function(e,t,n){const r=(n?2:-2)*Math.PI*(e/t);return{real:Math.cos(r),imag:Math.sin(r)}},decodeEinsumEquation:function(e,t){const n=((e=e.replace(/\s/g,"")).length-e.replace(Lh,"").length)/Oh.length;if(n<1)throw new Error("Equations without an arrow are not supported.");if(n>1)throw new Error('Equation must contain exactly one arrow ("->").');const[r,s]=e.split(Oh);i(-1===r.indexOf("..."),(()=>'The ellipsis notation ("...") is not supported yet.'));const o=r.split(","),a=o.length;if(t!==a)throw new Error(`Expected ${a} input tensors, received ${t}`);if(a>2)throw new Error("Support for more than 2 input tensors is not implemented yet.");const l=[];for(let e=0;e<s.length;++e){const t=s[e];if(!o.some((e=>-1!==e.indexOf(t))))throw new Error(`Output subscripts contain the label ${t} not present in the input subscripts.`);-1===l.indexOf(t)&&l.push(t)}for(let e=0;e<r.length;++e){const t=r[e];-1===l.indexOf(t)&&","!==t&&l.push(t)}const u=new Array(o.length);for(let e=0;e<a;++e){if(new Set(o[e].split("")).size!==o[e].length)throw new Error(`Found duplicate axes in input component ${o[e]}. Support for duplicate axes in input is not implemented yet.`);u[e]=[];for(let t=0;t<o[e].length;++t)u[e].push(l.indexOf(o[e][t]))}const c=l.length,h=[];for(let e=s.length;e<c;++e)h.push(e);return{allDims:l,summedDims:h,idDims:u}},getEinsumPermutation:function(e,t){let n=new Array(e);n.fill(-1);for(let e=0;e<t.length;++e)n[t[e]]=e;const r=[];for(let t=0;t<e;++t)-1===n[t]&&r.push(t);return n=n.filter((e=>-1!==e)),{permutationIndices:n,expandDims:r}},checkEinsumDimSizes:function(e,t,n){const r=new Array(e);for(let e=0;e<n.length;++e){const s=n[e].shape;for(let n=0;n<t[e].length;++n)void 0===r[t[e][n]]?r[t[e][n]]=s[n]:i(r[t[e][n]]===s[n],(()=>`Expected dimension ${r[t[e][n]]} at axis ${n} of input shaped ${JSON.stringify(s)}, but got dimension ${s[n]}`))}},getEinsumComputePath:function(e,t){const n=e,r=[];let s=0;0===e.length&&n.push(-1),s=e.length+1;for(let e=0;e<s;++e)r.push([]);const o=[];for(let e=0;e<n.length;++e){const s=zh(t,n[e]);for(const t of s)-1===o.indexOf(t)&&(r[e].push(t),o.push(t))}return{path:n,steps:r}},isIdentityPermutation:function(e){return e.every(((e,t)=>e===t))},prepareSplitSize:function(e,t,n=0){let r=[];if("number"==typeof t)i(e.shape[n]%t==0,(()=>"Number of splits must evenly divide the axis.")),r=new Array(t).fill(e.shape[n]/t);else{i(t.reduce(((e,t)=>(-1===t&&(e+=1),e)),0)<=1,(()=>"There should be only one negative value in split array."));const s=t.indexOf(-1);if(-1!==s){const r=t.reduce(((e,t)=>t>0?e+t:e));t[s]=e.shape[n]-r}i(e.shape[n]===t.reduce(((e,t)=>e+t)),(()=>"The sum of sizes must match the size of the axis dimension.")),r=t}return r},getSparseFillEmptyRowsIndicesDenseShapeMismatch:function(e){return`Received SparseTensor with denseShape[0] = 0 but\n  indices.shape[0] = ${e}`},getSparseFillEmptyRowsNegativeIndexErrorMessage:function(e,t){return`indices(${e}, 0) is invalid: ${t} < 0`},getSparseFillEmptyRowsOutOfRangeIndexErrorMessage:function(e,t,n){return`indices(${e}, 0) is invalid: ${t} >= ${n}`},getSparseReshapeMultipleNegativeOneOutputDimErrorMessage:function(e,t){return`only one output dimension may be -1, not both ${e} and ${t}`},getSparseReshapeNegativeOutputDimErrorMessage:function(e,t){return`size ${e} must be non-negative, not ${t}`},getSparseReshapeEmptyTensorZeroOutputDimErrorMessage:function(){return"reshape cannot infer the missing input size for an empty tensor unless all specified input sizes are non-zero"},getSparseReshapeInputOutputMultipleErrorMessage:function(e,t){return`Input to reshape is a SparseTensor with ${c(e)}\n  dense values, but the requested shape requires a multiple of ${c(t)}. inputShape=${e} outputShape= ${t}`},getSparseReshapeInputOutputMismatchErrorMessage:function(e,t){return`Input to reshape is a tensor with ${c(e)} dense values, but the requested shape has ${c(t)}. inputShape=${e} outputShape=${t}`},getSparseSegmentReductionNegativeSegmentIdsErrorMessage:function(){return"segment ids must be >= 0"},getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage:function(){return"segment ids are not increasing"},getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage:function(e,t){return`Segment id ${e} out of range [0, ${t}), possibly because segmentIds input is not sorted.`},getSparseSegmentReductionIndicesOutOfRangeErrorMessage:function(e,t,n){return`Bad: indices[${e}] == ${t} out of range [0, ${n})`}},Uh={__proto__:null,nonMaxSuppressionV3Impl:tc,nonMaxSuppressionV4Impl:nc,nonMaxSuppressionV5Impl:rc,whereImpl:ku};!function(){for(const e of th)qc(e)}(),e.Abs="Abs",e.Acos=U,e.Acosh=G,e.AdadeltaOptimizer=jc,e.AdagradOptimizer=Zc,e.AdamOptimizer=Jc,e.AdamaxOptimizer=Yc,e.Add=K,e.AddN=q,e.All="All",e.Any="Any",e.ArgMax=V,e.ArgMin=H,e.Asin=j,e.Asinh=Z,e.Atan=J,e.Atan2=X,e.Atanh=Y,e.AvgPool=Q,e.AvgPool3D=ee,e.AvgPool3DGrad="AvgPool3DGrad",e.AvgPoolGrad="AvgPoolGrad",e.BatchMatMul=te,e.BatchToSpaceND=ne,e.Bincount=re,e.BroadcastArgs=se,e.BroadcastTo="BroadcastTo",e.Cast=oe,e.Ceil=ae,e.ClipByValue=ie,e.Complex=le,e.ComplexAbs=ue,e.Concat=ce,e.Conv2D=he,e.Conv2DBackpropFilter=de,e.Conv2DBackpropInput=pe,e.Conv3D=fe,e.Conv3DBackpropFilterV2="Conv3DBackpropFilterV2",e.Conv3DBackpropInputV2=ge,e.Cos="Cos",e.Cosh=me,e.CropAndResize=we,e.Cumprod=be,e.Cumsum=ye,e.DataStorage=class{constructor(e,t){this.backend=e,this.dataMover=t,this.data=new WeakMap,this.dataIdsCount=0}get(e){return this.data.has(e)||this.dataMover.moveData(this.backend,e),this.data.get(e)}set(e,t){this.dataIdsCount++,this.data.set(e,t)}has(e){return this.data.has(e)}delete(e){return this.dataIdsCount--,this.data.delete(e)}numDataIds(){return this.dataIdsCount}},e.DenseBincount=ke,e.DepthToSpace=ve,e.DepthwiseConv2dNative=xe,e.DepthwiseConv2dNativeBackpropFilter=Ee,e.DepthwiseConv2dNativeBackpropInput=Se,e.Diag=$e,e.Dilation2D=Ae,e.Dilation2DBackpropFilter="Dilation2DBackpropFilter",e.Dilation2DBackpropInput="Dilation2DBackpropInput",e.Einsum=Ie,e.Elu="Elu",e.EluGrad="EluGrad",e.Environment=C,e.Equal=Ne,e.Erf="Erf",e.Exp="Exp",e.ExpandDims=Me,e.Expm1=Te,e.FFT="FFT",e.Fill=De,e.FlipLeftRight=Re,e.Floor=Fe,e.FloorDiv=Be,e.FromPixels=mn,e.FusedBatchNorm=Ce,e.FusedConv2D=wn,e.FusedDepthwiseConv2D=kn,e.GatherNd=Oe,e.GatherV2=Pe,e.Greater=Le,e.GreaterEqual=ze,e.IFFT=Ue,e.Identity=We,e.Imag=Ge,e.IsFinite=Ke,e.IsInf=qe,e.IsNan=Ve,e.KernelBackend=n,e.LRN="LRN",e.LRNGrad="LRNGrad",e.LeakyRelu=He,e.Less=je,e.LessEqual=Ze,e.LinSpace=Je,e.Log="Log",e.Log1p=Ye,e.LogSoftmax="LogSoftmax",e.LogicalAnd=Xe,e.LogicalNot=Qe,e.LogicalOr=et,e.LogicalXor="LogicalXor",e.LowerBound="LowerBound",e.MatrixBandPart="MatrixBandPart",e.Max="Max",e.MaxPool=nt,e.MaxPool3D=rt,e.MaxPool3DGrad="MaxPool3DGrad",e.MaxPoolGrad="MaxPoolGrad",e.MaxPoolWithArgmax=st,e.Maximum=tt,e.Mean=ot,e.Min="Min",e.Minimum=at,e.MirrorPad=it,e.Mod="Mod",e.MomentumOptimizer=Qc,e.Multinomial=lt,e.Multiply=ut,e.Neg="Neg",e.NonMaxSuppressionV3=ht,e.NonMaxSuppressionV4=dt,e.NonMaxSuppressionV5=pt,e.NotEqual=ct,e.OP_SCOPE_SUFFIX=is,e.OneHot=gt,e.OnesLike=ft,e.Optimizer=Hc,e.OptimizerConstructors=Fh,e.Pack=mt,e.PadV2=bt,e.Pool="Pool",e.Pow="Pow",e.Prelu=yt,e.Prod=wt,e.RMSPropOptimizer=eh,e.RaggedGather=kt,e.RaggedRange=vt,e.RaggedTensorToTensor=xt,e.Range=Et,e.Real=St,e.RealDiv=_e,e.Reciprocal=$t,e.Relu=At,e.Relu6=Mt,e.Reshape=_t,e.ResizeBilinear=Nt,e.ResizeBilinearGrad="ResizeBilinearGrad",e.ResizeNearestNeighbor=It,e.ResizeNearestNeighborGrad="ResizeNearestNeighborGrad",e.Reverse=Tt,e.RotateWithOffset=bn,e.Round=Dt,e.Rsqrt=Rt,e.SGDOptimizer=Xc,e.ScatterNd=Ft,e.SearchSorted=Ct,e.Select=Pt,e.Selu=Ot,e.Sigmoid=Ut,e.Sign=Wt,e.Sin="Sin",e.Sinh=zt,e.Slice=Lt,e.Softmax=Ht,e.Softplus=Gt,e.SpaceToBatchND=qt,e.SparseFillEmptyRows=jt,e.SparseReshape=Zt,e.SparseSegmentMean=Jt,e.SparseSegmentSum=Yt,e.SparseToDense=Xt,e.SplitV=Vt,e.Sqrt=Kt,e.Square="Square",e.SquaredDifference=Qt,e.StaticRegexReplace=en,e.Step=gn,e.StridedSlice=tn,e.StringNGrams=nn,e.StringSplit=rn,e.StringToHashBucketFast=sn,e.Sub="Sub",e.Sum="Sum",e.Tan="Tan",e.Tanh=on,e.Tensor=Mr,e.TensorBuffer=_r,e.TensorScatterUpdate=Bt,e.Tile=an,e.TopK=ln,e.Transform=un,e.Transpose=cn,e.Unique=hn,e.Unpack=dn,e.UnsortedSegmentSum=pn,e.UpperBound="UpperBound",e.Variable=Tr,e.ZerosLike=fn,e._FusedMatMul=yn,e.abs=po,e.acos=fo,e.acosh=go,e.add=lo,e.addN=mo,e.all=bo,e.any=yo,e.argMax=wo,e.argMin=ko,e.asin=vo,e.asinh=xo,e.atan=Eo,e.atan2=So,e.atanh=$o,e.avgPool=zo,e.avgPool3d=Wo,e.backend=function(){return Jr.backend},e.backend_util=Wh,e.basicLSTMCell=Ho,e.batchNorm=Zo,e.batchNorm2d=Jo,e.batchNorm3d=Yo,e.batchNorm4d=Xo,e.batchToSpaceND=jo,e.bincount=Qo,e.booleanMaskAsync=xu,e.broadcastArgs=ea,e.broadcastTo=ta,e.broadcast_util=Ia,e.browser=vh,e.buffer=to,e.cast=no,e.ceil=na,e.clipByValue=sa,e.clone=ro,e.complex=us,e.concat=Uo,e.concat1d=oa,e.concat2d=aa,e.concat3d=ia,e.concat4d=la,e.conv1d=ca,e.conv2d=ua,e.conv2dTranspose=da,e.conv3d=pa,e.conv3dTranspose=ga,e.copyRegisteredKernels=function(e,t){An(e).forEach((e=>{_n(Object.assign({},e,{backendName:t}))}))},e.cos=ma,e.cosh=ba,e.cosineWindow=Mu,e.cumprod=ya,e.cumsum=wa,e.customGrad=mi,e.denseBincount=ka,e.deprecationWarn=function(e){O().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(e+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")},e.depthToSpace=va,e.depthwiseConv2d=xa,e.device_util=es,e.diag=Ea,e.dilation2d=Sa,e.disableDeprecationWarnings=function(){O().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")},e.dispose=ao,e.disposeVariables=function(){Jr.disposeVariables()},e.div=co,e.divNoNan=Da,e.dot=Ra,e.dropout=Iu,e.einsum=Fa,e.elu=Ba,e.enableDebugMode=function(){O().set("DEBUG",!0)},e.enableProdMode=function(){O().set("PROD",!0)},e.enclosingPowerOfTwo=Nu,e.engine=function(){return Jr},e.env=O,e.equal=Na,e.erf=Ca,e.euclideanNorm=Za,e.exp=Ja,e.expandDims=Ya,e.expm1=Xa,e.eye=ei,e.fft=Jl,e.fill=ra,e.findBackend=function(e){return Jr.findBackend(e)},e.findBackendFactory=function(e){return Jr.findBackendFactory(e)},e.floor=ti,e.floorDiv=uo,e.fused=Uu,e.gather=ni,e.gatherND=_u,e.gather_util=Eh,e.getBackend=function(){return Jr.backendName},e.getGradient=$n,e.getKernel=Sn,e.getKernelsForBackend=An,e.grad=function(e){return i(A(e),(()=>"The f passed in grad(f) must be a function")),(t,n)=>{const r=os(t,"x","tf.grad","string_or_numeric"),s=null!=n?os(n,"dy","tf.grad"):null;return Jr.tidy((()=>{const{value:t,grads:n}=Jr.gradients((()=>e(r)),[r],s);return null!=s&&l(t.shape,s.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),bi(n),n[0]}))}},e.grads=function(e){return i(A(e),(()=>"The f passed in grads(f) must be a function")),(t,n)=>{i(Array.isArray(t),(()=>"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s"));const r=as(t,"args","tf.grads","string_or_numeric"),s=null!=n?os(n,"dy","tf.grads"):null;return Jr.tidy((()=>{const{value:t,grads:n}=Jr.gradients((()=>e(...r)),r,s);return null!=s&&l(t.shape,s.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),bi(n),n}))}},e.greater=ri,e.greaterEqual=si,e.ifft=Yl,e.imag=oi,e.image=Oc,e.inTopKAsync=Tu,e.io=mh,e.irfft=Xl,e.isFinite=ai,e.isInf=ii,e.isNaN=li,e.keep=io,e.kernel_impls=Uh,e.leakyRelu=ui,e.less=ci,e.lessEqual=hi,e.linalg=Lc,e.linspace=function(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");const r={start:e,stop:t,num:n};return Jr.runKernel(Je,{},r)},e.localResponseNormalization=di,e.log=pi,e.log1p=fi,e.logSigmoid=ki,e.logSoftmax=xi,e.logSumExp=Ei,e.logicalAnd=Si,e.logicalNot=$i,e.logicalOr=Ai,e.logicalXor=_i,e.losses=zc,e.lowerBound=function(e,t){return Ni(e,t,"left")},e.matMul=Go,e.math=bh,e.max=za,e.maxPool=Mi,e.maxPool3d=Ti,e.maxPoolWithArgmax=Di,e.maximum=Ri,e.mean=Fi,e.memory=function(){return Jr.memory()},e.meshgrid=function(e,t,{indexing:n="xy"}={}){if("xy"!==n&&"ij"!==n)throw new TypeError(`${n} is not a valid third argument to meshgrid`);if(void 0===e)return[];let r=os(e,"x","meshgrid",e instanceof Mr?e.dtype:"float32");if(void 0===t)return[r];let s=os(t,"y","meshgrid",t instanceof Mr?t.dtype:"float32");const o=c(r.shape),a=c(s.shape);return"xy"===n?(r=Lo(r,[1,-1]),s=Lo(s,[-1,1]),[Go(Ci([a,1],r.dtype),r),Go(s,Ci([1,o],s.dtype))]):(r=Lo(r,[-1,1]),s=Lo(s,[1,-1]),[Go(r,Ci([1,a],r.dtype)),Go(Ci([o,1],s.dtype),s)])},e.min=Wa,e.minimum=Pi,e.mirrorPad=Oi,e.mod=Li,e.moments=zi,e.movingAverage=Su,e.mul=ho,e.multiRNNCell=Wi,e.multinomial=Ui,e.neg=yi,e.nextFrame=function(){return new Promise((e=>Ch((()=>e()))))},e.norm=ja,e.notEqual=Gi,e.oneHot=Ki,e.ones=Ci,e.onesLike=qi,e.op=ls,e.outerProduct=Vi,e.pad=Hi,e.pad1d=ji,e.pad2d=Zi,e.pad3d=Ji,e.pad4d=Yi,e.pool=Qi,e.pow=Ua,e.prelu=el,e.print=so,e.prod=tl,e.profile=function(e){return Jr.profile(e)},e.raggedGather=nl,e.raggedRange=rl,e.raggedTensorToTensor=sl,e.rand=ol,e.randomGamma=El,e.randomNormal=Sl,e.randomStandardNormal=$l,e.randomUniform=Al,e.range=_l,e.ready=function(){return Jr.ready()},e.real=Il,e.reciprocal=Nl,e.registerBackend=function(e,t,n=1){return Jr.registerBackend(e,t,n)},e.registerGradient=function(e){const{kernelName:t}=e;En.has(t)&&O().getBool("DEBUG")&&vn(`Overriding the gradient for '${t}'`),En.set(t,e)},e.registerKernel=_n,e.relu=Ml,e.relu6=Tl,e.removeBackend=function(e){Jr.removeBackend(e)},e.reshape=Lo,e.reverse=Dl,e.reverse1d=Rl,e.reverse2d=Fl,e.reverse3d=Bl,e.reverse4d=Cl,e.rfft=eu,e.round=Pl,e.rsqrt=Ol,e.scalar=Ga,e.scatterND=$u,e.scatter_util=pu,e.searchSorted=Ni,e.selu=Ll,e.separableConv2d=zl,e.serialization=Vc,e.setBackend=function(e){return Jr.setBackend(e)},e.setPlatform=function(e,t){O().setPlatform(e,t)},e.setdiff1dAsync=Wl,e.sigmoid=Ko,e.sign=Ul,e.signal=Pc,e.sin=Gl,e.sinh=Kl,e.slice=qo,e.slice1d=ql,e.slice2d=Vl,e.slice3d=Hl,e.slice4d=jl,e.slice_util=Rh,e.softmax=Zl,e.softplus=wi,e.spaceToBatchND=Xi,e.sparse=Wc,e.sparseToDense=Au,e.spectral=Cc,e.split=Ql,e.sqrt=Ka,e.square=qa,e.squaredDifference=tu,e.squeeze=nu,e.stack=ru,e.step=su,e.stridedSlice=ou,e.string=Uc,e.sub=vi,e.sum=Va,e.sumOutType=function(e){return Or(e,"int32")},e.tan=au,e.tanh=Vo,e.tensor=hs,e.tensor1d=iu,e.tensor2d=lu,e.tensor3d=uu,e.tensor4d=function(e,t,n){if(u(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");const r=ns(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return cs(e,t,r,n)},e.tensor5d=function(e,t,n){if(u(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");const r=ns(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return cs(e,t,r,n)},e.tensor6d=function(e,t,n){if(u(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");const r=ns(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return cs(e,t=t||r,r,n)},e.tensorScatterUpdate=fu,e.tensor_util=qr,e.test_util=wl,e.tidy=oo,e.tile=Qa,e.time=function(e){return Jr.time(e)},e.topk=gu,e.train=Bh,e.transpose=Eu,e.truncatedNormal=mu,e.unique=bu,e.unregisterGradient=function(e){if(!En.has(e))throw new Error(`The gradient '${e}' for backend is not registered`);En.delete(e)},e.unregisterKernel=function(e,t){const n=In(e,t);if(!xn.has(n))throw new Error(`The kernel '${e}' for backend '${t}' is not registered`);xn.delete(n)},e.unsortedSegmentSum=yu,e.unstack=wu,e.upcastType=Or,e.upperBound=function(e,t){return Ni(e,t,"right")},e.util=yr,e.valueAndGrad=function(e){return i(A(e),(()=>"The f passed in valueAndGrad(f) must be a function")),(t,n)=>{i(t instanceof Mr,(()=>"The x passed in valueAndGrad(f)(x) must be a tensor")),i(null==n||n instanceof Mr,(()=>"The dy passed in valueAndGrad(f)(x, dy) must be a tensor"));const{grads:r,value:s}=Jr.gradients((()=>e(t)),[t],n);return bi(r),{grad:r[0],value:s}}},e.valueAndGrads=function(e){return i(A(e),(()=>"The f passed in valueAndGrads(f) must be a function")),(t,n)=>{i(Array.isArray(t)&&t.every((e=>e instanceof Mr)),(()=>"The args passed in valueAndGrads(f)(args) must be array of tensors")),i(null==n||n instanceof Mr,(()=>"The dy passed in valueAndGrads(f)(args, dy) must be a tensor"));const r=Jr.gradients((()=>e(...t)),t,n);return null!=n&&l(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),bi(r.grads),r}},e.variable=function(e,t=!0,n,r){return Jr.makeVariable(e,t,n,r)},e.variableGrads=gi,e.version_core="4.3.0",e.where=Ma,e.whereAsync=vu,e.zeros=Bi,e.zerosLike=Ta,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-core.es2017.min.js.map
